/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],ue=function(Q){for(var e=[],S=0,P=Q.length;S<P;S++)e[S]=le[Q[S]];return e};define(le[74],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var S;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(S||(e.LoaderEventType=S={}));class P{static get(){const k=new Map,L=new Map,R=new Map,w=new Map;function a(p,I){p.has(I.detail)||p.set(I.detail,-I.timestamp)}function f(p,I){const b=p.get(I.detail);b&&(b>=0||p.set(I.detail,b+I.timestamp))}let c=[];typeof Q=="function"&&typeof Q.getStats=="function"&&(c=Q.getStats().slice(0).sort((p,I)=>p.timestamp-I.timestamp));for(const p of c)switch(p.type){case S.BeginLoadingScript:a(k,p);break;case S.EndLoadingScriptOK:case S.EndLoadingScriptError:f(k,p);break;case S.BeginInvokeFactory:a(L,p);break;case S.EndInvokeFactory:f(L,p);break;case S.NodeBeginNativeRequire:a(R,p);break;case S.NodeEndNativeRequire:f(R,p);break;case S.NodeBeginEvaluatingScript:a(w,p);break;case S.NodeEndEvaluatingScript:f(w,p);break}let m=0;R.forEach(p=>m+=p);function d(p){const I=[];return p.forEach((b,h)=>I.push([h,b])),I}return{amdLoad:d(k),amdInvoke:d(L),nodeRequire:d(R),nodeEval:d(w),nodeRequireTotal:m}}static toMarkdownTable(k,L){let R="";const w=[];return k.forEach((a,f)=>{w[f]=a.length}),L.forEach(a=>{a.forEach((f,c)=>{typeof f>"u"&&(f=a[c]="-");const m=f.toString().length;w[c]=Math.max(m,w[c])})}),k.forEach((a,f)=>{R+=`| ${a+" ".repeat(w[f]-a.toString().length)} `}),R+=`|
`,k.forEach((a,f)=>{R+=`| ${"-".repeat(w[f])} `}),R+=`|
`,L.forEach(a=>{a.forEach((f,c)=>{typeof f<"u"&&(R+=`| ${f+" ".repeat(w[c]-f.toString().length)} `)}),R+=`|
`}),R}}e.$S=P}),define(le[55],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=P,e.$9h=v,e.$0h=k;function S(L){return(R,w,a)=>{let f=null,c=null;if(typeof a.value=="function"?(f="value",c=a.value):typeof a.get=="function"&&(f="get",c=a.get),!c)throw new Error("not supported");a[f]=L(c,w)}}function P(L,R,w){let a=null,f=null;if(typeof w.value=="function"?(a="value",f=w.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(a="get",f=w.get),!f)throw new Error("not supported");const c=`$memoize$${R}`;w[a]=function(...m){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,m)}),this[c]}}function v(L,R,w){return S((a,f)=>{const c=`$debounce$${f}`,m=`$debounce$result$${f}`;return function(...d){this[m]||(this[m]=w?w():void 0),clearTimeout(this[c]),R&&(this[m]=R(this[m],...d),d=[this[m]]),this[c]=setTimeout(()=>{a.apply(this,d),this[m]=w?w():void 0},L)}})}function k(L,R,w){return S((a,f)=>{const c=`$throttle$timer$${f}`,m=`$throttle$result$${f}`,d=`$throttle$lastRun$${f}`,p=`$throttle$pending$${f}`;return function(...I){if(this[m]||(this[m]=w?w():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...I)),this[p])return;const b=this[d]+L;b<=Date.now()?(this[d]=Date.now(),a.apply(this,[this[m]]),this[m]=w?w():void 0):(this[p]=!0,this[c]=setTimeout(()=>{this[p]=!1,this[d]=Date.now(),a.apply(this,[this[m]]),this[m]=w?w():void 0},b-Date.now()))}})}}),define(le[75],ue([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=P,e.$dd=v,e.$ed=k,e.$fd=L,e.$gd=R,e.$hd=w;function P(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function v(a,f="Unreachable"){throw new Error(f)}function k(a,f="unexpected state"){if(!a)throw new S.$bb(`Assertion Failed: ${f}`)}function L(a){a||(0,S.$Y)(new S.$bb("Soft Assertion Failed"))}function R(a){if(!a()){debugger;a(),(0,S.$Y)(new S.$bb("Assertion Failed"))}}function w(a,f){let c=0;for(;c<a.length-1;){const m=a[c],d=a[c+1];if(!f(m,d))return!1;c++}return!0}}),define(le[34],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Un=L,e.$Vn=c,e.$Wn=m,e.$Xn=d,e.$Yn=p,e.$Zn=I,e.$1n=b,e.$2n=h,e.$3n=g,e.$4n=O,e.$5n=y;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v||(e.ParseErrorCode=v={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function L(i,l=!1){let n=0;const s=i.length;let t="",r=0,o=P.Unknown,u=S.None;function $(Z){let ee=0,oe=0;for(;ee<Z;){const ce=i.charCodeAt(n);if(ce>=f._0&&ce<=f._9)oe=oe*16+ce-f._0;else if(ce>=f.A&&ce<=f.F)oe=oe*16+ce-f.A+10;else if(ce>=f.a&&ce<=f.f)oe=oe*16+ce-f.a+10;else break;n++,ee++}return ee<Z&&(oe=-1),oe}function D(Z){n=Z,t="",r=0,o=P.Unknown,u=S.None}function T(){const Z=n;if(i.charCodeAt(n)===f._0)n++;else for(n++;n<i.length&&a(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===f.dot)if(n++,n<i.length&&a(i.charCodeAt(n)))for(n++;n<i.length&&a(i.charCodeAt(n));)n++;else return u=S.UnexpectedEndOfNumber,i.substring(Z,n);let ee=n;if(n<i.length&&(i.charCodeAt(n)===f.E||i.charCodeAt(n)===f.e))if(n++,(n<i.length&&i.charCodeAt(n)===f.plus||i.charCodeAt(n)===f.minus)&&n++,n<i.length&&a(i.charCodeAt(n))){for(n++;n<i.length&&a(i.charCodeAt(n));)n++;ee=n}else u=S.UnexpectedEndOfNumber;return i.substring(Z,ee)}function A(){let Z="",ee=n;for(;;){if(n>=s){Z+=i.substring(ee,n),u=S.UnexpectedEndOfString;break}const oe=i.charCodeAt(n);if(oe===f.doubleQuote){Z+=i.substring(ee,n),n++;break}if(oe===f.backslash){if(Z+=i.substring(ee,n),n++,n>=s){u=S.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case f.doubleQuote:Z+='"';break;case f.backslash:Z+="\\";break;case f.slash:Z+="/";break;case f.b:Z+="\b";break;case f.f:Z+="\f";break;case f.n:Z+=`
`;break;case f.r:Z+="\r";break;case f.t:Z+="	";break;case f.u:{const fe=$(4);fe>=0?Z+=String.fromCharCode(fe):u=S.InvalidUnicode;break}default:u=S.InvalidEscapeCharacter}ee=n;continue}if(oe>=0&&oe<=31)if(w(oe)){Z+=i.substring(ee,n),u=S.UnexpectedEndOfString;break}else u=S.InvalidCharacter;n++}return Z}function N(){if(t="",u=S.None,r=n,n>=s)return r=s,o=P.EOF;let Z=i.charCodeAt(n);if(R(Z)){do n++,t+=String.fromCharCode(Z),Z=i.charCodeAt(n);while(R(Z));return o=P.Trivia}if(w(Z))return n++,t+=String.fromCharCode(Z),Z===f.carriageReturn&&i.charCodeAt(n)===f.lineFeed&&(n++,t+=`
`),o=P.LineBreakTrivia;switch(Z){case f.openBrace:return n++,o=P.OpenBraceToken;case f.closeBrace:return n++,o=P.CloseBraceToken;case f.openBracket:return n++,o=P.OpenBracketToken;case f.closeBracket:return n++,o=P.CloseBracketToken;case f.colon:return n++,o=P.ColonToken;case f.comma:return n++,o=P.CommaToken;case f.doubleQuote:return n++,t=A(),o=P.StringLiteral;case f.slash:{const ee=n-1;if(i.charCodeAt(n+1)===f.slash){for(n+=2;n<s&&!w(i.charCodeAt(n));)n++;return t=i.substring(ee,n),o=P.LineCommentTrivia}if(i.charCodeAt(n+1)===f.asterisk){n+=2;const oe=s-1;let ce=!1;for(;n<oe;){if(i.charCodeAt(n)===f.asterisk&&i.charCodeAt(n+1)===f.slash){n+=2,ce=!0;break}n++}return ce||(n++,u=S.UnexpectedEndOfComment),t=i.substring(ee,n),o=P.BlockCommentTrivia}return t+=String.fromCharCode(Z),n++,o=P.Unknown}case f.minus:if(t+=String.fromCharCode(Z),n++,n===s||!a(i.charCodeAt(n)))return o=P.Unknown;case f._0:case f._1:case f._2:case f._3:case f._4:case f._5:case f._6:case f._7:case f._8:case f._9:return t+=T(),o=P.NumericLiteral;default:for(;n<s&&M(Z);)n++,Z=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return o=P.TrueKeyword;case"false":return o=P.FalseKeyword;case"null":return o=P.NullKeyword}return o=P.Unknown}return t+=String.fromCharCode(Z),n++,o=P.Unknown}}function M(Z){if(R(Z)||w(Z))return!1;switch(Z){case f.closeBrace:case f.closeBracket:case f.openBrace:case f.openBracket:case f.doubleQuote:case f.colon:case f.comma:case f.slash:return!1}return!0}function G(){let Z;do Z=N();while(Z>=P.LineCommentTrivia&&Z<=P.Trivia);return Z}return{setPosition:D,getPosition:()=>n,scan:l?G:N,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>u}}function R(i){return i===f.space||i===f.tab||i===f.verticalTab||i===f.formFeed||i===f.nonBreakingSpace||i===f.ogham||i>=f.enQuad&&i<=f.zeroWidthSpace||i===f.narrowNoBreakSpace||i===f.mathematicalSpace||i===f.ideographicSpace||i===f.byteOrderMark}function w(i){return i===f.lineFeed||i===f.carriageReturn||i===f.lineSeparator||i===f.paragraphSeparator}function a(i){return i>=f._0&&i<=f._9}var f;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(f||(f={}));function c(i,l){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u($,D,T,A){r.value=$,r.offset=D,r.length=T,r.type=A,r.colonOffset=void 0,t=r}try{O(i,{onObjectBegin:($,D)=>{if(l<=$)throw s;t=void 0,o=l>$,n.push("")},onObjectProperty:($,D,T)=>{if(l<D||(u($,D,T,"property"),n[n.length-1]=$,l<=D+T))throw s},onObjectEnd:($,D)=>{if(l<=$)throw s;t=void 0,n.pop()},onArrayBegin:($,D)=>{if(l<=$)throw s;t=void 0,n.push(0)},onArrayEnd:($,D)=>{if(l<=$)throw s;t=void 0,n.pop()},onLiteralValue:($,D,T)=>{if(l<D||(u($,D,T,y($)),l<=D+T))throw s},onSeparator:($,D,T)=>{if(l<=D)throw s;if($===":"&&t&&t.type==="property")t.colonOffset=D,o=!1,t=void 0;else if($===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch($){if($!==s)throw $}return{path:n,previousNode:t,isAtPropertyKey:o,matches:$=>{let D=0;for(let T=0;D<$.length&&T<n.length;T++)if($[D]===n[T]||$[D]==="*")D++;else if($[D]!=="**")return!1;return D===$.length}}}function m(i,l=[],n=k.DEFAULT){let s=null,t=[];const r=[];function o($){Array.isArray(t)?t.push($):s!==null&&(t[s]=$)}return O(i,{onObjectBegin:()=>{const $={};o($),r.push(t),t=$,s=null},onObjectProperty:$=>{s=$},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const $=[];o($),r.push(t),t=$,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:($,D,T)=>{l.push({error:$,offset:D,length:T})}},n),t[0]}function d(i,l=[],n=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t($){s.type==="property"&&(s.length=$-s.offset,s=s.parent)}function r($){return s.children.push($),$}O(i,{onObjectBegin:$=>{s=r({type:"object",offset:$,length:-1,parent:s,children:[]})},onObjectProperty:($,D,T)=>{s=r({type:"property",offset:D,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:$,offset:D,length:T,parent:s})},onObjectEnd:($,D)=>{s.length=$+D-s.offset,s=s.parent,t($+D)},onArrayBegin:($,D)=>{s=r({type:"array",offset:$,length:-1,parent:s,children:[]})},onArrayEnd:($,D)=>{s.length=$+D-s.offset,s=s.parent,t($+D)},onLiteralValue:($,D,T)=>{r({type:y($),offset:D,length:T,parent:s,value:$}),t(D+T)},onSeparator:($,D,T)=>{s.type==="property"&&($===":"?s.colonOffset=D:$===","&&t(D))},onError:($,D,T)=>{l.push({error:$,offset:D,length:T})}},n);const u=s.children[0];return u&&delete u.parent,u}function p(i,l){if(!i)return;let n=i;for(const s of l)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function I(i){if(!i.parent||!i.parent.children)return[];const l=I(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;l.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&l.push(n)}return l}function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const l=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(l[n.children[0].value]=b(s))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function h(i,l,n=!1){return l>=i.offset&&l<i.offset+i.length||n&&l===i.offset+i.length}function g(i,l,n=!1){if(h(i,l,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=l;t++){const r=g(s[t],l,n);if(r)return r}return i}}function O(i,l,n=k.DEFAULT){const s=L(i,!1);function t(X){return X?()=>X(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(X){return X?te=>X(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=t(l.onObjectBegin),u=r(l.onObjectProperty),$=t(l.onObjectEnd),D=t(l.onArrayBegin),T=t(l.onArrayEnd),A=r(l.onLiteralValue),N=r(l.onSeparator),M=t(l.onComment),G=r(l.onError),Z=n&&n.disallowComments,ee=n&&n.allowTrailingComma;function oe(){for(;;){const X=s.scan();switch(s.getTokenError()){case S.InvalidUnicode:ce(v.InvalidUnicode);break;case S.InvalidEscapeCharacter:ce(v.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:ce(v.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:Z||ce(v.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:ce(v.UnexpectedEndOfString);break;case S.InvalidCharacter:ce(v.InvalidCharacter);break}switch(X){case P.LineCommentTrivia:case P.BlockCommentTrivia:Z?ce(v.InvalidCommentToken):M();break;case P.Unknown:ce(v.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return X}}}function ce(X,te=[],ne=[]){if(G(X),te.length+ne.length>0){let F=s.getToken();for(;F!==P.EOF;){if(te.indexOf(F)!==-1){oe();break}else if(ne.indexOf(F)!==-1)break;F=oe()}}}function fe(X){const te=s.getTokenValue();return X?A(te):u(te),oe(),!0}function x(){switch(s.getToken()){case P.NumericLiteral:{let X=0;try{X=JSON.parse(s.getTokenValue()),typeof X!="number"&&(ce(v.InvalidNumberFormat),X=0)}catch{ce(v.InvalidNumberFormat)}A(X);break}case P.NullKeyword:A(null);break;case P.TrueKeyword:A(!0);break;case P.FalseKeyword:A(!1);break;default:return!1}return oe(),!0}function Y(){return s.getToken()!==P.StringLiteral?(ce(v.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(fe(!1),s.getToken()===P.ColonToken?(N(":"),oe(),K()||ce(v.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):ce(v.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function B(){o(),oe();let X=!1;for(;s.getToken()!==P.CloseBraceToken&&s.getToken()!==P.EOF;){if(s.getToken()===P.CommaToken){if(X||ce(v.ValueExpected,[],[]),N(","),oe(),s.getToken()===P.CloseBraceToken&&ee)break}else X&&ce(v.CommaExpected,[],[]);Y()||ce(v.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),X=!0}return $(),s.getToken()!==P.CloseBraceToken?ce(v.CloseBraceExpected,[P.CloseBraceToken],[]):oe(),!0}function z(){D(),oe();let X=!1;for(;s.getToken()!==P.CloseBracketToken&&s.getToken()!==P.EOF;){if(s.getToken()===P.CommaToken){if(X||ce(v.ValueExpected,[],[]),N(","),oe(),s.getToken()===P.CloseBracketToken&&ee)break}else X&&ce(v.CommaExpected,[],[]);K()||ce(v.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),X=!0}return T(),s.getToken()!==P.CloseBracketToken?ce(v.CloseBracketExpected,[P.CloseBracketToken],[]):oe(),!0}function K(){switch(s.getToken()){case P.OpenBracketToken:return z();case P.OpenBraceToken:return B();case P.StringLiteral:return fe(!0);default:return x()}}return oe(),s.getToken()===P.EOF?n.allowEmptyContent?!0:(ce(v.ValueExpected,[],[]),!1):K()?(s.getToken()!==P.EOF&&ce(v.EndOfFileExpected,[],[]),!0):(ce(v.ValueExpected,[],[]),!1)}function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[76],ue([0,1,34]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=P,e.$7n=v,e.$8n=R,e.$9n=w;function P(a,f,c){let m,d,p,I,b;if(f){for(I=f.offset,b=I+f.length,p=I;p>0&&!w(a,p-1);)p--;let u=b;for(;u<a.length&&!w(a,u);)u++;d=a.substring(p,u),m=L(d,c)}else d=a,m=0,p=0,I=0,b=a.length;const h=R(c,a);let g=!1,O=0,y;c.insertSpaces?y=k(" ",c.tabSize||4):y="	";const i=(0,S.$Un)(d,!1);let l=!1;function n(){return h+k(y,m+O)}function s(){let u=i.scan();for(g=!1;u===S.SyntaxKind.Trivia||u===S.SyntaxKind.LineBreakTrivia;)g=g||u===S.SyntaxKind.LineBreakTrivia,u=i.scan();return l=u===S.SyntaxKind.Unknown||i.getTokenError()!==S.ScanError.None,u}const t=[];function r(u,$,D){!l&&$<b&&D>I&&a.substring($,D)!==u&&t.push({offset:$,length:D-$,content:u})}let o=s();if(o!==S.SyntaxKind.EOF){const u=i.getTokenOffset()+p,$=k(y,m);r($,p,u)}for(;o!==S.SyntaxKind.EOF;){let u=i.getTokenOffset()+i.getTokenLength()+p,$=s(),D="";for(;!g&&($===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia);){const A=i.getTokenOffset()+p;r(" ",u,A),u=i.getTokenOffset()+i.getTokenLength()+p,D=$===S.SyntaxKind.LineCommentTrivia?n():"",$=s()}if($===S.SyntaxKind.CloseBraceToken)o!==S.SyntaxKind.OpenBraceToken&&(O--,D=n());else if($===S.SyntaxKind.CloseBracketToken)o!==S.SyntaxKind.OpenBracketToken&&(O--,D=n());else{switch(o){case S.SyntaxKind.OpenBracketToken:case S.SyntaxKind.OpenBraceToken:O++,D=n();break;case S.SyntaxKind.CommaToken:case S.SyntaxKind.LineCommentTrivia:D=n();break;case S.SyntaxKind.BlockCommentTrivia:g?D=n():D=" ";break;case S.SyntaxKind.ColonToken:D=" ";break;case S.SyntaxKind.StringLiteral:if($===S.SyntaxKind.ColonToken){D="";break}case S.SyntaxKind.NullKeyword:case S.SyntaxKind.TrueKeyword:case S.SyntaxKind.FalseKeyword:case S.SyntaxKind.NumericLiteral:case S.SyntaxKind.CloseBraceToken:case S.SyntaxKind.CloseBracketToken:$===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia?D=" ":$!==S.SyntaxKind.CommaToken&&$!==S.SyntaxKind.EOF&&(l=!0);break;case S.SyntaxKind.Unknown:l=!0;break}g&&($===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia)&&(D=n())}const T=i.getTokenOffset()+p;r(D,u,T),o=$}return t}function v(a,f){const c=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?c.replace(/\r\n|\r|\n/g,f.eol):c}function k(a,f){let c="";for(let m=0;m<f;m++)c+=a;return c}function L(a,f){let c=0,m=0;const d=f.tabSize||4;for(;c<a.length;){const p=a.charAt(c);if(p===" ")m++;else if(p==="	")m+=d;else break;c++}return Math.floor(m/d)}function R(a,f){for(let c=0;c<f.length;c++){const m=f.charAt(c);if(m==="\r")return c+1<f.length&&f.charAt(c+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return a&&a.eol||`
`}function w(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(le[77],ue([0,1,34,76]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=v,e.$$n=k,e.$_n=L,e.$ao=R,e.$bo=w;function v(a,f,c){return k(a,f,void 0,c)}function k(a,f,c,m,d){const p=f.slice(),I=[],b=(0,S.$Xn)(a,I);let h,g;for(;p.length>0&&(g=p.pop(),h=(0,S.$Yn)(b,p),h===void 0&&c!==void 0);)typeof g=="string"?c={[g]:c}:c=[c];if(h)if(h.type==="object"&&typeof g=="string"&&Array.isArray(h.children)){const O=(0,S.$Yn)(h,[g]);if(O!==void 0)if(c===void 0){if(!O.parent)throw new Error("Malformed AST");const y=h.children.indexOf(O.parent);let i,l=O.parent.offset+O.parent.length;if(y>0){const n=h.children[y-1];i=n.offset+n.length}else i=h.offset+1,h.children.length>1&&(l=h.children[1].offset);return L(a,{offset:i,length:l-i,content:""},m)}else return L(a,{offset:O.offset,length:O.length,content:JSON.stringify(c)},m);else{if(c===void 0)return[];const y=`${JSON.stringify(g)}: ${JSON.stringify(c)}`,i=d?d(h.children.map(n=>n.children[0].value)):h.children.length;let l;if(i>0){const n=h.children[i-1];l={offset:n.offset+n.length,length:0,content:","+y}}else h.children.length===0?l={offset:h.offset+1,length:0,content:y}:l={offset:h.offset+1,length:0,content:y+","};return L(a,l,m)}}else if(h.type==="array"&&typeof g=="number"&&Array.isArray(h.children))if(c!==void 0){const O=`${JSON.stringify(c)}`;let y;if(h.children.length===0||g===0)y={offset:h.offset+1,length:0,content:h.children.length===0?O:O+","};else{const i=g===-1||g>h.children.length?h.children.length:g,l=h.children[i-1];y={offset:l.offset+l.length,length:0,content:","+O}}return L(a,y,m)}else{const O=g,y=h.children[O];let i;if(h.children.length===1)i={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===O){const l=h.children[O-1],n=l.offset+l.length,s=h.offset+h.length;i={offset:n,length:s-2-n,content:""}}else i={offset:y.offset,length:h.children[O+1].offset-y.offset,content:""};return L(a,i,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${h.type}`);else return c===void 0?[]:L(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(c)},m)}function L(a,f,c){let m=R(a,f),d=f.offset,p=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;d>0&&!(0,P.$9n)(m,d-1);)d--;for(;p<m.length&&!(0,P.$9n)(m,p);)p++}const I=(0,P.$6n)(m,{offset:d,length:p-d},c);for(let h=I.length-1;h>=0;h--){const g=I[h];m=R(m,g),d=Math.min(d,g.offset),p=Math.max(p,g.offset+g.length),p+=g.content.length-g.length}const b=a.length-(m.length-p)-d;return[{offset:d,length:b,content:m.substring(d,p)}]}function R(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function w(a,f){const c=f.slice(0).sort((d,p)=>{const I=d.offset-p.offset;return I===0?d.length-p.length:I});let m=a.length;for(let d=c.length-1;d>=0;d--){const p=c[d];if(p.offset+p.length<=m)a=R(a,p);else throw new Error("Overlapping edit");m=p.offset}return a}}),define(le[78],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=S;function S(k){let L=!1;const R=new Map,w=new Map;if(v(k,I=>{if(k===I)return!0;const b=JSON.stringify(I);if(b.length<30)return!0;const h=R.get(b);if(!h){const g={schemas:[I]};return R.set(b,g),w.set(I,g),!0}return h.schemas.push(I),w.set(I,h),L=!0,!1}),R.clear(),!L)return JSON.stringify(k);let f="$defs";for(;k.hasOwnProperty(f);)f+="_";const c=[];function m(I){return JSON.stringify(I,(b,h)=>{if(h!==I){const g=w.get(h);if(g&&g.schemas.length>1)return g.id||(g.id=`_${c.length}`,c.push(g.schemas[0])),{$ref:`#/${f}/${g.id}`}}return h})}const d=m(k),p=[];for(let I=0;I<c.length;I++)p.push(`"_${I}":${m(c[I])}`);return p.length?`${d.substring(0,d.length-1)},"${f}":{${p.join(",")}}}`:d}function P(k){return typeof k=="object"&&k!==null}function v(k,L){if(!k||typeof k!="object")return;const R=(...d)=>{for(const p of d)P(p)&&c.push(p)},w=(...d)=>{for(const p of d)if(P(p))for(const I in p){const b=p[I];P(b)&&c.push(b)}},a=(...d)=>{for(const p of d)if(Array.isArray(p))for(const I of p)P(I)&&c.push(I)},f=d=>{if(Array.isArray(d))for(const p of d)P(p)&&c.push(p);else P(d)&&c.push(d)},c=[k];let m=c.pop();for(;m;)L(m)&&(R(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),w(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),a(m.anyOf,m.allOf,m.oneOf,m.prefixItems),f(m.items)),m=c.pop()}}),define(le[79],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=void 0,e.$Jm=S,e.rot=P,e.$Om=R;function S(w,a,f){return Math.min(Math.max(w,a),f)}function P(w,a){return(a+w%a)%a}class v{constructor(){this.a=0}getNext(){return this.a++}}e.$Lm=v;class k{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Mm=k;class L{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const f=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Nm=L;function R(w,a,f,c,m,d,p,I){const b=p-f,h=I-c,g=m-f,O=d-c,y=w-f,i=a-c,l=b*b+h*h,n=b*g+h*O,s=b*y+h*i,t=g*g+O*O,r=g*y+O*i,o=1/(l*t-n*n),u=(t*s-n*r)*o,$=(l*r-n*s)*o;return u>=0&&$>=0&&u+$<1}}),function(){function Q(v){const k=[];typeof v=="number"&&k.push("code/timeOrigin",v);function L(w){k.push(w,Date.now())}function R(){const w=[];for(let a=0;a<k.length;a+=2)w.push({name:k[a],startTime:k[a+1]});return w}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(v+L.startTime)});return k}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function S(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=S(P))}(),define(le[56],ue([0,1,12]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$jm=k,e.$km=L;var P;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(P||(e.Source=P={}));var v;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(v||(e.TerminateResponseCode=v={}));function k(R,...w){const a=w.reduce((m,d)=>(m[d]=!0,m),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!a[m]).forEach(m=>{for(let d=0;d<f.length;d++)if(m.search(f[d])!==-1){delete R[m];break}})}function L(R){R&&(delete R.DEBUG,S.$l&&delete R.LD_PRELOAD)}}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var P in S)(typeof exports=="object"?exports:Q)[P]=S[P]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function S(P){if(e[P])return e[P].exports;var v=e[P]={i:P,l:!1,exports:{}};return Q[P].call(v.exports,v,v.exports,S),v.l=!0,v.exports}return S.m=Q,S.c=e,S.d=function(P,v,k){S.o(P,v)||Object.defineProperty(P,v,{enumerable:!0,get:k})},S.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},S.t=function(P,v){if(1&v&&(P=S(P)),8&v||4&v&&typeof P=="object"&&P&&P.__esModule)return P;var k=Object.create(null);if(S.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:P}),2&v&&typeof P!="string")for(var L in P)S.d(k,L,function(R){return P[R]}.bind(null,L));return k},S.n=function(P){var v=P&&P.__esModule?function(){return P.default}:function(){return P};return S.d(v,"a",v),v},S.o=function(P,v){return Object.prototype.hasOwnProperty.call(P,v)},S.p="",S(S.s=0)}([function(Q,e,S){(function(P){var v;e=Q.exports=F,v=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],w=e.src=[],a=0,f=a++;w[f]="0|[1-9]\\d*";var c=a++;w[c]="[0-9]+";var m=a++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=a++;w[d]="("+w[f]+")\\.("+w[f]+")\\.("+w[f]+")";var p=a++;w[p]="("+w[c]+")\\.("+w[c]+")\\.("+w[c]+")";var I=a++;w[I]="(?:"+w[f]+"|"+w[m]+")";var b=a++;w[b]="(?:"+w[c]+"|"+w[m]+")";var h=a++;w[h]="(?:-("+w[I]+"(?:\\."+w[I]+")*))";var g=a++;w[g]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var O=a++;w[O]="[0-9A-Za-z-]+";var y=a++;w[y]="(?:\\+("+w[O]+"(?:\\."+w[O]+")*))";var i=a++,l="v?"+w[d]+w[h]+"?"+w[y]+"?";w[i]="^"+l+"$";var n="[v=\\s]*"+w[p]+w[g]+"?"+w[y]+"?",s=a++;w[s]="^"+n+"$";var t=a++;w[t]="((?:<|>)?=?)";var r=a++;w[r]=w[c]+"|x|X|\\*";var o=a++;w[o]=w[f]+"|x|X|\\*";var u=a++;w[u]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[h]+")?"+w[y]+"?)?)?";var $=a++;w[$]="[v=\\s]*("+w[r]+")(?:\\.("+w[r]+")(?:\\.("+w[r]+")(?:"+w[g]+")?"+w[y]+"?)?)?";var D=a++;w[D]="^"+w[t]+"\\s*"+w[u]+"$";var T=a++;w[T]="^"+w[t]+"\\s*"+w[$]+"$";var A=a++;w[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=a++;w[N]="(?:~>?)";var M=a++;w[M]="(\\s*)"+w[N]+"\\s+",R[M]=new RegExp(w[M],"g");var G=a++;w[G]="^"+w[N]+w[u]+"$";var Z=a++;w[Z]="^"+w[N]+w[$]+"$";var ee=a++;w[ee]="(?:\\^)";var oe=a++;w[oe]="(\\s*)"+w[ee]+"\\s+",R[oe]=new RegExp(w[oe],"g");var ce=a++;w[ce]="^"+w[ee]+w[u]+"$";var fe=a++;w[fe]="^"+w[ee]+w[$]+"$";var x=a++;w[x]="^"+w[t]+"\\s*("+n+")$|^$";var Y=a++;w[Y]="^"+w[t]+"\\s*("+l+")$|^$";var B=a++;w[B]="(\\s*)"+w[t]+"\\s*("+n+"|"+w[u]+")",R[B]=new RegExp(w[B],"g");var z=a++;w[z]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var K=a++;w[K]="^\\s*("+w[$]+")\\s+-\\s+("+w[$]+")\\s*$";var X=a++;w[X]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)v(te,w[te]),R[te]||(R[te]=new RegExp(w[te]));function ne(W,_){if(W instanceof F)return W;if(typeof W!="string"||W.length>k||!(_?R[s]:R[i]).test(W))return null;try{return new F(W,_)}catch{return null}}function F(W,_){if(W instanceof F){if(W.loose===_)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof F))return new F(W,_);v("SemVer",W,_),this.loose=_;var ie=W.trim().match(_?R[s]:R[i]);if(!ie)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ee=+$e;if(Ee>=0&&Ee<L)return Ee}return $e}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}e.parse=ne,e.valid=function(W,_){var ie=ne(W,_);return ie?ie.version:null},e.clean=function(W,_){var ie=ne(W.trim().replace(/^[=v]+/,""),_);return ie?ie.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(W){return v("SemVer.compare",this.version,this.loose,W),W instanceof F||(W=new F(W,this.loose)),this.compareMain(W)||this.comparePre(W)},F.prototype.compareMain=function(W){return W instanceof F||(W=new F(W,this.loose)),q(this.major,W.major)||q(this.minor,W.minor)||q(this.patch,W.patch)},F.prototype.comparePre=function(W){if(W instanceof F||(W=new F(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var _=0;do{var ie=this.prerelease[_],$e=W.prerelease[_];if(v("prerelease compare",_,ie,$e),ie===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ie===void 0)return-1;if(ie!==$e)return q(ie,$e)}while(++_)},F.prototype.inc=function(W,_){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,_,ie,$e){typeof ie=="string"&&($e=ie,ie=void 0);try{return new F(W,ie).inc(_,$e).version}catch{return null}},e.diff=function(W,_){if(C(W,_))return null;var ie=ne(W),$e=ne(_);if(ie.prerelease.length||$e.prerelease.length){for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==$e[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==$e[Ee])return Ee},e.compareIdentifiers=q;var V=/^[0-9]+$/;function q(W,_){var ie=V.test(W),$e=V.test(_);return ie&&$e&&(W=+W,_=+_),ie&&!$e?-1:$e&&!ie?1:W<_?-1:W>_?1:0}function E(W,_,ie){return new F(W,ie).compare(new F(_,ie))}function j(W,_,ie){return E(W,_,ie)>0}function U(W,_,ie){return E(W,_,ie)<0}function C(W,_,ie){return E(W,_,ie)===0}function H(W,_,ie){return E(W,_,ie)!==0}function J(W,_,ie){return E(W,_,ie)>=0}function se(W,_,ie){return E(W,_,ie)<=0}function ae(W,_,ie,$e){var Ee;switch(_){case"===":typeof W=="object"&&(W=W.version),typeof ie=="object"&&(ie=ie.version),Ee=W===ie;break;case"!==":typeof W=="object"&&(W=W.version),typeof ie=="object"&&(ie=ie.version),Ee=W!==ie;break;case"":case"=":case"==":Ee=C(W,ie,$e);break;case"!=":Ee=H(W,ie,$e);break;case">":Ee=j(W,ie,$e);break;case">=":Ee=J(W,ie,$e);break;case"<":Ee=U(W,ie,$e);break;case"<=":Ee=se(W,ie,$e);break;default:throw new TypeError("Invalid operator: "+_)}return Ee}function de(W,_){if(W instanceof de){if(W.loose===_)return W;W=W.value}if(!(this instanceof de))return new de(W,_);v("comparator",W,_),this.loose=_,this.parse(W),this.semver===me?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(W,_){return q(_,W)},e.major=function(W,_){return new F(W,_).major},e.minor=function(W,_){return new F(W,_).minor},e.patch=function(W,_){return new F(W,_).patch},e.compare=E,e.compareLoose=function(W,_){return E(W,_,!0)},e.rcompare=function(W,_,ie){return E(_,W,ie)},e.sort=function(W,_){return W.sort(function(ie,$e){return e.compare(ie,$e,_)})},e.rsort=function(W,_){return W.sort(function(ie,$e){return e.rcompare(ie,$e,_)})},e.gt=j,e.lt=U,e.eq=C,e.neq=H,e.gte=J,e.lte=se,e.cmp=ae,e.Comparator=de;var me={};function ge(W,_){if(W instanceof ge)return W.loose===_?W:new ge(W.raw,_);if(W instanceof de)return new ge(W.value,_);if(!(this instanceof ge))return new ge(W,_);if(this.loose=_,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function we(W){return!W||W.toLowerCase()==="x"||W==="*"}function he(W,_,ie,$e,Ee,Ne,ke,Te,Oe,Le,Me,Ae,Ce){return((_=we(ie)?"":we($e)?">="+ie+".0.0":we(Ee)?">="+ie+"."+$e+".0":">="+_)+" "+(Te=we(Oe)?"":we(Le)?"<"+(+Oe+1)+".0.0":we(Me)?"<"+Oe+"."+(+Le+1)+".0":Ae?"<="+Oe+"."+Le+"."+Me+"-"+Ae:"<="+Te)).trim()}function pe(W,_){for(var ie=0;ie<W.length;ie++)if(!W[ie].test(_))return!1;if(_.prerelease.length){for(ie=0;ie<W.length;ie++)if(v(W[ie].semver),W[ie].semver!==me&&W[ie].semver.prerelease.length>0){var $e=W[ie].semver;if($e.major===_.major&&$e.minor===_.minor&&$e.patch===_.patch)return!0}return!1}return!0}function be(W,_,ie){try{_=new ge(_,ie)}catch{return!1}return _.test(W)}function Se(W,_,ie,$e){var Ee,Ne,ke,Te,Oe;switch(W=new F(W,$e),_=new ge(_,$e),ie){case">":Ee=j,Ne=se,ke=U,Te=">",Oe=">=";break;case"<":Ee=U,Ne=J,ke=j,Te="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(W,_,$e))return!1;for(var Le=0;Le<_.set.length;++Le){var Me=_.set[Le],Ae=null,Ce=null;if(Me.forEach(function(Fe){Fe.semver===me&&(Fe=new de(">=0.0.0")),Ae=Ae||Fe,Ce=Ce||Fe,Ee(Fe.semver,Ae.semver,$e)?Ae=Fe:ke(Fe.semver,Ce.semver,$e)&&(Ce=Fe)}),Ae.operator===Te||Ae.operator===Oe||(!Ce.operator||Ce.operator===Te)&&Ne(W,Ce.semver)||Ce.operator===Oe&&ke(W,Ce.semver))return!1}return!0}de.prototype.parse=function(W){var _=this.loose?R[x]:R[Y],ie=W.match(_);if(!ie)throw new TypeError("Invalid comparator: "+W);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new F(ie[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(W){return v("Comparator.test",W,this.loose),this.semver===me||(typeof W=="string"&&(W=new F(W,this.loose)),ae(W,this.operator,this.semver,this.loose))},de.prototype.intersects=function(W,_){if(!(W instanceof de))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new ge(W.value,_),be(this.value,ie,_);if(W.operator==="")return ie=new ge(this.value,_),be(W.semver,ie,_);var $e=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ne=this.semver.version===W.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Te=ae(this.semver,"<",W.semver,_)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Oe=ae(this.semver,">",W.semver,_)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return $e||Ee||Ne&&ke||Te||Oe},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(W){var _=this.loose;W=W.trim(),v("range",W,_);var ie=_?R[K]:R[z];W=W.replace(ie,he),v("hyphen replace",W),W=W.replace(R[B],"$1$2$3"),v("comparator trim",W,R[B]),W=(W=(W=W.replace(R[M],"$1~")).replace(R[oe],"$1^")).split(/\s+/).join(" ");var $e=_?R[x]:R[Y],Ee=W.split(" ").map(function(Ne){return function(ke,Te){return v("comp",ke),ke=function(Oe,Le){return Oe.trim().split(/\s+/).map(function(Me){return function(Ae,Ce){v("caret",Ae,Ce);var Fe=Ce?R[fe]:R[ce];return Ae.replace(Fe,function(Ue,Pe,Ie,Re,De){var je;return v("caret",Ae,Ue,Pe,Ie,Re,De),we(Pe)?je="":we(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Re)?je=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":De?(v("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Re+De+" <"+Pe+"."+Ie+"."+(+Re+1):">="+Pe+"."+Ie+"."+Re+De+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Re+De+" <"+(+Pe+1)+".0.0"):(v("no pr"),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+Ie+"."+(+Re+1):">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Re+" <"+(+Pe+1)+".0.0"),v("caret return",je),je})}(Me,Le)}).join(" ")}(ke,Te),v("caret",ke),ke=function(Oe,Le){return Oe.trim().split(/\s+/).map(function(Me){return function(Ae,Ce){var Fe=Ce?R[Z]:R[G];return Ae.replace(Fe,function(Ue,Pe,Ie,Re,De){var je;return v("tilde",Ae,Ue,Pe,Ie,Re,De),we(Pe)?je="":we(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Re)?je=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":De?(v("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),je=">="+Pe+"."+Ie+"."+Re+De+" <"+Pe+"."+(+Ie+1)+".0"):je=">="+Pe+"."+Ie+"."+Re+" <"+Pe+"."+(+Ie+1)+".0",v("tilde return",je),je})}(Me,Le)}).join(" ")}(ke,Te),v("tildes",ke),ke=function(Oe,Le){return v("replaceXRanges",Oe,Le),Oe.split(/\s+/).map(function(Me){return function(Ae,Ce){Ae=Ae.trim();var Fe=Ce?R[T]:R[D];return Ae.replace(Fe,function(Ue,Pe,Ie,Re,De,je){v("xRange",Ae,Ue,Pe,Ie,Re,De,je);var Ve=we(Ie),qe=Ve||we(Re),Be=qe||we(De);return Pe==="="&&Be&&(Pe=""),Ve?Ue=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(qe&&(Re=0),Be&&(De=0),Pe===">"?(Pe=">=",qe?(Ie=+Ie+1,Re=0,De=0):Be&&(Re=+Re+1,De=0)):Pe==="<="&&(Pe="<",qe?Ie=+Ie+1:Re=+Re+1),Ue=Pe+Ie+"."+Re+"."+De):qe?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Re+".0 <"+Ie+"."+(+Re+1)+".0"),v("xRange return",Ue),Ue})}(Me,Le)}).join(" ")}(ke,Te),v("xrange",ke),ke=function(Oe,Le){return v("replaceStars",Oe,Le),Oe.trim().replace(R[X],"")}(ke,Te),v("stars",ke),ke}(Ne,_)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Ne){return!!Ne.match($e)})),Ee=Ee.map(function(Ne){return new de(Ne,_)})},ge.prototype.intersects=function(W,_){if(!(W instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function($e){return W.set.some(function(Ee){return Ee.every(function(Ne){return $e.intersects(Ne,_)})})})})},e.toComparators=function(W,_){return new ge(W,_).set.map(function(ie){return ie.map(function($e){return $e.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new F(W,this.loose));for(var _=0;_<this.set.length;_++)if(pe(this.set[_],W))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(W,_,ie){var $e=null,Ee=null;try{var Ne=new ge(_,ie)}catch{return null}return W.forEach(function(ke){Ne.test(ke)&&($e&&Ee.compare(ke)!==-1||(Ee=new F($e=ke,ie)))}),$e},e.minSatisfying=function(W,_,ie){var $e=null,Ee=null;try{var Ne=new ge(_,ie)}catch{return null}return W.forEach(function(ke){Ne.test(ke)&&($e&&Ee.compare(ke)!==1||(Ee=new F($e=ke,ie)))}),$e},e.validRange=function(W,_){try{return new ge(W,_).range||"*"}catch{return null}},e.ltr=function(W,_,ie){return Se(W,_,"<",ie)},e.gtr=function(W,_,ie){return Se(W,_,">",ie)},e.outside=Se,e.prerelease=function(W,_){var ie=ne(W,_);return ie&&ie.prerelease.length?ie.prerelease:null},e.intersects=function(W,_,ie){return W=new ge(W,ie),_=new ge(_,ie),W.intersects(_)},e.coerce=function(W){if(W instanceof F)return W;if(typeof W!="string")return null;var _=W.match(R[A]);return _==null?null:ne((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,S(1))},function(Q,e){var S,P,v=Q.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(b){if(S===setTimeout)return setTimeout(b,0);if((S===k||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch{try{return S.call(null,b,0)}catch{return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:k}catch{S=k}try{P=typeof clearTimeout=="function"?clearTimeout:L}catch{P=L}})();var w,a=[],f=!1,c=-1;function m(){f&&w&&(f=!1,w.length?a=w.concat(a):c=-1,a.length&&d())}function d(){if(!f){var b=R(m);f=!0;for(var h=a.length;h;){for(w=a,a=[];++c<h;)w&&w[c].run();c=-1,h=a.length}w=null,f=!1,function(g){if(P===clearTimeout)return clearTimeout(g);if((P===L||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(g);try{P(g)}catch{try{return P.call(null,g)}catch{return P.call(this,g)}}}(b)}}function p(b,h){this.fun=b,this.array=h}function I(){}v.nextTick=function(b){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];a.push(new p(b,h)),a.length!==1||f||R(d)},p.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=I,v.addListener=I,v.once=I,v.off=I,v.removeListener=I,v.removeAllListeners=I,v.emit=I,v.prependListener=I,v.prependOnceListener=I,v.listeners=function(b){return[]},v.binding=function(b){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(b){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(le[80],ue([0,1]),function(Q,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class P{constructor(R,w,a){this.level=R,this.key=w,this.value=a,this.forward=[]}}const v=void 0;class k{constructor(R,w=2**16){this.comparator=R,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new P(this.c,v,v)}get size(){return this.f}clear(){this.e=new P(this.c,v,v),this.f=0}has(R){return!!k.g(this,R,this.comparator)}get(R){return k.g(this,R,this.comparator)?.value}set(R,w){return k.h(this,R,w,this.comparator)&&(this.f+=1),this}delete(R){const w=k.k(this,R,this.comparator);return w&&(this.f-=1),w}forEach(R,w){let a=this.e.forward[0];for(;a;)R.call(w,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",w=this.e.forward[0];for(;w;)R+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return R}static g(R,w,a){let f=R.e;for(let c=R.d-1;c>=0;c--)for(;f.forward[c]&&a(f.forward[c].key,w)<0;)f=f.forward[c];if(f=f.forward[0],f&&a(f.key,w)===0)return f}static h(R,w,a,f){const c=[];let m=R.e;for(let d=R.d-1;d>=0;d--){for(;m.forward[d]&&f(m.forward[d].key,w)<0;)m=m.forward[d];c[d]=m}if(m=m.forward[0],m&&f(m.key,w)===0)return m.value=a,!1;{const d=k.j(R);if(d>R.d){for(let p=R.d;p<d;p++)c[p]=R.e;R.d=d}m=new P(d,w,a);for(let p=0;p<d;p++)m.forward[p]=c[p].forward[p],c[p].forward[p]=m;return!0}}static j(R,w=.5){let a=1;for(;Math.random()<w&&a<R.c;)a+=1;return a}static k(R,w,a){const f=[];let c=R.e;for(let m=R.d-1;m>=0;m--){for(;c.forward[m]&&a(c.forward[m].key,w)<0;)c=c.forward[m];f[m]=c}if(c=c.forward[0],!c||a(c.key,w)!==0)return!1;for(let m=0;m<R.d&&f[m].forward[m]===c;m++)f[m].forward[m]=c.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===v;)R.d-=1;return!0}}e.$Rs=k}),define(le[47],ue([0,1,7,2]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=v,e.$ye=k,e.$ze=L,e.$Ae=R,e.$Be=a,e.$Ce=f,e.$De=c,e.$Ee=m,e.$Fe=d,e.$Ge=p,e.$He=I,e.$Ie=b,e.$Je=h,e.$Ke=g,e.$Le=O;function v(y){const i=y;return i?typeof i.read=="function":!1}function k(y){const i=y;return i?[i.on,i.pause,i.resume,i.destroy].every(l=>typeof l=="function"):!1}function L(y){const i=y;return i?k(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function R(y,i){return new w(y,i)}class w{constructor(i,l){this.e=i,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(l=>l(i))}h(i){this.c.error.length===0?(0,S.$Y)(i):this.c.error.slice(0).forEach(l=>l(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,l){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(i,l){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const s=n.indexOf(l);s>=0&&n.splice(s,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(y,i){const l=[];let n;for(;(n=y.read())!==null;)l.push(n);return i(l)}function f(y,i,l){const n=[];let s;for(;(s=y.read())!==null&&n.length<l;)n.push(s);return s===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const t=s;return s=void 0,t}return y.read()}}}function c(y,i){return new Promise((l,n)=>{const s=[];m(y,{onData:t=>{i&&s.push(t)},onError:t=>{i?n(t):l(void 0)},onEnd:()=>{l(i?i(s):void 0)}})})}function m(y,i,l){y.on("error",n=>{l?.isCancellationRequested||i.onError(n)}),y.on("end",()=>{l?.isCancellationRequested||i.onEnd()}),y.on("data",n=>{l?.isCancellationRequested||i.onData(n)})}function d(y,i){return new Promise((l,n)=>{const s=new P.$Sc,t=[],r=$=>{if(t.push($),t.length>i)return s.dispose(),y.pause(),l({stream:y,buffer:t,ended:!1})},o=$=>(s.dispose(),n($)),u=()=>(s.dispose(),l({stream:y,buffer:t,ended:!0}));s.add((0,P.$Rc)(()=>y.removeListener("error",o))),y.on("error",o),s.add((0,P.$Rc)(()=>y.removeListener("end",u))),y.on("end",u),s.add((0,P.$Rc)(()=>y.removeListener("data",r))),y.on("data",r)})}function p(y,i){const l=R(i);return l.end(y),l}function I(){const y=R(()=>{throw new Error("not supported")});return y.end(),y}function b(y){let i=!1;return{read:()=>i?null:(i=!0,y)}}function h(y,i,l){const n=R(l);return m(y,{onData:s=>n.write(i.data(s)),onError:s=>n.error(i.error?i.error(s):s),onEnd:()=>n.end()}),n}function g(y,i,l){let n=!1;return{read:()=>{const s=i.read();return n?s:(n=!0,s!==null?l([y,s]):y)}}}function O(y,i,l){let n=!1;const s=R(l);return m(i,{onData:t=>n?s.write(t):(n=!0,s.write(l([y,t]))),onError:t=>s.error(t),onEnd:()=>{n||(n=!0,s.write(y)),s.end()}}),s}});var We=this&&this.__createBinding||(Object.create?function(Q,e,S,P){P===void 0&&(P=S);var v=Object.getOwnPropertyDescriptor(e,S);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(Q,P,v)}:function(Q,e,S,P){P===void 0&&(P=S),Q[P]=e[S]}),xe=this&&this.__setModuleDefault||(Object.create?function(Q,e){Object.defineProperty(Q,"default",{enumerable:!0,value:e})}:function(Q,e){Q.default=e}),ye=this&&this.__importStar||function(Q){if(Q&&Q.__esModule)return Q;var e={};if(Q!=null)for(var S in Q)S!=="default"&&Object.prototype.hasOwnProperty.call(Q,S)&&We(e,Q,S);return xe(e,Q),e};define(le[13],ue([0,1,146,47]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=void 0,e.$Ne=a,e.$Oe=f,e.$Pe=c,e.$Qe=m,e.$Re=d,e.$Se=p,e.$Te=I,e.$Ue=b,e.$Ve=h,e.$We=g,e.$Xe=O,e.$Ye=y,e.$Ze=i,e.$1e=l,e.$2e=n,e.$3e=s,e.$4e=t,e.$5e=r,e.$6e=o,e.$7e=D,P=ye(P);const v=typeof Buffer<"u",k=new S.$T(()=>new Uint8Array(256));let L,R;class w{static alloc(A){return v?new w(Buffer.allocUnsafe(A)):new w(new Uint8Array(A))}static wrap(A){return v&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new w(A)}static fromString(A,N){return!(N?.dontUseNodeBuffer||!1)&&v?new w(Buffer.from(A)):(L||(L=new TextEncoder),new w(L.encode(A)))}static fromByteArray(A){const N=w.alloc(A.length);for(let M=0,G=A.length;M<G;M++)N.buffer[M]=A[M];return N}static concat(A,N){if(typeof N>"u"){N=0;for(let Z=0,ee=A.length;Z<ee;Z++)N+=A[Z].byteLength}const M=w.alloc(N);let G=0;for(let Z=0,ee=A.length;Z<ee;Z++){const oe=A[Z];M.set(oe,G),G+=oe.byteLength}return M}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=w.alloc(this.byteLength);return A.set(this),A}toString(){return v?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(A,N){return new w(this.buffer.subarray(A,N))}set(A,N){if(A instanceof w)this.buffer.set(A.buffer,N);else if(A instanceof Uint8Array)this.buffer.set(A,N);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),N);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return m(this.buffer,A)}writeUInt32BE(A,N){d(this.buffer,A,N)}readUInt32LE(A){return p(this.buffer,A)}writeUInt32LE(A,N){I(this.buffer,A,N)}readUInt8(A){return b(this.buffer,A)}writeUInt8(A,N){h(this.buffer,A,N)}indexOf(A,N=0){return a(this.buffer,A instanceof w?A.buffer:A,N)}}e.$Me=w;function a(T,A,N=0){const M=A.byteLength,G=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf(A[0]);if(M>G-N)return-1;const Z=k.value;Z.fill(A.length);for(let fe=0;fe<A.length;fe++)Z[A[fe]]=A.length-fe-1;let ee=N+A.length-1,oe=ee,ce=-1;for(;ee<G;)if(T[ee]===A[oe]){if(oe===0){ce=ee;break}ee--,oe--}else ee+=Math.max(A.length-oe,Z[T[ee]]),oe=A.length-1;return ce}function f(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0}function c(T,A,N){T[N+0]=A&255,A=A>>>8,T[N+1]=A&255}function m(T,A){return T[A]*2**24+T[A+1]*2**16+T[A+2]*2**8+T[A+3]}function d(T,A,N){T[N+3]=A,A=A>>>8,T[N+2]=A,A=A>>>8,T[N+1]=A,A=A>>>8,T[N]=A}function p(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0|T[A+2]<<16>>>0|T[A+3]<<24>>>0}function I(T,A,N){T[N+0]=A&255,A=A>>>8,T[N+1]=A&255,A=A>>>8,T[N+2]=A&255,A=A>>>8,T[N+3]=A&255}function b(T,A){return T[A]}function h(T,A,N){T[N]=A}function g(T){return P.$Be(T,A=>w.concat(A))}function O(T){return P.$Ie(T)}function y(T){return P.$De(T,A=>w.concat(A))}async function i(T){return T.ended?w.concat(T.buffer):w.concat([...T.buffer,await y(T.stream)])}function l(T){return P.$Ge(T,A=>w.concat(A))}function n(T){return P.$Je(T,{data:A=>typeof A=="string"?w.fromString(A):w.wrap(A)},A=>w.concat(A))}function s(T){return P.$Ae(A=>w.concat(A),T)}function t(T,A){return P.$Ke(T,A,N=>w.concat(N))}function r(T,A){return P.$Le(T,A,N=>w.concat(N))}function o(T){let A=0,N=0,M=0;const G=new Uint8Array(Math.floor(T.length/4*3)),Z=oe=>{switch(N){case 3:G[M++]=A|oe,N=0;break;case 2:G[M++]=A|oe>>>2,A=oe<<6,N=3;break;case 1:G[M++]=A|oe>>>4,A=oe<<4,N=2;break;default:A=oe<<2,N=1}};for(let oe=0;oe<T.length;oe++){const ce=T.charCodeAt(oe);if(ce>=65&&ce<=90)Z(ce-65);else if(ce>=97&&ce<=122)Z(ce-97+26);else if(ce>=48&&ce<=57)Z(ce-48+52);else if(ce===43||ce===45)Z(62);else if(ce===47||ce===95)Z(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${T[oe]}`)}}const ee=M;for(;N>0;)Z(0);return w.wrap(G).slice(0,ee)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",$="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:T},A=!0,N=!1){const M=N?$:u;let G="";const Z=T.byteLength%3;let ee=0;for(;ee<T.byteLength-Z;ee+=3){const oe=T[ee+0],ce=T[ee+1],fe=T[ee+2];G+=M[oe>>>2],G+=M[(oe<<4|ce>>>4)&63],G+=M[(ce<<2|fe>>>6)&63],G+=M[fe&63]}if(Z===1){const oe=T[ee+0];G+=M[oe>>>2],G+=M[oe<<4&63],A&&(G+="==")}else if(Z===2){const oe=T[ee+0],ce=T[ee+1];G+=M[oe>>>2],G+=M[(oe<<4|ce>>>4)&63],G+=M[ce<<2&63],A&&(G+="=")}return G}}),define(le[27],ue([0,1,3]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=P,e.$do=v,e.$eo=L,e.$fo=w,e.$go=a,e.$ho=f,e.$io=c,e.$jo=m,e.$ko=d,e.$lo=p,e.$mo=I,e.$no=b,e.$oo=h;function P(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const O=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([y,i])=>{O[y]=i&&typeof i=="object"?P(i):i}),O}function v(g){if(!g||typeof g!="object")return g;const O=[g];for(;O.length>0;){const y=O.shift();Object.freeze(y);for(const i in y)if(k.call(y,i)){const l=y[i];typeof l=="object"&&!Object.isFrozen(l)&&!(0,S.$gg)(l)&&O.push(l)}}return g}const k=Object.prototype.hasOwnProperty;function L(g,O){return R(g,O,new Set)}function R(g,O,y){if((0,S.$mg)(g))return g;const i=O(g);if(typeof i<"u")return i;if(Array.isArray(g)){const l=[];for(const n of g)l.push(R(n,O,y));return l}if((0,S.$fg)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const l={};for(const n in g)k.call(g,n)&&(l[n]=R(g[n],O,y));return y.delete(g),l}return g}function w(g,O,y=!0){return(0,S.$fg)(g)?((0,S.$fg)(O)&&Object.keys(O).forEach(i=>{i in g?y&&((0,S.$fg)(g[i])&&(0,S.$fg)(O[i])?w(g[i],O[i],y):g[i]=O[i]):g[i]=O[i]}),g):O}function a(g,O){if(g===O)return!0;if(g==null||O===null||O===void 0||typeof g!=typeof O||typeof g!="object"||Array.isArray(g)!==Array.isArray(O))return!1;let y,i;if(Array.isArray(g)){if(g.length!==O.length)return!1;for(y=0;y<g.length;y++)if(!a(g[y],O[y]))return!1}else{const l=[];for(i in g)l.push(i);l.sort();const n=[];for(i in O)n.push(i);if(n.sort(),!a(l,n))return!1;for(y=0;y<l.length;y++)if(!a(g[l[y]],O[l[y]]))return!1}return!0}function f(g){const O=new Set;return JSON.stringify(g,(y,i)=>{if((0,S.$fg)(i)||Array.isArray(i)){if(O.has(i))return"[Circular]";O.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function c(g,O){const y=Object.create(null);return!g||!O||Object.keys(O).forEach(l=>{const n=g[l],s=O[l];a(n,s)||(y[l]=s)}),y}function m(g,O){const y=O.toLowerCase(),i=Object.keys(g).find(l=>l.toLowerCase()===y);return i?g[i]:g[O]}function d(g,O){const y=Object.create(null);for(const[i,l]of Object.entries(g))O(i,l)&&(y[i]=l);return y}function p(g){let O=[];for(;Object.prototype!==g;)O=O.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return O}function I(g){const O=[];for(const y of p(g))typeof g[y]=="function"&&O.push(y);return O}function b(g,O){const y=l=>function(){const n=Array.prototype.slice.call(arguments,0);return O(l,n)},i={};for(const l of g)i[l]=y(l);return i}function h(g,O){const y={};for(const[i,l]of Object.entries(g))y[i]=O(l,i);return y}}),define(le[43],ue([0,1,31]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$vj=void 0,e.$rj=P,e.$sj=v,e.$tj=k,e.$uj=R,e.$wj=I,S=ye(S);function P(h){return v(h,0)}function v(h,g){switch(typeof h){case"object":return h===null?k(349,g):Array.isArray(h)?w(h,g):a(h,g);case"string":return R(h,g);case"boolean":return L(h,g);case"number":return k(h,g);case"undefined":return k(937,g);default:return k(617,g)}}function k(h,g){return(g<<5)-g+h|0}function L(h,g){return k(h?433:863,g)}function R(h,g){g=k(149417,g);for(let O=0,y=h.length;O<y;O++)g=k(h.charCodeAt(O),g);return g}function w(h,g){return g=k(104579,g),h.reduce((O,y)=>v(y,O),g)}function a(h,g){return g=k(181387,g),Object.keys(h).sort().reduce((O,y)=>(O=R(y,O),v(h[y],O)),g)}class f{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=v(g,this.g),this.g}}e.$vj=f;var c;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function m(h,g,O=32){const y=O-g,i=~((1<<y)-1);return(h<<g|(i&h)>>>y)>>>0}function d(h,g=0,O=h.byteLength,y=0){for(let i=0;i<O;i++)h[g+i]=y}function p(h,g,O="0"){for(;h.length<g;)h=O+h;return h}function I(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(O=>O.toString(16).padStart(2,"0")).join(""):p((h>>>0).toString(16),g/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(c.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const O=g.length;if(O===0)return;const y=this.p;let i=this.r,l=this.u,n,s;for(l!==0?(n=l,s=-1,l=0):(n=g.charCodeAt(0),s=0);;){let t=n;if(S.$If(n))if(s+1<O){const r=g.charCodeAt(s+1);S.$Jf(r)?(s++,t=S.$Kf(n,r)):t=c.UNICODE_REPLACEMENT}else{l=n;break}else S.$Jf(n)&&(t=c.UNICODE_REPLACEMENT);if(i=this.w(y,i,t),s++,s<O)n=g.charCodeAt(s);else break}this.r=i,this.u=l}w(g,O,y){return y<128?g[O++]=y:y<2048?(g[O++]=192|(y&1984)>>>6,g[O++]=128|(y&63)>>>0):y<65536?(g[O++]=224|(y&61440)>>>12,g[O++]=128|(y&4032)>>>6,g[O++]=128|(y&63)>>>0):(g[O++]=240|(y&1835008)>>>18,g[O++]=128|(y&258048)>>>12,g[O++]=128|(y&4032)>>>6,g[O++]=128|(y&63)>>>0),O>=c.BLOCK_SIZE&&(this.y(),O-=c.BLOCK_SIZE,this.t+=c.BLOCK_SIZE,g[0]=g[c.BLOCK_SIZE+0],g[1]=g[c.BLOCK_SIZE+1],g[2]=g[c.BLOCK_SIZE+2]),O}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,c.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),I(this.h)+I(this.l)+I(this.m)+I(this.n)+I(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=b.g,O=this.q;for(let u=0;u<64;u+=4)g.setUint32(u,O.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,m(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let y=this.h,i=this.l,l=this.m,n=this.n,s=this.o,t,r,o;for(let u=0;u<80;u++)u<20?(t=i&l|~i&n,r=1518500249):u<40?(t=i^l^n,r=1859775393):u<60?(t=i&l|i&n|l&n,r=2400959708):(t=i^l^n,r=3395469782),o=m(y,5)+t+s+r+g.getUint32(u*4,!1)&4294967295,s=n,n=l,l=m(i,30),i=y,y=o;this.h=this.h+y&4294967295,this.l=this.l+i&4294967295,this.m=this.m+l&4294967295,this.n=this.n+n&4294967295,this.o=this.o+s&4294967295}}e.$xj=b}),define(le[57],ue([0,1,31]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),S=ye(S);var P;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(P||(P={})),function(v){const k="error",L="warning",R="warn",w="info",a="ignore";function f(m){return m?S.$Ef(k,m)?v.Error:S.$Ef(L,m)||S.$Ef(R,m)?v.Warning:S.$Ef(w,m)?v.Info:v.Ignore:v.Ignore}v.fromValue=f;function c(m){switch(m){case v.Error:return k;case v.Warning:return L;case v.Info:return w;default:return a}}v.toString=c}(P||(P={})),e.default=P}),define(le[81],ue([0,1,11]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=P,e.$cr=v,e.$dr=k,e.log=R;function P(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function v(a){const f=[];let c;try{const m=JSON.parse(a.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),c=d.__$stack),f.push(...m)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:c}}function k(a){if(typeof a!="string")return k(v(a).stack);const f=a;if(f){const c=L(f),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(m&&m.length===4)return{uri:S.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function L(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function R(a,f){const{args:c,stack:m}=v(a),d=typeof c[0]=="string"&&c.length===1;let p=L(m);p&&(p=`(${p.trim()})`);let I=[];if(typeof c[0]=="string"?p&&d?I=[`%c[${f}] %c${c[0]} %c${p}`,w("blue"),w(""),w("grey")]:I=[`%c[${f}] %c${c[0]}`,w("blue"),w(""),...c.slice(1)]:I=[`%c[${f}]%`,w("blue"),...c],p&&!d&&I.push(p),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,I)}function w(a){return`color: ${a}`}}),define(le[48],ue([0,1,13,11,147]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=k,e.$_h=L,e.$ai=w;function k(a){return JSON.stringify(a,R)}function L(a){let f=JSON.parse(a);return f=w(f),f}function R(a,f){return f instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:f.source,flags:f.flags}:f}function w(a,f=0){if(!a||f>200)return a;if(typeof a=="object"){switch(a.$mid){case v.MarshalledId.Uri:return P.URI.revive(a);case v.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case v.MarshalledId.Date:return new Date(a.source)}if(a instanceof S.$Me||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let c=0;c<a.length;++c)a[c]=w(a[c],f+1);else for(const c in a)Object.hasOwnProperty.call(a,c)&&(a[c]=w(a[c],f+1))}return a}}),define(le[82],ue([0,1,74,14,12,3,11]),function(Q,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=c,e.$BE=m,v=ye(v);class R{constructor(p,I,b){this.id=p,this.dependencies=I,this.callback=b}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,I,b)=>{typeof p!="string"&&(b=I,I=p,p=null),(typeof I!="object"||!Array.isArray(I))&&(b=I,I=null),this.c.push(new R(p,I,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const I=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!I)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(I.dependencies)&&I.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${I.dependencies.join(", ")}`);return typeof I.callback=="function"?I.callback([]):I.callback}h(p){return new Promise((I,b)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const g=()=>{h.removeEventListener("load",O),h.removeEventListener("error",y)},O=i=>{g(),I(this.c.pop())},y=i=>{g(),b(i)};h.addEventListener("load",O),h.addEventListener("error",y),this.f&&(p=this.f.createScriptURL(p)),h.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(p){return new Promise((I,b)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),I(this.c.pop())}catch(h){b(h)}})}async j(p){try{const I=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,g=L.URI.parse(p).fsPath,O=I.readFileSync(g).toString(),y=h.wrap(O.replace(/^#!.*/,""));return new b.Script(y).runInThisContext().apply(),this.c.pop()}catch(I){throw I}}}const a=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function c(d,p,I){if(S.$R){I===void 0&&(I=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[d]&&(d=f[d]);const b=p?`${d}/${p}`:d;if(a.has(b))return a.get(b);let h;if(/^\w[\w\d+.-]*:\/\//.test(b))h=b;else{const i=`${I&&!v.$p?P.$Ug:P.$Tg}/${b}`;h=P.$Xg.asBrowserUri(i).toString(!0)}const g=w.INSTANCE.load(h);return a.set(b,g),g}else return await new Promise((b,h)=>{Q([d],b,h)}).then(ye)}function m(d,p){(0,k.$ng)(S.$R);const h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!v.$p,g=`${d}/${p}`,y=`${h?P.$Ug:P.$Tg}/${g}`;return P.$Xg.asBrowserUri(y).toString(!0)}}),define(le[28],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=P;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(v){return S.test(v)}e.$Zg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(R){for(let w=0;w<R.length;w++)R[w]=Math.floor(Math.random()*256);return R};const k=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){v(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let w=0,a="";return a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a}}()}),define(le[83],ue([0,1,35]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=k;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(L){const R=L.replace(/\-/g,":").toLowerCase();return!P.has(R)}function k(){const L=(0,S.networkInterfaces)();for(const R in L){const w=L[R];if(w){for(const{mac:a}of w)if(v(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[84],ue([0,1,35,49,28,83,12]),function(Q,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=void 0,e.$Rn=w,e.$Sn=c,e.$Tn=m,v=ye(v),e.$Qn=new class{c(d){return this.a||(this.a=P.$Ji.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,p=0;const I=(0,S.networkInterfaces)();for(const b in I){const h=I[b];if(h)for(const{mac:g,internal:O}of h)O||(p+=1,this.c(g.toUpperCase())&&(d+=1))}this.b=p>0?d/p:0}return this.b}};let R;async function w(d){return R||(R=(async()=>await a(d)||v.$Zg())()),R}async function a(d){try{const p=await new Promise((b,h)=>{Q(["crypto"],b,h)}).then(ye),I=(0,k.$Pn)();return p.createHash("sha256").update(I,"utf8").digest("hex")}catch(p){d(p);return}}const f="Software\\Microsoft\\SQMClient";async function c(d){if(L.$j){const p=await new Promise((I,b)=>{Q(["@vscode/windows-registry"],I,b)}).then(ye);try{return p.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(I){return d(I),""}}return""}async function m(d){try{return await(await new Promise((b,h)=>{Q(["@vscode/deviceid"],b,h)}).then(ye)).getDeviceId()}catch(p){return d(p),""}}}),define(le[85],ue([0,1,35,15,29]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=g,e.$vm=O,S=ye(S),P=ye(P),v=ye(v);const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var w;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(w||(w={}));let a;switch(process.arch){case"ia32":a=w.x86;break;case"arm":case"arm64":a=w.ARM;break;default:a=w.x64;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?w.ARM:w.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=w.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=w.x86:f=w.x64;class c{constructor(i,l,n){this.exePath=i,this.displayName=l,this.a=n}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:y=!1}={}){return y?a===w.x64?process.env["ProgramFiles(x86)"]||null:f===w.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:y=!1,findPreview:i=!1}={}){const l=m({useAlternateBitness:y});if(!l)return null;const n=P.$ic(l,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(n))return null;let s=-1,t=null;for(const u of await v.Promises.readdir(n)){let $=-1;if(i){const T=u.indexOf("-");if(T<0)continue;const A=u.substring(0,T);if(!k.test(A)||u.substring(T+1)!=="preview")continue;$=parseInt(A,10)}else{if(!k.test(u))continue;$=parseInt(u,10)}if($<=s)continue;const D=P.$ic(n,u,"pwsh.exe");await v.SymlinkSupport.existsFile(D)&&(t=D,s=$)}if(!t)return null;const r=l.includes("x86")?" (x86)":"",o=i?" Preview":"";return new c(t,`PowerShell${o}${r}`,!0)}async function p({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const i=P.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=y?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const s of await v.Promises.readdir(i))if(l.test(s)){const t=P.$ic(i,s,"pwsh.exe");return new c(t,n)}return null}function I(){const y=P.$ic(S.homedir(),".dotnet","tools","pwsh.exe");return new c(y,".NET Core PowerShell Global Tool")}function b(){const y=P.$ic(process.env.windir,a===w.x86&&f!==w.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(y,"Windows PowerShell",!0)}async function*h(){let y=await d();y&&(yield y),y=await d({useAlternateBitness:!0}),y&&(yield y),y=await p(),y&&(yield y),y=I(),y&&(yield y),y=await d({findPreview:!0}),y&&(yield y),y=await p({findPreview:!0}),y&&(yield y),y=await d({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=b(),y&&(yield y)}async function*g(){for await(const y of h())await y.exists()&&(yield y)}async function O(){for await(const y of g())return y;return null}}),define(le[58],ue([0,1,32,15,12,36,56,3,29]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$wm=a,e.$xm=f,P=ye(P),v=ye(v),k=ye(k),R=ye(R),w=ye(w),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function a(m=k.env){return m.comspec||"cmd.exe"}function f(m){let d=[],p=!1;const I=function(b){if(p){d.push(b);return}(!m.send(b,g=>{if(g&&console.error(g),p=!1,d.length>0){const O=d.slice(0);d=[],O.forEach(y=>I(y))}})||v.$j)&&(p=!0)};return{send:I}}var c;(function(m){async function d(p,I,b){if(P.$hc(p))return p;if(I===void 0&&(I=k.cwd()),P.$lc(p)!=="."||(b===void 0&&R.$dg(k.env.PATH)&&(b=k.env.PATH.split(P.$sc)),b===void 0||b.length===0))return P.$ic(I,p);async function g(O){if(await w.Promises.exists(O)){let y;try{y=await S.promises.stat(O)}catch(i){i.message.startsWith("EACCES")&&(y=await S.promises.lstat(O))}return y?!y.isDirectory():!1}return!1}for(const O of b){let y;if(P.$hc(O)?y=P.$ic(O,p):y=P.$ic(I,O,p),await g(y))return y;let i=y+".com";if(await g(i)||(i=y+".exe",await g(i)))return i}return P.$ic(I,p)}m.findExecutable=d})(c||(e.win32=c={}))}),define(le[86],ue([0,1,35,12,85,58]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=L,P=ye(P),k=ye(k);async function L(c,m){return c===P.OperatingSystem.Windows?P.$j?f():k.$wm(m):w(c,m)}let R=null;function w(c,m){if(P.$l&&c===P.OperatingSystem.Macintosh||P.$k&&c===P.OperatingSystem.Linux)return"/bin/bash";if(!R){let d;if(P.$j)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,S.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}R=d}return R}let a=null;async function f(){return a||(a=(await(0,v.$vm)()).exePath),a}});var ve=this&&this.__decorate||function(Q,e,S,P){var v=arguments.length,k=v<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,S):P,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Q,e,S,P);else for(var R=Q.length-1;R>=0;R--)(L=Q[R])&&(k=(v<3?L(k):v>3?L(e,S,k):L(e,S))||k);return v>3&&k&&Object.defineProperty(e,S,k),k};define(le[59],ue([0,1,19,8,13,21,55,7,4,2,48,31,3]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.ProxyChannel=e.$li=e.$ii=e.$hi=e.$gi=e.RequestInitiator=e.$fi=e.$ci=e.$bi=void 0,e.$di=o,e.$ei=u,e.$ji=M,e.$ki=G,c=ye(c);var d;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(d||(d={}));function p(B){switch(B){case d.Promise:return"req";case d.PromiseCancel:return"cancel";case d.EventListen:return"subscribe";case d.EventDispose:return"unsubscribe"}}var I;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(I||(I={}));function b(B){switch(B){case I.Initialize:return"init";case I.PromiseSuccess:return"reply:";case I.PromiseError:case I.PromiseErrorObj:return"replyErr:";case I.EventFire:return"event:"}}var h;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(h||(h={}));function g(B){let z=0;for(let K=0;;K+=7){const X=B.read(1);if(z|=(X.buffer[0]&127)<<K,!(X.buffer[0]&128))return z}}const O=s(0);function y(B,z){if(z===0){B.write(O);return}let K=0;for(let te=z;te!==0;te=te>>>7)K++;const X=v.$Me.alloc(K);for(let te=0;z!==0;te++)X.buffer[te]=z&127,z=z>>>7,z>0&&(X.buffer[te]|=128);B.write(X)}class i{constructor(z){this.b=z,this.a=0}read(z){const K=this.b.slice(this.a,this.a+z);return this.a+=K.byteLength,K}}e.$bi=i;class l{constructor(){this.a=[]}get buffer(){return v.$Me.concat(this.a)}write(z){this.a.push(z)}}e.$ci=l;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function s(B){const z=v.$Me.alloc(1);return z.writeUInt8(B,0),z}const t={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},r=typeof Buffer<"u";function o(B,z){if(typeof z>"u")B.write(t.Undefined);else if(typeof z=="string"){const K=v.$Me.fromString(z);B.write(t.String),y(B,K.byteLength),B.write(K)}else if(r&&Buffer.isBuffer(z)){const K=v.$Me.wrap(z);B.write(t.Buffer),y(B,K.byteLength),B.write(K)}else if(z instanceof v.$Me)B.write(t.VSBuffer),y(B,z.byteLength),B.write(z);else if(Array.isArray(z)){B.write(t.Array),y(B,z.length);for(const K of z)o(B,K)}else if(typeof z=="number"&&(z|0)===z)B.write(t.Uint),y(B,z);else{const K=v.$Me.fromString(JSON.stringify(z));B.write(t.Object),y(B,K.byteLength),B.write(K)}}function u(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(g(B)).toString();case n.Buffer:return B.read(g(B)).buffer;case n.VSBuffer:return B.read(g(B));case n.Array:{const K=g(B),X=[];for(let te=0;te<K;te++)X.push(u(B));return X}case n.Object:return JSON.parse(B.read(g(B)).toString());case n.Int:return g(B)}}class ${constructor(z,K,X=null,te=1e3){this.h=z,this.j=K,this.k=X,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:I.Initialize})}registerChannel(z,K){this.b.set(z,K),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case I.Initialize:{const K=this.o([z.type]);this.k?.logOutgoing(K,0,D.OtherSide,b(z.type));return}case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:{const K=this.o([z.type,z.id],z.data);this.k?.logOutgoing(K,z.id,D.OtherSide,b(z.type),z.data);return}}}o(z,K=void 0){const X=new l;return o(X,z),o(X,K),this.p(X.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const K=new i(z),X=u(K),te=u(K),ne=X[0];switch(ne){case d.Promise:return this.k?.logIncoming(z.byteLength,X[1],D.OtherSide,`${p(ne)}: ${X[2]}.${X[3]}`,te),this.s({type:ne,id:X[1],channelName:X[2],name:X[3],arg:te});case d.EventListen:return this.k?.logIncoming(z.byteLength,X[1],D.OtherSide,`${p(ne)}: ${X[2]}.${X[3]}`,te),this.t({type:ne,id:X[1],channelName:X[2],name:X[3],arg:te});case d.PromiseCancel:return this.k?.logIncoming(z.byteLength,X[1],D.OtherSide,`${p(ne)}`),this.u({type:ne,id:X[1]});case d.EventDispose:return this.k?.logIncoming(z.byteLength,X[1],D.OtherSide,`${p(ne)}`),this.u({type:ne,id:X[1]})}}s(z){const K=this.b.get(z.channelName);if(!K){this.v(z);return}const X=new k.$ve;let te;try{te=K.call(this.j,z.name,z.arg,X.token)}catch(V){te=Promise.reject(V)}const ne=z.id;te.then(V=>{this.m({id:ne,data:V,type:I.PromiseSuccess})},V=>{V instanceof Error?this.m({id:ne,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split(`
`):void 0},type:I.PromiseError}):this.m({id:ne,data:V,type:I.PromiseErrorObj})}).finally(()=>{F.dispose(),this.d.delete(z.id)});const F=(0,a.$Rc)(()=>X.cancel());this.d.set(z.id,F)}t(z){const K=this.b.get(z.channelName);if(!K){this.v(z);return}const X=z.id,ne=K.listen(this.j,z.name,z.arg)(F=>this.m({id:X,data:F,type:I.EventFire}));this.d.set(z.id,ne)}u(z){const K=this.d.get(z.id);K&&(K.dispose(),this.d.delete(z.id))}v(z){let K=this.g.get(z.channelName);K||(K=[],this.g.set(z.channelName,K));const X=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===d.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:I.PromiseError})},this.l);K.push({request:z,timeoutTimer:X})}w(z){const K=this.g.get(z);if(K){for(const X of K)switch(clearTimeout(X.timeoutTimer),X.request.type){case d.Promise:this.s(X.request);break;case d.EventListen:this.t(X.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$fi=$;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class T{constructor(z,K=null){this.l=z,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$ke,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=K}getChannel(z){const K=this;return{call(X,te,ne){return K.a?Promise.reject(new R.$4):K.m(z,X,te,ne)},listen(X,te){return K.a?w.Event.None:K.o(z,X,te)}}}m(z,K,X,te=k.CancellationToken.None){const ne=this.g++,F=d.Promise,V={id:ne,type:F,channelName:z,name:K,arg:X};if(te.isCancellationRequested)return Promise.reject(new R.$4);let q;return new Promise((j,U)=>{if(te.isCancellationRequested)return U(new R.$4);const C=()=>{const ae=de=>{switch(de.type){case I.PromiseSuccess:this.f.delete(ne),j(de.data);break;case I.PromiseError:{this.f.delete(ne);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,U(me);break}case I.PromiseErrorObj:this.f.delete(ne),U(de.data);break}};this.f.set(ne,ae),this.p(V)};let H=null;this.b===h.Idle?C():(H=(0,P.$qh)(ae=>this.u()),H.then(()=>{H=null,C()}));const J=()=>{H?(H.cancel(),H=null):this.p({id:ne,type:d.PromiseCancel}),U(new R.$4)},se=te.onCancellationRequested(J);q=(0,a.$Qc)((0,a.$Rc)(J),se),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(z,K,X){const te=this.g++,ne=d.EventListen,F={id:te,type:ne,channelName:z,name:K,arg:X};let V=null;const q=new w.$ke({onWillAddFirstListener:()=>{V=(0,P.$qh)(j=>this.u()),V.then(()=>{V=null,this.d.add(q),this.p(F)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(q),this.p({id:te,type:d.EventDispose}))}}),E=j=>q.fire(j.data);return this.f.set(te,E),q.event}p(z){switch(z.type){case d.Promise:case d.EventListen:{const K=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(K,z.id,D.LocalSide,`${p(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case d.PromiseCancel:case d.EventDispose:{const K=this.q([z.type,z.id]);this.j?.logOutgoing(K,z.id,D.LocalSide,p(z.type));return}}}q(z,K=void 0){const X=new l;return o(X,z),o(X,K),this.r(X.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const K=new i(z),X=u(K),te=u(K),ne=X[0];switch(ne){case I.Initialize:return this.j?.logIncoming(z.byteLength,0,D.LocalSide,b(ne)),this.t({type:X[0]});case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,X[1],D.LocalSide,b(ne),te),this.t({type:X[0],id:X[1],data:te})}}t(z){if(z.type===I.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$gi=T,ve([L.$8h],T.prototype,"onDidInitializePromise",null);class A{get connections(){const z=[];return this.f.forEach(K=>z.push(K)),z}constructor(z,K,X){this.a=new Map,this.f=new Set,this.g=new w.$ke,this.onDidAddConnection=this.g.event,this.h=new w.$ke,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(z(({protocol:te,onDidClientDisconnect:ne})=>{const F=w.Event.once(te.onMessage);this.j.add(F(V=>{const q=new i(V),E=u(q),j=new $(te,E,K,X),U=new T(te,K);this.a.forEach((H,J)=>j.registerChannel(J,H));const C={channelServer:j,channelClient:U,ctx:E};this.f.add(C),this.g.fire(C),this.j.add(ne(()=>{j.dispose(),U.dispose(),this.f.delete(C),this.h.fire(C)}))}))}))}getChannel(z,K){const X=this;return{call(te,ne,F){let V;if((0,m.$rg)(K)){const E=(0,S.$2b)(X.connections.filter(K));V=E?Promise.resolve(E):w.Event.toPromise(w.Event.filter(X.onDidAddConnection,K))}else V=K.routeCall(X,te,ne);const q=V.then(E=>E.channelClient.getChannel(z));return M(q).call(te,ne,F)},listen(te,ne){if((0,m.$rg)(K))return X.k(z,K,te,ne);const F=K.routeEvent(X,te,ne).then(V=>V.channelClient.getChannel(z));return M(F).listen(te,ne)}}}k(z,K,X,te){const ne=this;let F;const V=new w.$ke({onWillAddFirstListener:()=>{F=new a.$Sc;const q=new w.$qe,E=new Map,j=C=>{const J=C.channelClient.getChannel(z).listen(X,te),se=q.add(J);E.set(C,se)},U=C=>{const H=E.get(C);H&&(H.dispose(),E.delete(C))};ne.connections.filter(K).forEach(j),w.Event.filter(ne.onDidAddConnection,K)(j,void 0,F),ne.onDidRemoveConnection(U,void 0,F),q.event(V.fire,V,F),F.add(q)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return V.event}registerChannel(z,K){this.a.set(z,K);for(const X of this.f)X.channelServer.registerChannel(z,K)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$hi=A;class N{constructor(z,K,X=null){const te=new l;o(te,K),z.send(te.buffer),this.a=new T(z,X),this.d=new $(z,K,X)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,K){this.d.registerChannel(z,K)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ii=N;function M(B){return{call(z,K,X){return B.then(te=>te.call(z,K,X))},listen(z,K){const X=new w.$te;return B.then(te=>X.input=te.listen(z,K)),X.event}}}function G(B){let z=!1;return{call(K,X,te){return z?B.call(K,X,te):(0,P.$Eh)(0).then(()=>z=!0).then(()=>B.call(K,X,te))},listen(K,X){if(z)return B.listen(K,X);const te=new w.$te;return(0,P.$Eh)(0).then(()=>z=!0).then(()=>te.input=B.listen(K,X)),te.event}}}class Z{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const K of z.connections)if(await Promise.resolve(this.a(K.ctx)))return Promise.resolve(K);return await w.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$li=Z;var ee;(function(B){function z(ne,F,V){const q=ne,E=V&&V.disableMarshalling,j=new Map;for(const U in q)X(U)&&j.set(U,w.Event.buffer(q[U],!0,void 0,F));return new class{listen(U,C,H){const J=j.get(C);if(J)return J;const se=q[C];if(typeof se=="function"){if(te(C))return se.call(q,H);if(X(C))return j.set(C,w.Event.buffer(q[C],!0,void 0,F)),j.get(C)}throw new R.$ab(`Event not found: ${C}`)}call(U,C,H){const J=q[C];if(typeof J=="function"){if(!E&&Array.isArray(H))for(let ae=0;ae<H.length;ae++)H[ae]=(0,f.$ai)(H[ae]);let se=J.apply(q,H);return se instanceof Promise||(se=Promise.resolve(se)),se}throw new R.$ab(`Method not found: ${C}`)}}}B.fromService=z;function K(ne,F){const V=F&&F.disableMarshalling;return new Proxy({},{get(q,E){if(typeof E=="string")return F?.properties?.has(E)?F.properties.get(E):te(E)?function(j){return ne.listen(E,j)}:X(E)?ne.listen(E):async function(...j){let U;F&&!(0,m.$mg)(F.context)?U=[F.context,...j]:U=j;const C=await ne.call(E,U);return V?C:(0,f.$ai)(C)};throw new R.$ab(`Property not found: ${String(E)}`)}})}B.toService=K;function X(ne){return ne[0]==="o"&&ne[1]==="n"&&c.$Df(ne.charCodeAt(2))}function te(ne){return/^onDynamic/.test(ne)&&c.$Df(ne.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const z=B.toString();if(z!=="[object Object]")return z}return B}function fe(B){return Array.isArray(B)?B.map(ce):ce(B)}function x(B,z,K,X,te,ne,F){F=fe(F);const V=oe[te],q=V[X%V.length];let E=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ne)?(E=E.concat(F),E.push(")")):E.push(F),console.log.apply(console,E)}class Y{constructor(z,K){this.d=z,this.f=K,this.a=0,this.b=0}logOutgoing(z,K,X,te,ne){this.b+=z,x(this.d,this.b,z,K,X,te,ne)}logIncoming(z,K,X,te,ne){this.a+=z,x(this.f,this.a,z,K,X,te,ne)}}e.$mi=Y}),define(le[87],ue([0,1,60,8,13,21,81,7,4,2,27,58,56,59]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0,R=ye(R);class p extends d.$fi{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",g=>v.$Me.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$fr=p;class I{constructor(h,g){this.i=h,this.j=g,this.c=new Set,this.g=new Map,this.h=new w.$ke,this.onDidProcessExit=this.h.event;const O=g&&g.timeout?g.timeout:6e4;this.b=new P.$Ah(O),this.d=null,this.f=null}getChannel(h){const g=this;return{call(O,y,i){return g.k(h,O,y,i)},listen(O,y){return g.l(h,O,y)}}}k(h,g,O,y=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(R.$5());this.b.cancel();const i=this.n(h),l=(0,P.$qh)(t=>i.call(g,O,t)),n=y.onCancellationRequested(()=>l.cancel()),s=(0,a.$Rc)(()=>l.cancel());return this.c.add(s),l.finally(()=>{n.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l(h,g,O){if(!this.b)return w.Event.None;this.b.cancel();let y;const i=new w.$ke({onWillAddFirstListener:()=>{y=this.n(h).listen(g,O)(i.fire,i),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,f.$co)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,m.$km)(g.env),this.d=(0,S.fork)(this.i,h,g);const O=new w.$ke,i=w.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,L.$br)(o)){(0,L.log)(o,`IPC Library: ${this.j.serverName}`);return}O.fire(v.$Me.wrap(Buffer.from(o,"base64")))}),l=this.j.useQueue?(0,c.$xm)(this.d):this.d,n=o=>this.d&&this.d.connected&&l.send(o.buffer.toString("base64")),s=O.event,t={send:n,onMessage:s};this.f=new d.$gi(t);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",r),i.dispose(),this.c.forEach($=>(0,a.$Oc)($)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(h){let g=this.g.get(h);return g||(g=this.m.getChannel(h),this.g.set(h,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gr=I}),define(le[88],ue([0,1,8,4,2,48,3]),function(Q,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=e.StorageState=e.StorageHint=void 0,e.$bq=w;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function w(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}var a;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(a||(e.StorageState=a={}));class f extends v.$Tc{static{this.a=100}constructor(d,p=Object.create(null)){super(),this.r=d,this.s=p,this.b=this.B(new P.$ne),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Bh(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((p,I)=>this.w(I,p)),d.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(d,p){if(this.c===a.Closed)return;let I=!1;(0,L.$mg)(p)?I=this.f.delete(d):this.f.get(d)!==p&&(this.f.set(d,p),I=!0),I&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,p){const I=this.f.get(d);return(0,L.$mg)(I)?p:I}getBoolean(d,p){const I=this.get(d);return(0,L.$mg)(I)?p:I==="true"}getNumber(d,p){const I=this.get(d);return(0,L.$mg)(I)?p:parseInt(I,10)}getObject(d,p){const I=this.get(d);return(0,L.$mg)(I)?p:(0,k.$_h)(I)}async set(d,p,I=!1){if(this.c===a.Closed)return;if((0,L.$mg)(p))return this.delete(d,I);const b=(0,L.$fg)(p)||Array.isArray(p)?(0,k.$$h)(p):String(p);if(this.f.get(d)!==b)return this.f.set(d,b),this.j.set(d,b),this.h.delete(d),this.b.fire({key:d,external:I}),this.D()}async delete(d,p=!1){if(!(this.c===a.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:p}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(!(this.c===a.Closed||this.m))return this.D(d)}async D(d){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$cq=f;class c{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((p,I)=>this.a.set(I,p)),d.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$dq=c}),define(le[89],ue([0,1,5]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=a,e.$1m=f,e.$2m=c;const P=60,v=P*60,k=v*24,L=k*7,R=k*30,w=k*365;function a(m,d,p,I){typeof m!="number"&&(m=m.getTime());const b=Math.round((new Date().getTime()-m)/1e3);if(b<-30)return(0,S.localize)(12911,null,a(new Date().getTime()+b*1e3,!1));if(!I&&b<30)return(0,S.localize)(12912,null);let h;return b<P?(h=b,d?h===1?p?(0,S.localize)(12913,null,h):(0,S.localize)(12914,null,h):p?(0,S.localize)(12915,null,h):(0,S.localize)(12916,null,h):h===1?p?(0,S.localize)(12917,null,h):(0,S.localize)(12918,null,h):p?(0,S.localize)(12919,null,h):(0,S.localize)(12920,null,h)):b<v?(h=Math.floor(b/P),d?h===1?p?(0,S.localize)(12921,null,h):(0,S.localize)(12922,null,h):p?(0,S.localize)(12923,null,h):(0,S.localize)(12924,null,h):h===1?p?(0,S.localize)(12925,null,h):(0,S.localize)(12926,null,h):p?(0,S.localize)(12927,null,h):(0,S.localize)(12928,null,h)):b<k?(h=Math.floor(b/v),d?h===1?p?(0,S.localize)(12929,null,h):(0,S.localize)(12930,null,h):p?(0,S.localize)(12931,null,h):(0,S.localize)(12932,null,h):h===1?p?(0,S.localize)(12933,null,h):(0,S.localize)(12934,null,h):p?(0,S.localize)(12935,null,h):(0,S.localize)(12936,null,h)):b<L?(h=Math.floor(b/k),d?h===1?(0,S.localize)(12937,null,h):(0,S.localize)(12938,null,h):h===1?(0,S.localize)(12939,null,h):(0,S.localize)(12940,null,h)):b<R?(h=Math.floor(b/L),d?h===1?p?(0,S.localize)(12941,null,h):(0,S.localize)(12942,null,h):p?(0,S.localize)(12943,null,h):(0,S.localize)(12944,null,h):h===1?p?(0,S.localize)(12945,null,h):(0,S.localize)(12946,null,h):p?(0,S.localize)(12947,null,h):(0,S.localize)(12948,null,h)):b<w?(h=Math.floor(b/R),d?h===1?p?(0,S.localize)(12949,null,h):(0,S.localize)(12950,null,h):p?(0,S.localize)(12951,null,h):(0,S.localize)(12952,null,h):h===1?p?(0,S.localize)(12953,null,h):(0,S.localize)(12954,null,h):p?(0,S.localize)(12955,null,h):(0,S.localize)(12956,null,h)):(h=Math.floor(b/w),d?h===1?p?(0,S.localize)(12957,null,h):(0,S.localize)(12958,null,h):p?(0,S.localize)(12959,null,h):(0,S.localize)(12960,null,h):h===1?p?(0,S.localize)(12961,null,h):(0,S.localize)(12962,null,h):p?(0,S.localize)(12963,null,h):(0,S.localize)(12964,null,h))}function f(m,d){const p=Math.abs(m/1e3);return p<1?d?(0,S.localize)(12965,null,m):(0,S.localize)(12966,null,m):p<P?d?(0,S.localize)(12967,null,Math.round(m)/1e3):(0,S.localize)(12968,null,Math.round(m)/1e3):p<v?d?(0,S.localize)(12969,null,Math.round(m/(1e3*P))):(0,S.localize)(12970,null,Math.round(m/(1e3*P))):p<k?d?(0,S.localize)(12971,null,Math.round(m/(1e3*v))):(0,S.localize)(12972,null,Math.round(m/(1e3*v))):(0,S.localize)(12973,null,Math.round(m/(1e3*k)))}function c(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[38],ue([0,1,19,3,5]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=w,e.$pj=a,e.$qj=f,S=ye(S),P=ye(P),v=ye(v);function k(c,m){return m&&(c.stack||c.stacktrace)?v.localize(12905,null,R(c),L(c.stack)||L(c.stacktrace)):R(c)}function L(c){return Array.isArray(c)?c.join(`
`):c}function R(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?v.localize(12906,null,c.message):c.message||v.localize(12907,null)}function w(c=null,m=!1){if(!c)return v.localize(12908,null);if(Array.isArray(c)){const d=S.$Gb(c),p=w(d[0],m);return d.length>1?v.localize(12909,null,p,d.length):p}if(P.$dg(c))return c;if(c.detail){const d=c.detail;if(d.error)return k(d.error,m);if(d.exception)return k(d.exception,m)}return c.stack?k(c,m):c.message?c.message:v.localize(12910,null)}function a(c){const m=c;return m instanceof Error&&Array.isArray(m.actions)}function f(c,m){let d;return typeof c=="string"?d=new Error(c):d=c,d.actions=m,d}}),define(le[90],ue([0,1,5,34]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=v;function v(k){switch(k){case P.ParseErrorCode.InvalidSymbol:return(0,S.localize)(12896,null);case P.ParseErrorCode.InvalidNumberFormat:return(0,S.localize)(12897,null);case P.ParseErrorCode.PropertyNameExpected:return(0,S.localize)(12898,null);case P.ParseErrorCode.ValueExpected:return(0,S.localize)(12899,null);case P.ParseErrorCode.ColonExpected:return(0,S.localize)(12900,null);case P.ParseErrorCode.CommaExpected:return(0,S.localize)(12901,null);case P.ParseErrorCode.CloseBraceExpected:return(0,S.localize)(12902,null);case P.ParseErrorCode.CloseBracketExpected:return(0,S.localize)(12903,null);case P.ParseErrorCode.EndOfFileExpected:return(0,S.localize)(12904,null);default:return""}}}),define(le[50],ue([0,1,32,8,15,3,29,5]),function(Q,e,S,P,v,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=void 0,e.zip=b,e.$Bq=h,e.$Cq=O,v=ye(v),R=ye(R),e.$yq="end of central directory record signature not found";const w=new RegExp(e.$yq);class a extends Error{constructor(i,l){let n=l.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=l}}e.$zq=a;function f(y){const i=y.externalFileAttributes>>16||33188;return[448,56,7].map(l=>i&l).reduce((l,n)=>l+n,i&61440)}function c(y){if(y instanceof a)return y;let i;return w.test(y.message)&&(i="CorruptZip"),new a(i,y)}function m(y,i,l,n,s,t){const r=v.$lc(i),o=v.$ic(n,r);if(!o.startsWith(n))return Promise.reject(new Error(R.localize(12873,null,i)));const u=v.$ic(n,i);let $;return t.onCancellationRequested(()=>{$?.destroy()}),Promise.resolve(S.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((D,T)=>{if(!t.isCancellationRequested)try{$=(0,S.createWriteStream)(u,{mode:l}),$.once("close",()=>D()),$.once("error",T),y.once("error",T),y.pipe($)}catch(A){T(A)}}))}function d(y,i,l,n){let s=(0,P.$qh)(()=>Promise.resolve()),t=0;const r=n.onCancellationRequested(()=>{s.cancel(),y.close()});return new Promise((o,u)=>{const $=new P.$yh,D=T=>{T.isCancellationRequested||(t++,y.readEntry())};y.once("error",u),y.once("close",()=>s.then(()=>{n.isCancellationRequested||y.entryCount===t?o():u(new a("Incomplete",new Error(R.localize(12874,null,t,y.entryCount))))},u)),y.readEntry(),y.on("entry",T=>{if(n.isCancellationRequested)return;if(!l.sourcePathRegex.test(T.fileName)){D(n);return}const A=T.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(A)){const G=v.$ic(i,A);s=(0,P.$qh)(Z=>S.promises.mkdir(G,{recursive:!0}).then(()=>D(Z)).then(void 0,u));return}const N=I(y,T),M=f(T);s=(0,P.$qh)(G=>$.queue(()=>N.then(Z=>m(Z,A,M,i,l,G).then(()=>D(G)))).then(null,u))})}).finally(()=>r.dispose())}async function p(y,i=!1){const{open:l}=await new Promise((n,s)=>{Q(["yauzl"],n,s)}).then(ye);return new Promise((n,s)=>{l(y,i?{lazyEntries:!0}:void 0,(t,r)=>{t?s(c(t)):n((0,k.$og)(r))})})}function I(y,i){return new Promise((l,n)=>{y.openReadStream(i,(s,t)=>{s?n(c(s)):l((0,k.$og)(t))})})}async function b(y,i){const{ZipFile:l}=await new Promise((n,s)=>{Q(["yazl"],n,s)}).then(ye);return new Promise((n,s)=>{const t=new l;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,S.createWriteStream)(y);t.outputStream.pipe(r),t.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(y))})}function h(y,i,l={},n){const s=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let t=p(y,!0);return l.overwrite&&(t=t.then(r=>L.Promises.rm(i).then(()=>r))),t.then(r=>d(r,i,{sourcePathRegex:s},n))}function g(y,i){return p(y).then(l=>new Promise((n,s)=>{l.on("entry",t=>{t.fileName===i&&I(l,t).then(r=>n(r),r=>s(r))}),l.once("close",()=>s(new Error(R.localize(12875,null,i))))}))}function O(y,i){return g(y,i).then(l=>new Promise((n,s)=>{const t=[];l.once("error",s),l.on("data",r=>t.push(r)),l.on("end",()=>n(Buffer.concat(t)))}))}}),define(le[91],ue([0,1,92,7,5]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.TokenType=void 0;var k;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(k||(e.TokenType=k={}));function L(...f){switch(f.length){case 1:return(0,v.localize)(11510,null,f[0]);case 2:return(0,v.localize)(11511,null,f[0],f[1]);case 3:return(0,v.localize)(11512,null,f[0],f[1],f[2]);default:return}}const R=(0,v.localize)(11513,null),w=(0,v.localize)(11514,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return c.isTripleEq?"===":"==";case k.NotEq:return c.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return c.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return c.lexeme;case k.QuotedStr:return c.lexeme;case k.Error:return c.lexeme;case k.EOF:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(c){return this.c=c,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case S.CharCode.OpenParen:this.k(k.LParen);break;case S.CharCode.CloseParen:this.k(k.RParen);break;case S.CharCode.ExclamationMark:if(this.h(S.CharCode.Equals)){const m=this.h(S.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:m})}else this.k(k.Neg);break;case S.CharCode.SingleQuote:this.o();break;case S.CharCode.Slash:this.q();break;case S.CharCode.Equals:if(this.h(S.CharCode.Equals)){const m=this.h(S.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:m})}else this.h(S.CharCode.Tilde)?this.k(k.RegexOp):this.l(L("==","=~"));break;case S.CharCode.LessThan:this.k(this.h(S.CharCode.Equals)?k.LtEq:k.Lt);break;case S.CharCode.GreaterThan:this.k(this.h(S.CharCode.Equals)?k.GtEq:k.Gt);break;case S.CharCode.Ampersand:this.h(S.CharCode.Ampersand)?this.k(k.And):this.l(L("&&"));break;case S.CharCode.Pipe:this.h(S.CharCode.Pipe)?this.k(k.Or):this.l(L("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(c){return this.r()||this.c.charCodeAt(this.e)!==c?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?S.CharCode.Null:this.c.charCodeAt(this.e)}k(c){this.f.push({type:c,offset:this.d})}l(c){const m=this.d,d=this.c.substring(this.d,this.e),p={type:k.Error,offset:this.d,lexeme:d};this.g.push({offset:m,lexeme:d,additionalInfo:c}),this.f.push(p)}n(){this.m.lastIndex=this.d;const c=this.m.exec(this.c);if(c){this.e=this.d+c[0].length;const m=this.c.substring(this.d,this.e),d=a.b.get(m);d?this.k(d):this.f.push({type:k.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==S.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let c=this.e,m=!1,d=!1;for(;;){if(c>=this.c.length){this.e=c,this.l(w);return}const I=this.c.charCodeAt(c);if(m)m=!1;else if(I===S.CharCode.Slash&&!d){c++;break}else I===S.CharCode.OpenSquareBracket?d=!0:I===S.CharCode.Backslash?m=!0:I===S.CharCode.CloseSquareBracket&&(d=!1);c++}for(;c<this.c.length&&a.a.has(this.c.charCodeAt(c));)c++;this.e=c;const p=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$yj=a}),define(le[93],ue([0,1,89,55,14,15,36,16,11]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=void 0,e.$5m=f,e.$6m=c,e.$3m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,k.$lc)(v.$Xg.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,k.$ic)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,R.$eh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$eh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,S.$2m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$ic)(this.userDataPath,"logs",d)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$eh)(w.URI.file((0,k.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$eh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$eh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$eh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=L.env.VSCODE_PORTABLE;return d?w.URI.file((0,k.$ic)(d,"argv.json")):(0,R.$eh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,k.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,k.$jc)(d):(0,k.$gc)((0,k.$ic)(v.$Xg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?w.URI.file((0,k.$jc)(d)):w.URI.file((0,k.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,k.$jc)(d);const p=L.env.VSCODE_EXTENSIONS;if(p)return p;const I=L.env.VSCODE_PORTABLE;return I?(0,k.$ic)(I,"extensions"):(0,R.$eh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,k.$gc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,k.$gc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$3m.test(d))}get extensionLogLevel(){const d=[];for(const p of this.args.log||[]){const I=e.$3m.exec(p);I&&I[1]&&I[2]&&d.push([I[1],I[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,R.$eh)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=L.env.VSCODE_PORTABLE;return d?w.URI.file((0,k.$ic)(d,"policy.json")):(0,R.$eh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,p,I){this.a=d,this.b=p,this.c=I,this.editSessionId=this.args.editSessionId}}e.$4m=a,ve([P.$8h],a.prototype,"appRoot",null),ve([P.$8h],a.prototype,"userHome",null),ve([P.$8h],a.prototype,"userDataPath",null),ve([P.$8h],a.prototype,"appSettingsHome",null),ve([P.$8h],a.prototype,"tmpDir",null),ve([P.$8h],a.prototype,"cacheHome",null),ve([P.$8h],a.prototype,"stateResource",null),ve([P.$8h],a.prototype,"userRoamingDataHome",null),ve([P.$8h],a.prototype,"userDataSyncHome",null),ve([P.$8h],a.prototype,"sync",null),ve([P.$8h],a.prototype,"machineSettingsResource",null),ve([P.$8h],a.prototype,"workspaceStorageHome",null),ve([P.$8h],a.prototype,"localHistoryHome",null),ve([P.$8h],a.prototype,"keyboardLayoutResource",null),ve([P.$8h],a.prototype,"argvResource",null),ve([P.$8h],a.prototype,"isExtensionDevelopment",null),ve([P.$8h],a.prototype,"untitledWorkspacesHome",null),ve([P.$8h],a.prototype,"builtinExtensionsPath",null),ve([P.$8h],a.prototype,"extensionsPath",null),ve([P.$8h],a.prototype,"extensionDevelopmentLocationURI",null),ve([P.$8h],a.prototype,"extensionDevelopmentKind",null),ve([P.$8h],a.prototype,"extensionTestsLocationURI",null),ve([P.$8h],a.prototype,"debugExtensionHost",null),ve([P.$8h],a.prototype,"logLevel",null),ve([P.$8h],a.prototype,"extensionLogLevel",null),ve([P.$8h],a.prototype,"serviceMachineIdResource",null),ve([P.$8h],a.prototype,"disableTelemetry",null),ve([P.$8h],a.prototype,"disableWorkspaceTrust",null),ve([P.$8h],a.prototype,"useInMemorySecretStorage",null),ve([P.$8h],a.prototype,"policyFile",null);function f(m,d){return c(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}function c(m,d,p,I,b,h){const O=Number(d||m)||(I?null:p),y=O?!!d:!1;let i;if(h)try{i=JSON.parse(h)}catch{}return{port:O,break:y,debugId:b,env:i}}}),function(){function Q(e,S,P){function v(L,R){const w=k(L,R),a=[w];return e.isAbsolute(w)||a.unshift(P),e.resolve(...a)}function k(L,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,R);const f=L["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(c,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,R)}return{getUserDataPath:v}}if(typeof define=="function")define(le[94],ue([148,35,36]),function(e,S,P){return Q(e,S,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Q(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[95],ue([0,1,35,93,94]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$8m=L,e.$9m=R;class k extends P.$4m{constructor(a,f){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,v.getUserDataPath)(a,f.nameShort)},f)}}e.$7m=k;function L(w,a){return(0,P.$6m)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,a,w.extensionEnvironment)}function R(w,a){return(0,P.$6m)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,a,w.extensionEnvironment)}}),define(le[96],ue([0,1,3,5]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=v;function v(L,R,w,a){try{k(L,R,w,a)}catch(f){L.error(f?.message??f)}return R}function k(L,R,w,a){const f=(c,m,d)=>{const p=c[m];if((0,S.$dg)(p)){const I=p,b=I.length;if(b>1&&I[0]==="%"&&I[b-1]==="%"){const h=I.substr(1,b-2);let g=w[h];g===void 0&&a&&(g=a[h]);const O=typeof g=="string"?g:g?.message,y=a?.[h],i=typeof y=="string"?y:y?.message;if(!O){i||L.warn(`[${R.name}]: ${(0,P.localize)(11393,null,h)}`);return}if(d&&(m==="title"||m==="category")&&i&&i!==O){const l={value:O,original:i};c[m]=l}else c[m]=O}}else if((0,S.$fg)(p))for(const I in p)p.hasOwnProperty(I)&&(I==="commands"?f(p,I,!0):f(p,I,d));else if(Array.isArray(p))for(let I=0;I<p.length;I++)f(p,I,d)};for(const c in R)R.hasOwnProperty(c)&&f(R,c)}}),define(le[97],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(S)}),define(le[51],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class S{constructor(v,k=[],L=!1){this.ctor=v,this.staticArguments=k,this.supportsDelayedInstantiation=L}}e.$Ai=S}),define(le[98],ue([0,1,51]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ps=k,e.$Qs=L;const P=[];var v;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(v||(e.InstantiationType=v={}));function k(R,w,a){w instanceof S.$Ai||(w=new S.$Ai(w,[],!!a)),P.push([R,w])}function L(){return P}}),define(le[99],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class S{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$sr=S;class P{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const L of this.a.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const R=this.lookupOrInsertNode(k),w=this.lookupOrInsertNode(L);R.outgoing.set(w.key,w),w.incoming.set(R.key,R)}removeNode(k){const L=this.b(k);this.a.delete(L);for(const R of this.a.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(k){const L=this.b(k);let R=this.a.get(L);return R||(R=new S(L,k),this.a.set(L,R)),R}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[L,R]of this.a)k.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this.a){const R=new Set([k]),w=this.c(L,R);if(w)return w}}c(k,L){for(const[R,w]of k.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const a=this.c(w,L);if(a)return a;L.delete(R)}}}e.$tr=P}),define(le[30],ue([0,1,3,11,10]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$0i=void 0,e.$$i=k,e.$_i=L,e.$aj=w,e.$bj=a,e.$cj=f,e.$dj=c,e.$ej=m,e.$fj=p,e.$gj=I,e.$hj=b,S=ye(S),e.$0i=(0,v.$Di)("configurationService");function k(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof P.URI)}function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof P.URI)}var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function w(h){switch(h){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function a(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function f(h,g){const O=Object.create(null);for(const y in h)c(O,y,h[y],g);return O}function c(h,g,O,y){const i=g.split("."),l=i.pop();let n=h;for(let s=0;s<i.length;s++){const t=i[s];let r=n[t];switch(typeof r){case"undefined":r=n[t]=Object.create(null);break;case"object":if(r===null){y(`Ignoring ${g} as ${i.slice(0,s+1).join(".")} is null`);return}break;default:y(`Ignoring ${g} as ${i.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}n=r}if(typeof n=="object"&&n!==null)try{n[l]=O}catch{y(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(n)}`)}else y(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(n)}`)}function m(h,g){const O=g.split(".");d(h,O)}function d(h,g){const O=g.shift();if(g.length===0){delete h[O];return}if(Object.keys(h).indexOf(O)!==-1){const y=h[O];typeof y=="object"&&!Array.isArray(y)&&(d(y,g),Object.keys(y).length===0&&delete h[O])}}function p(h,g,O){function y(n,s){let t=n;for(const r of s){if(typeof t!="object"||t===null)return;t=t[r]}return t}const i=g.split("."),l=y(h,i);return typeof l>"u"?O:l}function I(h,g,O){Object.keys(g).forEach(y=>{y!=="__proto__"&&(y in h?S.$fg(h[y])&&S.$fg(g[y])?I(h[y],g[y],O):O&&(h[y]=g[y]):h[y]=g[y])})}function b(h){return h.replace(/[\[\]]/g,"")}}),define(le[100],ue([0,1,92,12,31,91,10,5,7]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Bj=e.$Aj=e.ContextKeyExprType=void 0,e.$zj=f,e.$Cj=s,e.$Dj=t,e.$Wj=ne;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",P.$k),a.set("isLinux",P.$l),a.set("isWindows",P.$j),a.set("isWeb",P.$p),a.set("isMacNative",P.$k&&!P.$p),a.set("isEdge",P.$I),a.set("isFirefox",P.$G),a.set("isChrome",P.$F),a.set("isSafari",P.$H);function f(q,E){if(a.get(q)!==void 0)throw(0,w.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(q,E)}const c=Object.prototype.hasOwnProperty;var m;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const d={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(11524,null),I=(0,R.localize)(11525,null),b=(0,R.localize)(11526,null),h=(0,R.localize)(11527,null),g=(0,R.localize)(11528,null),O=(0,R.localize)(11529,null),y=(0,R.localize)(11530,null),i=(0,R.localize)(11531,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(E=d){this.k=E,this.d=new k.$yj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(E){if(E===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:I});return}this.f=this.d.reset(E).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const U=this.D(),C=U.type===k.TokenType.Str?O:void 0;throw this.h.push({message:g,offset:U.offset,lexeme:k.$yj.getLexeme(U),additionalInfo:C}),l.c}return j}catch(j){if(j!==l.c)throw j;return}}l(){return this.m()}m(){const E=[this.o()];for(;this.y(k.TokenType.Or);){const j=this.o();E.push(j)}return E.length===1?E[0]:n.or(...E)}o(){const E=[this.s()];for(;this.y(k.TokenType.And);){const j=this.s();E.push(j)}return E.length===1?E[0]:n.and(...E)}s(){if(this.y(k.TokenType.Neg)){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),u.INSTANCE;case k.TokenType.LParen:{this.z();const j=this.l();return this.A(k.TokenType.RParen,h),j?.negate()}case k.TokenType.Str:return this.z(),M.create(E.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",E)}}return this.t()}t(){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),n.true();case k.TokenType.False:return this.z(),n.false();case k.TokenType.LParen:{this.z();const j=this.l();return this.A(k.TokenType.RParen,h),j}case k.TokenType.Str:{const j=E.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==k.TokenType.RegexStr)throw this.B("REGEX",C);const H=C.lexeme,J=H.lastIndexOf("/"),se=J===H.length-1?void 0:this.w(H.substring(J+1));let ae;try{ae=new RegExp(H.substring(1,J),se)}catch{throw this.B("REGEX",C)}return fe.create(j,ae)}switch(C.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const H=[C.lexeme];this.z();let J=this.D(),se=0;for(let we=0;we<C.lexeme.length;we++)C.lexeme.charCodeAt(we)===S.CharCode.OpenParen?se++:C.lexeme.charCodeAt(we)===S.CharCode.CloseParen&&se--;for(;!this.E()&&J.type!==k.TokenType.And&&J.type!==k.TokenType.Or;){switch(J.type){case k.TokenType.LParen:se++;break;case k.TokenType.RParen:se--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let we=0;we<J.lexeme.length;we++)J.lexeme.charCodeAt(we)===S.CharCode.OpenParen?se++:C.lexeme.charCodeAt(we)===S.CharCode.CloseParen&&se--}if(se<0)break;H.push(k.$yj.getLexeme(J)),this.z(),J=this.D()}const ae=H.join(""),de=ae.lastIndexOf("/"),me=de===ae.length-1?void 0:this.w(ae.substring(de+1));let ge;try{ge=new RegExp(ae.substring(1,de),me)}catch{throw this.B("REGEX",C)}return n.regex(j,ge)}case k.TokenType.QuotedStr:{const H=C.lexeme;this.z();let J=null;if(!(0,v.$bf)(H)){const se=H.indexOf("/"),ae=H.lastIndexOf("/");if(se!==ae&&se>=0){const de=H.slice(se+1,ae),me=H[ae+1]==="i"?"i":"";try{J=new RegExp(de,me)}catch{throw this.B("REGEX",C)}}}if(J===null)throw this.B("REGEX",C);return fe.create(j,J)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,b);const C=this.u();return n.notIn(j,C)}switch(this.D().type){case k.TokenType.Eq:{this.z();const C=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.equals(j,C);switch(C){case"true":return n.has(j);case"false":return n.not(j);default:return n.equals(j,C)}}case k.TokenType.NotEq:{this.z();const C=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.notEquals(j,C);switch(C){case"true":return n.not(j);case"false":return n.has(j);default:return n.notEquals(j,C)}}case k.TokenType.Lt:return this.z(),oe.create(j,this.u());case k.TokenType.LtEq:return this.z(),ce.create(j,this.u());case k.TokenType.Gt:return this.z(),Z.create(j,this.u());case k.TokenType.GtEq:return this.z(),ee.create(j,this.u());case k.TokenType.In:return this.z(),n.in(j,this.u());default:return n.has(j)}}case k.TokenType.EOF:throw this.h.push({message:y,offset:E.offset,lexeme:"",additionalInfo:i}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const E=this.D();switch(E.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),E.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(E){return E.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(E){return this.C(E)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(E,j){if(this.C(E))return this.z();throw this.B(j,this.D())}B(E,j,U){const C=(0,R.localize)(11532,null,E,k.$yj.getLexeme(j)),H=j.offset,J=k.$yj.getLexeme(j);return this.h.push({message:C,offset:H,lexeme:J,additionalInfo:U}),l.c}C(E){return this.D().type===E}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Aj=l;class n{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(E){return $.create(E)}static equals(E,j){return D.create(E,j)}static notEquals(E,j){return N.create(E,j)}static regex(E,j){return fe.create(E,j)}static in(E,j){return T.create(E,j)}static notIn(E,j){return A.create(E,j)}static not(E){return M.create(E)}static and(...E){return B.create(E,null,!0)}static or(...E){return z.create(E,null,!0)}static greater(E,j){return Z.create(E,j)}static greaterEquals(E,j){return ee.create(E,j)}static smaller(E,j){return oe.create(E,j)}static smallerEquals(E,j){return ce.create(E,j)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(E){return E==null?void 0:this.c.parse(E)}}e.$Bj=n;function s(q){const E=new l({regexParsingWithErrorRecovery:!1});return q.map(j=>(E.parse(j),E.lexingErrors.length>0?E.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,R.localize)(11533,null,U.additionalInfo):(0,R.localize)(11534,null),offset:U.offset,length:U.lexeme.length})):E.parsingErrors.length>0?E.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function t(q,E){const j=q?q.substituteConstants():void 0,U=E?E.substituteConstants():void 0;return!j&&!U?!0:!j||!U?!1:j.equals(U)}function r(q,E){return q.cmp(E)}class o{static{this.INSTANCE=new o}constructor(){this.type=m.False}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return u.INSTANCE}}e.$Ej=o;class u{static{this.INSTANCE=new u}constructor(){this.type=m.True}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return o.INSTANCE}}e.$Fj=u;class ${static create(E,j=null){const U=a.get(E);return typeof U=="boolean"?U?u.INSTANCE:o.INSTANCE:new $(E,j)}constructor(E,j){this.key=E,this.c=j,this.type=m.Defined}cmp(E){return E.type!==this.type?this.type-E.type:X(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=a.get(this.key);return typeof E=="boolean"?E?u.INSTANCE:o.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Gj=$;class D{static create(E,j,U=null){if(typeof j=="boolean")return j?$.create(E,U):M.create(E,U);const C=a.get(E);return typeof C=="boolean"?j===(C?"true":"false")?u.INSTANCE:o.INSTANCE:new D(E,j,U)}constructor(E,j,U){this.c=E,this.d=j,this.f=U,this.type=m.Equals}cmp(E){return E.type!==this.type?this.type-E.type:te(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=a.get(this.c);if(typeof E=="boolean"){const j=E?"true":"false";return this.d===j?u.INSTANCE:o.INSTANCE}return this}evaluate(E){return E.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(E){return E.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Hj=D;class T{static create(E,j){return new T(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=m.In,this.c=null}cmp(E){return E.type!==this.type?this.type-E.type:te(this.d,this.f,E.d,E.f)}equals(E){return E.type===this.type?this.d===E.d&&this.f===E.f:!1}substituteConstants(){return this}evaluate(E){const j=E.getValue(this.f),U=E.getValue(this.d);return Array.isArray(j)?j.includes(U):typeof U=="string"&&typeof j=="object"&&j!==null?c.call(j,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(E){return E.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Ij=T;class A{static create(E,j){return new A(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=m.NotIn,this.c=T.create(E,j)}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(E){return E.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Jj=A;class N{static create(E,j,U=null){if(typeof j=="boolean")return j?M.create(E,U):$.create(E,U);const C=a.get(E);return typeof C=="boolean"?j===(C?"true":"false")?o.INSTANCE:u.INSTANCE:new N(E,j,U)}constructor(E,j,U){this.c=E,this.d=j,this.f=U,this.type=m.NotEquals}cmp(E){return E.type!==this.type?this.type-E.type:te(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=a.get(this.c);if(typeof E=="boolean"){const j=E?"true":"false";return this.d===j?o.INSTANCE:u.INSTANCE}return this}evaluate(E){return E.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(E){return E.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Kj=N;class M{static create(E,j=null){const U=a.get(E);return typeof U=="boolean"?U?o.INSTANCE:u.INSTANCE:new M(E,j)}constructor(E,j){this.c=E,this.d=j,this.type=m.Not}cmp(E){return E.type!==this.type?this.type-E.type:X(this.c,E.c)}equals(E){return E.type===this.type?this.c===E.c:!1}substituteConstants(){const E=a.get(this.c);return typeof E=="boolean"?E?o.INSTANCE:u.INSTANCE:this}evaluate(E){return!E.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(E){return E.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Lj=M;function G(q,E){if(typeof q=="string"){const j=parseFloat(q);isNaN(j)||(q=j)}return typeof q=="string"||typeof q=="number"?E(q):o.INSTANCE}class Z{static create(E,j,U=null){return G(j,C=>new Z(E,C,U))}constructor(E,j,U){this.c=E,this.d=j,this.f=U,this.type=m.Greater}cmp(E){return E.type!==this.type?this.type-E.type:te(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Mj=Z;class ee{static create(E,j,U=null){return G(j,C=>new ee(E,C,U))}constructor(E,j,U){this.c=E,this.d=j,this.f=U,this.type=m.GreaterEquals}cmp(E){return E.type!==this.type?this.type-E.type:te(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$Nj=ee;class oe{static create(E,j,U=null){return G(j,C=>new oe(E,C,U))}constructor(E,j,U){this.c=E,this.d=j,this.f=U,this.type=m.Smaller}cmp(E){return E.type!==this.type?this.type-E.type:te(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Oj=oe;class ce{static create(E,j,U=null){return G(j,C=>new ce(E,C,U))}constructor(E,j,U){this.c=E,this.d=j,this.f=U,this.type=m.SmallerEquals}cmp(E){return E.type!==this.type?this.type-E.type:te(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Pj=ce;class fe{static create(E,j){return new fe(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=m.Regex,this.c=null}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.d<E.d)return-1;if(this.d>E.d)return 1;const j=this.f?this.f.source:"",U=E.f?E.f.source:"";return j<U?-1:j>U?1:0}equals(E){if(E.type===this.type){const j=this.f?this.f.source:"",U=E.f?E.f.source:"";return this.d===E.d&&j===U}return!1}substituteConstants(){return this}evaluate(E){const j=E.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const E=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${E}`}keys(){return[this.d]}map(E){return E.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$Qj=fe;class x{static create(E){return new x(E)}constructor(E){this.c=E,this.type=m.NotRegex}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(E){return new x(this.c.map(E))}negate(){return this.c}}e.$Rj=x;function Y(q){let E=null;for(let j=0,U=q.length;j<U;j++){const C=q[j].substituteConstants();if(q[j]!==C&&E===null){E=[];for(let H=0;H<j;H++)E[H]=q[H]}E!==null&&(E[j]=C)}return E===null?q:E}class B{static create(E,j,U){return B.d(E,j,U)}constructor(E,j){this.expr=E,this.c=j,this.type=m.And}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let j=0,U=this.expr.length;j<U;j++){const C=r(this.expr[j],E.expr[j]);if(C!==0)return C}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let j=0,U=this.expr.length;j<U;j++)if(!this.expr[j].equals(E.expr[j]))return!1;return!0}return!1}substituteConstants(){const E=Y(this.expr);return E===this.expr?this:B.create(E,this.c,!1)}evaluate(E){for(let j=0,U=this.expr.length;j<U;j++)if(!this.expr[j].evaluate(E))return!1;return!0}static d(E,j,U){const C=[];let H=!1;for(const J of E)if(J){if(J.type===m.True){H=!0;continue}if(J.type===m.False)return o.INSTANCE;if(J.type===m.And){C.push(...J.expr);continue}C.push(J)}if(C.length===0&&H)return u.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(r);for(let J=1;J<C.length;J++)C[J-1].equals(C[J])&&(C.splice(J,1),J--);if(C.length===1)return C[0];for(;C.length>1;){const J=C[C.length-1];if(J.type!==m.Or)break;C.pop();const se=C.pop(),ae=C.length===0,de=z.create(J.expr.map(me=>B.create([me,se],null,U)),null,ae);de&&(C.push(de),C.sort(r))}if(C.length===1)return C[0];if(U){for(let J=0;J<C.length;J++)for(let se=J+1;se<C.length;se++)if(C[J].negate().equals(C[se]))return o.INSTANCE;if(C.length===1)return C[0]}return new B(C,j)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(const j of this.expr)E.push(...j.keys());return E}map(E){return new B(this.expr.map(j=>j.map(E)),null)}negate(){if(!this.c){const E=[];for(const j of this.expr)E.push(j.negate());this.c=z.create(E,this,!0)}return this.c}}e.$Sj=B;class z{static create(E,j,U){return z.d(E,j,U)}constructor(E,j){this.expr=E,this.c=j,this.type=m.Or}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let j=0,U=this.expr.length;j<U;j++){const C=r(this.expr[j],E.expr[j]);if(C!==0)return C}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let j=0,U=this.expr.length;j<U;j++)if(!this.expr[j].equals(E.expr[j]))return!1;return!0}return!1}substituteConstants(){const E=Y(this.expr);return E===this.expr?this:z.create(E,this.c,!1)}evaluate(E){for(let j=0,U=this.expr.length;j<U;j++)if(this.expr[j].evaluate(E))return!0;return!1}static d(E,j,U){let C=[],H=!1;if(E){for(let J=0,se=E.length;J<se;J++){const ae=E[J];if(ae){if(ae.type===m.False){H=!0;continue}if(ae.type===m.True)return u.INSTANCE;if(ae.type===m.Or){C=C.concat(ae.expr);continue}C.push(ae)}}if(C.length===0&&H)return o.INSTANCE;C.sort(r)}if(C.length!==0){if(C.length===1)return C[0];for(let J=1;J<C.length;J++)C[J-1].equals(C[J])&&(C.splice(J,1),J--);if(C.length===1)return C[0];if(U){for(let J=0;J<C.length;J++)for(let se=J+1;se<C.length;se++)if(C[J].negate().equals(C[se]))return u.INSTANCE;if(C.length===1)return C[0]}return new z(C,j)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(const j of this.expr)E.push(...j.keys());return E}map(E){return new z(this.expr.map(j=>j.map(E)),null)}negate(){if(!this.c){const E=[];for(const j of this.expr)E.push(j.negate());for(;E.length>1;){const j=E.shift(),U=E.shift(),C=[];for(const H of V(j))for(const J of V(U))C.push(B.create([H,J],null,!1));E.unshift(z.create(C,null,!1))}this.c=z.create(E,this,!0)}return this.c}}e.$Tj=z;class K extends ${static{this.d=[]}static all(){return K.d.values()}constructor(E,j,U){super(E,null),this.f=j,typeof U=="object"?K.d.push({...U,key:E}):U!==!0&&K.d.push({key:E,description:U,type:j!=null?typeof j:void 0})}bindTo(E){return E.createKey(this.key,this.f)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return D.create(this.key,E)}notEqualsTo(E){return N.create(this.key,E)}}e.$Uj=K,e.$Vj=(0,L.$Di)("contextKeyService");function X(q,E){return q<E?-1:q>E?1:0}function te(q,E,j,U){return q<j?-1:q>j?1:E<U?-1:E>U?1:0}function ne(q,E){if(q.type===m.False||E.type===m.True)return!0;if(q.type===m.Or)return E.type===m.Or?F(q.expr,E.expr):!1;if(E.type===m.Or){for(const j of E.expr)if(ne(q,j))return!0;return!1}if(q.type===m.And){if(E.type===m.And)return F(E.expr,q.expr);for(const j of q.expr)if(ne(j,E))return!0;return!1}return q.equals(E)}function F(q,E){let j=0,U=0;for(;j<q.length&&U<E.length;){const C=q[j].cmp(E[U]);if(C<0)return!1;C===0&&j++,U++}return j===q.length}function V(q){return q.type===m.Or?q.expr:[q]}}),define(le[61],ue([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=void 0,e.$Zo=(0,S.$Di)("downloadService")}),define(le[17],ue([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=void 0,e.$Ki=(0,S.$Di)("environmentService"),e.$Li=(0,S.$Ei)(e.$Ki)}),define(le[62],ue([0,1,13,7,5,9]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=L;async function L(f,c,m,d,p,I){let b;try{await R(f,c,m,d,p,I)}catch(h){b=h}finally{b&&p.errorTransformer&&(b=p.errorTransformer(b)),typeof b<"u"&&m.error(b),m.end()}}async function R(f,c,m,d,p,I){w(I);const b=await f.open(c,{create:!1});try{w(I);let h=0,g=0,O=p&&typeof p.length=="number"?p.length:void 0,y=S.$Me.alloc(Math.min(p.bufferSize,typeof O=="number"?O:p.bufferSize)),i=p&&typeof p.position=="number"?p.position:0,l=0;do g=await f.read(b,i,y.buffer,l,y.byteLength-l),i+=g,l+=g,h+=g,typeof O=="number"&&(O-=g),l===y.byteLength&&(await m.write(d(y)),y=S.$Me.alloc(Math.min(p.bufferSize,typeof O=="number"?O:p.bufferSize)),l=0);while(g>0&&(typeof O!="number"||O>0)&&w(I)&&a(h,p));if(l>0){let n=l;typeof O=="number"&&(n=Math.min(l,O)),m.write(d(y.slice(0,n)))}}catch(h){throw(0,k.$ml)(h)}finally{await f.close(b)}}function w(f){if(f.isCancellationRequested)throw(0,P.$5)();return!0}function a(f,c){if(typeof c?.limits?.size=="number"&&f>c.limits.size)throw(0,k.$ll)((0,v.localize)(11309,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[101],ue([0,1,32,2,52,4,9,11,8]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class a extends P.$Tc{constructor(){super(),this.a=this.B(new k.$ke),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$ke),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$ke),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new P.$3c),this.m=new Set,this.n=this.B(new w.$Bh(this.y())),this.r=5007,this.s=new w.$1h,this.R=!1,this.B(this.f(c=>this.t(c)))}t(c){this.u(c)&&this.z(c)}u(c){return(0,v.$2q)(c)}async watch(c){this.s.isSettled||this.s.complete(),this.s=new w.$1h;try{this.h.clear(),this.g.clear();for(const m of c)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(c){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),c?this.y():0)}y(){return 800}isSuspended(c){return typeof c.correlationId!="number"?!1:this.m.has(c.correlationId)?"polling":this.j.has(c.correlationId)}async z(c){if(this.j.has(c.correlationId))return;const m=new P.$Sc;this.j.set(c.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(c,m),this.w(!0))}C(c){this.j.deleteAndDispose(c.correlationId),this.m.delete(c.correlationId),this.w(!1)}D(c,m){this.F(c,m)?(this.P(`reusing an existing recursive watcher to monitor ${c.path}`),this.m.delete(c.correlationId)):(this.G(c,m),this.m.add(c.correlationId))}F(c,m){const d=this.O?.subscribe(c.path,(p,I)=>{m.isDisposed||(p?this.D(c,m):I?.type===L.FileChangeType.ADDED&&this.H(c))});return d?(m.add(d),!0):!1}G(c,m){let d=!1;const p=(I,b)=>{if(m.isDisposed)return;const h=this.I(I),g=this.I(b),O=d;d=h,!h&&(g||O)&&this.H(c)};this.P(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.watchFile)(c.path,{persistent:!1,interval:this.r},p)}catch(I){this.Q(`fs.watchFile() failed with error ${I} on path ${c.path} (correlationId: ${c.correlationId})`)}m.add((0,P.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.unwatchFile)(c.path,p)}catch(I){this.Q(`fs.unwatchFile() failed with error ${I} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}H(c){this.P(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const m={resource:R.URI.file(c.path),type:L.FileChangeType.ADDED,cId:c.correlationId};this.a.fire([m]),this.J(m,c),this.C(c)}I(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(c,m){if(this.R){const d=` >> normalized ${c.type===L.FileChangeType.ADDED?"[ADDED]":c.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.L(d,m)}}L(c,m){this.R&&this.P(`${c}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,v.$_q)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.R=c}}e.$ir=a}),define(le[102],ue([0,1,4,149,101,12,150,63]),function(Q,e,S,P,v,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class w extends v.$ir{constructor(f){super(),this.O=f,this.onDidError=S.Event.None,this.watchers=new Set}async N(f){f=this.Z(f);const c=[],m=new Set(Array.from(this.watchers));for(const d of f){const p=this.W(d);p&&(0,P.$Ck)(p.request.excludes,d.excludes)&&(0,P.$Ck)(p.request.includes,d.includes)?m.delete(p):c.push(d)}c.length&&this.P(`Request to start watching: ${c.map(d=>this.M(d)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(d=>this.M(d.request)).join(",")}`);for(const d of m)this.Y(d);for(const d of c)this.X(d)}W(f){for(const c of this.watchers)if(typeof f.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===f.correlationId)return c}else if((0,R.$Bg)(c.request.path,f.path,!k.$l))return c}X(f){const c=new L.$nr(f,this.O,d=>this.a.fire(d),()=>this.c.fire(f),d=>this.b.fire(d),this.R),m={request:f,instance:c};this.watchers.add(m)}async stop(){await super.stop();for(const f of this.watchers)this.Y(f)}Y(f){this.P("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}Z(f){const c=new Map;for(const m of f){const d=k.$l?m.path:m.path.toLowerCase();let p=c.get(m.correlationId);p||(p=new Map,c.set(m.correlationId,p)),p.has(d)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),p.set(d,m)}return Array.from(c.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const c of this.watchers)c.instance.setVerboseLogging(f)}P(f,c){this.R&&this.b.fire({type:"trace",message:this.bb(f,c)})}Q(f){this.b.fire({type:"warn",message:this.bb(f)})}bb(f,c){return c?`[File Watcher (node.js)] ${f} (${this.M(c.request)})`:`[File Watcher (node.js)] ${f}`}}e.$pr=w}),define(le[103],ue([0,1,52,102]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class v extends S.$5q{constructor(L,R,w){super(L,R,w),this.s()}r(L){return L.add(new P.$pr(void 0))}}e.$qr=v}),define(le[104],ue([0,1,14,59,87,52]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class L extends k.$6q{constructor(w,a,f){super(w,a,f),this.s()}r(w){const a=w.add(new v.$gr(S.$Xg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(a.onDidProcessExit(({code:f,signal:c})=>this.t(`terminated by itself with code ${f}, signal: ${c} (ETERM)`))),P.ProxyChannel.toService((0,P.$ki)(a.getChannel("watcher")))}}e.$hr=L}),define(le[64],ue([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class S{constructor(...v){this.a=new Map;for(const[k,L]of v)this.set(k,L)}set(v,k){const L=this.a.get(v);return this.a.set(v,k),L}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}e.$Bi=S}),define(le[105],ue([0,1,8,7,2,51,99,10,64,151]),function(Q,e,S,P,v,k,L,R,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=void 0;const f=!1;class c extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class m{constructor(b=new w.$Bi,h=!1,g,O=f){this.i=b,this.j=h,this.k=g,this.l=O,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$Ci,this),this._globalGraph=O?g?._globalGraph??new L.$tr(y=>y):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Oc)(this.h),this.h.clear();for(const b of this.g)(0,v.$Nc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,h){this.m();const g=this,O=new class extends m{dispose(){g.h.delete(O),super.dispose()}}(b,this.j,this,this.l);return this.h.add(O),h?.add(O),O}invokeFunction(b,...h){this.m();const g=p.traceInvocation(this.l,b);let O=!1;try{return b({get:i=>{if(O)throw(0,P.$7)("service accessor is only valid during the invocation of its target method");const l=this.s(i,g);if(!l)throw new Error(`[invokeFunction] unknown service '${i}'`);return l}},...h)}finally{O=!0,g.stop()}}createInstance(b,...h){this.m();let g,O;return b instanceof k.$Ai?(g=p.traceCreation(this.l,b.ctor),O=this.o(b.ctor,b.staticArguments.concat(h),g)):(g=p.traceCreation(this.l,b),O=this.o(b,h,g)),g.stop(),O}o(b,h=[],g){const O=R._util.getServiceDependencies(b).sort((l,n)=>l.index-n.index),y=[];for(const l of O){const n=this.s(l.id,g);n||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${l.id}.`,!1),y.push(n)}const i=O.length>0?O[0].index:h.length;if(h.length!==i){console.trace(`[createInstance] First service dependency of ${b.name} at position ${i+1} conflicts with ${h.length} static arguments`);const l=i-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,i)}return Reflect.construct(b,h.concat(y))}q(b,h){if(this.i.get(b)instanceof k.$Ai)this.i.set(b,h);else if(this.k)this.k.q(b,h);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const h=this.i.get(b);return!h&&this.k?this.k.r(b):h}s(b,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const g=this.r(b);return g instanceof k.$Ai?this.u(b,g,h.branch(b,!0)):(h.branch(b,!1),g)}u(b,h,g){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,h,g)}finally{this.t.delete(b)}}v(b,h,g){const O=new L.$tr(n=>n.id.toString());let y=0;const i=[{id:b,desc:h,_trace:g}],l=new Set;for(;i.length;){const n=i.pop();if(!l.has(String(n.id))){if(l.add(String(n.id)),O.lookupOrInsertNode(n),y++>1e3)throw new c(O);for(const s of R._util.getServiceDependencies(n.desc.ctor)){const t=this.r(s.id);if(t||this.y(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),t instanceof k.$Ai){const r={id:s.id,desc:t,_trace:n._trace.branch(s.id,!0)};O.insertEdge(n,r),i.push(r)}}}}for(;;){const n=O.roots();if(n.length===0){if(!O.isEmpty())throw new c(O);break}for(const{data:s}of n){if(this.r(s.id)instanceof k.$Ai){const r=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,r)}O.removeNode(s)}}return this.r(b)}w(b,h,g=[],O,y){if(this.i.get(b)instanceof k.$Ai)return this.x(b,h,g,O,y,this.g);if(this.k)return this.k.w(b,h,g,O,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}x(b,h,g=[],O,y,i){if(O){const l=new m(void 0,this.j,this,this.l);l.c=String(b);const n=new Map,s=new S.$Wh(()=>{const t=l.o(h,g,y);for(const[r,o]of n){const u=t[r];if(typeof u=="function")for(const $ of o)$.disposable=u.apply(t,$.listener)}return n.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,r){if(!s.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let $=n.get(r);return $||($=new a.$4c,n.set(r,$)),(T,A,N)=>{if(s.isInitialized)return s.value[r](T,A,N);{const M={listener:[T,A,N],disposable:void 0},G=$.push(M);return(0,v.$Rc)(()=>{G(),M.disposable?.dispose()})}}}if(r in t)return t[r];const o=s.value;let u=o[r];return typeof u!="function"||(u=u.bind(o),t[r]=u),u},set(t,r,o){return s.value[r]=o,!0},getPrototypeOf(t){return h.prototype}})}else{const l=this.o(h,g,y);return i.add(l),l}}y(b,h){if(h&&console.warn(b),this.j)throw new Error(b)}}e.$ur=m;var d;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(d||(d={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(d.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,h){return b?new p(d.Invocation,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(b,h){return b?new p(d.Creation,h.name):p.c}static{this.f=0}constructor(b,h){this.type=b,this.name=h,this.g=Date.now(),this.h=[]}branch(b,h){const g=new p(d.Branch,b.toString());return this.h.push([b,h,g]),g}stop(){const b=Date.now()-this.g;p.f+=b;let h=!1;function g(y,i){const l=[],n=new Array(y+1).join("	");for(const[s,t,r]of i.h)if(t&&r){h=!0,l.push(`${n}CREATES -> ${s}`);const o=g(y+1,r);o&&l.push(o)}else l.push(`${n}uses -> ${s}`);return l.join(`
`)}const O=[`${this.type===d.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(b>2||h)&&p.all.add(O.join(`
`))}}e.$vr=p}),define(le[6],ue([0,1,5,38,4,43,2,25,12,16,3,11,100,10]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$bk=e.LogLevel=e.$_j=e.$$j=void 0,e.$ak=I,e.log=h,e.$mk=u,e.$nk=$,e.$ok=D,e.$pk=T,S=ye(S),e.$$j=(0,d.$Di)("logService"),e.$_j=(0,d.$Di)("loggerService");function p(){return new Date().toISOString()}function I(A){return(0,f.$hg)(A)}var b;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$bk=b.Info;function h(A,N,M){switch(N){case b.Trace:A.trace(M);break;case b.Debug:A.debug(M);break;case b.Info:A.info(M);break;case b.Warning:A.warn(M);break;case b.Error:A.error(M);break;case b.Off:break;default:throw new Error(`Invalid log level ${N}`)}}function g(A,N=!1){let M="";for(let G=0;G<A.length;G++){let Z=A[G];if(Z instanceof Error&&(Z=(0,P.$oj)(Z,N)),typeof Z=="object")try{Z=JSON.stringify(Z)}catch{}M+=(G>0?" ":"")+Z}return M}class O extends L.$Tc{constructor(){super(...arguments),this.b=e.$bk,this.c=this.B(new v.$ke),this.onDidChangeLogLevel=this.c.event}setLevel(N){this.b!==N&&(this.b=N,this.c.fire(this.b))}getLevel(){return this.b}f(N){return this.b!==b.Off&&this.b<=N}}e.$dk=O;class y extends O{constructor(N){super(),this.h=N}f(N){return this.h||super.f(N)}trace(N,...M){this.f(b.Trace)&&this.g(b.Trace,g([N,...M],!0))}debug(N,...M){this.f(b.Debug)&&this.g(b.Debug,g([N,...M]))}info(N,...M){this.f(b.Info)&&this.g(b.Info,g([N,...M]))}warn(N,...M){this.f(b.Warning)&&this.g(b.Warning,g([N,...M]))}error(N,...M){if(this.f(b.Error))if(N instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=N.stack,this.g(b.Error,g(G))}else this.g(b.Error,g([N,...M]))}flush(){}}e.$ek=y;class i extends O{constructor(N=e.$bk){super(),this.setLevel(N),this.g=!w.$j}trace(N,...M){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,N,...M):console.log(`[main ${p()}]`,N,...M))}debug(N,...M){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,N,...M):console.log(`[main ${p()}]`,N,...M))}info(N,...M){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,N,...M):console.log(`[main ${p()}]`,N,...M))}warn(N,...M){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,N,...M):console.warn(`[main ${p()}]`,N,...M))}error(N,...M){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,N,...M):console.error(`[main ${p()}]`,N,...M))}flush(){}}e.$fk=i;class l extends O{constructor(N=e.$bk,M=!0){super(),this.g=M,this.setLevel(N)}trace(N,...M){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",N,...M):console.log(N,...M))}debug(N,...M){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",N,...M):console.log(N,...M))}info(N,...M){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",N,...M):console.log(N,...M))}warn(N,...M){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",N,...M):console.log(N,...M))}error(N,...M){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",N,...M):console.error(N,...M))}flush(){}}e.$gk=l;class n extends O{constructor(N,M=e.$bk){super(),this.g=N,this.setLevel(M)}trace(N,...M){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(N),...M])}debug(N,...M){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(N),...M])}info(N,...M){this.f(b.Info)&&this.g.log(b.Info,[this.h(N),...M])}warn(N,...M){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(N),...M])}error(N,...M){this.f(b.Error)&&this.g.log(b.Error,[this.h(N),...M])}h(N){return typeof N=="string"?N:(0,P.$oj)(N,this.f(b.Trace))}flush(){}}e.$hk=n;class s extends O{constructor(N){super(),this.g=N,N.length&&this.setLevel(N[0].getLevel())}setLevel(N){for(const M of this.g)M.setLevel(N);super.setLevel(N)}trace(N,...M){for(const G of this.g)G.trace(N,...M)}debug(N,...M){for(const G of this.g)G.debug(N,...M)}info(N,...M){for(const G of this.g)G.info(N,...M)}warn(N,...M){for(const G of this.g)G.warn(N,...M)}error(N,...M){for(const G of this.g)G.error(N,...M)}flush(){for(const N of this.g)N.flush()}dispose(){for(const N of this.g)N.dispose();super.dispose()}}e.$ik=s;class t extends L.$Tc{constructor(N,M,G){if(super(),this.h=N,this.j=M,this.b=new R.$zc,this.c=this.B(new v.$ke),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$ke),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$ke),this.onDidChangeVisibility=this.g.event,G)for(const Z of G)this.b.set(Z.resource,{logger:void 0,info:Z})}m(N){return(0,f.$dg)(N)?[...this.b.values()].find(M=>M.info.id===N):this.b.get(N)}getLogger(N){return this.m(N)?.logger}createLogger(N,M){const G=this.n(N),Z=(0,f.$dg)(N)?N:M?.id??(0,k.$rj)(G.toString()).toString(16);let ee=this.b.get(G)?.logger;const oe=M?.logLevel==="always"?b.Trace:M?.logLevel;ee||(ee=this.s(G,oe??this.getLogLevel(G)??this.h,{...M,id:Z}));const ce={logger:ee,info:{resource:G,id:Z,logLevel:oe,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ce.info),this.b.set(G,ce),ee}n(N){return(0,f.$dg)(N)?(0,a.$eh)(this.j,`${N}.log`):N}setLogLevel(N,M){if(c.URI.isUri(N)){const G=N,Z=M,ee=this.b.get(G);ee&&Z!==ee.info.logLevel&&(ee.info.logLevel=Z===this.h?void 0:Z,ee.logger?.setLevel(Z),this.b.set(ee.info.resource,ee),this.f.fire([G,Z]))}else{this.h=N;for(const[G,Z]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&Z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(N,M){const G=this.m(N);G&&M!==!G.info.hidden&&(G.info.hidden=!M,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,M]))}getLogLevel(N){let M;return N&&(M=this.b.get(N)?.info.logLevel),M??this.h}registerLogger(N){const M=this.b.get(N.resource);M?M.info.hidden!==N.hidden&&this.setVisibility(N.resource,!N.hidden):(this.b.set(N.resource,{info:N,logger:void 0}),this.c.fire({added:[N],removed:[]}))}deregisterLogger(N){const M=this.b.get(N);M&&(M.logger&&M.logger.dispose(),this.b.delete(N),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const N of this.b.values())yield N.info}getRegisteredLogger(N){return this.b.get(N)?.info}dispose(){this.b.forEach(N=>N.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jk=t;class r{constructor(){this.onDidChangeLogLevel=new v.$ke().event}setLevel(N){}getLevel(){return b.Info}trace(N,...M){}debug(N,...M){}info(N,...M){}warn(N,...M){}error(N,...M){}critical(N,...M){}dispose(){}flush(){}}e.$kk=r;class o extends r{}e.$lk=o;function u(A){if(A.verbose)return b.Trace;if(typeof A.logLevel=="string"){const N=T(A.logLevel.toLowerCase());if(N!==void 0)return N}return e.$bk}function $(A){switch(A){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function D(A){switch(A){case b.Trace:return{original:"Trace",value:S.localize(11243,null)};case b.Debug:return{original:"Debug",value:S.localize(11244,null)};case b.Info:return{original:"Info",value:S.localize(11245,null)};case b.Warning:return{original:"Warning",value:S.localize(11246,null)};case b.Error:return{original:"Error",value:S.localize(11247,null)};case b.Off:return{original:"Off",value:S.localize(11248,null)}}}function T(A){switch(A){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$qk=new m.$Uj("logLevel",$(b.Info))}),define(le[106],ue([0,1,19,8,7,4,63,2,15,52,6]),function(Q,e,S,P,v,k,L,R,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class c extends R.$Tc{constructor(d,p){super(),this.a=d,this.b=p,this.c=this.B(new k.$ke),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$ke),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new P.$Bh(0)),this.w=[],this.y=this.B(new P.$Bh(0))}watch(d,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(d,p):this.z(d,p)}n(d,p){const I={path:this.J(d),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},b=(0,S.$Sb)(this.j,I);return this.r(),(0,R.$Rc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,v.$Y)(d))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,a.$7q)(p)),p=>this.G(p),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const p of this.j)(0,a.$3q)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const p of this.j)(0,a.$3q)(p)&&d.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,p){const I={path:this.J(d),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},b=(0,S.$Sb)(this.w,I);return this.C(),(0,R.$Rc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,v.$Y)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,a.$7q)(d)),d=>this.G(d),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.H(d)}H(d){this.a[d.type](d.message)}I(d){return(0,w.$gc)(d.fsPath)}J(d){const p=this.I(d);return(0,L.$Fg)(p)}}e.$ar=c});var re=this&&this.__param||function(Q,e){return function(S,P){e(S,P,Q)}};define(le[107],ue([0,1,19,8,13,21,4,43,65,2,49,14,108,16,47,5,9,62,6,7]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g,O){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let i=class extends a.$Tc{static{y=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new L.$ke),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$ke),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$ke),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$ke),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$ke),this.Y=this.B(new L.$ke),this.onDidFilesChange=this.Y.event,this.Z=this.B(new L.$ke),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new P.$Mh)}registerProvider(n,s){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${n}`);const t=new a.$Sc;return this.h.set(n,s),this.c.fire({added:!0,scheme:n,provider:s}),t.add(s.onDidChangeFile(r=>{const o=new b.$rl(r,!this.S(s));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof s.onDidWatchError=="function"&&t.add(s.onDidWatchError(r=>this.Z.fire(new Error(r)))),t.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:n}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:n,provider:s}),this.h.delete(n),(0,a.$Oc)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const s=[];this.f.fire({scheme:n,join(t){s.push(t)}}),!this.h.has(n)&&await P.Promises.settled(s)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,s){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return w.Iterable.map(this.h,([n,s])=>({scheme:n,capabilities:s.capabilities}))}async j(n){if(!(0,d.$ih)(n))throw new b.$tl((0,I.localize)(11316,null,this.sb(n)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const s=this.h.get(n.scheme);if(!s){const t=new O.$ab;throw t.message=(0,I.localize)(11317,null,n.toString()),t}return s}async m(n){const s=await this.j(n);if((0,b.$el)(s)||(0,b.$bl)(s)||(0,b.$fl)(s))return s;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const s=await this.j(n);if((0,b.$el)(s)||(0,b.$bl)(s))return s;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,s){try{return await this.s(n,s)}catch(t){throw(0,b.$ol)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$tl((0,I.localize)(11318,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$ml)(t)}}async s(n,s){const t=await this.j(n),r=this.S(t),o=s?.resolveTo,u=s?.resolveSingleChildDescendants,$=s?.resolveMetadata,D=await t.stat(n);let T;return this.t(t,n,D,void 0,!!$,(A,N)=>(T||(T=f.$Ji.forUris(()=>!r),T.set(n,!0),o&&T.fill(!0,o)),T.get(A.resource)||T.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&u?N===1:!1))}async t(n,s,t,r,o,u){const{providerExtUri:$}=this.R(n),D={resource:s,name:$.basename(s),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(n.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$El)({mtime:t.mtime,size:t.size}),children:void 0};if(D.isDirectory&&u(D,r)){try{const T=await n.readdir(s),A=await P.Promises.settled(T.map(async([N,M])=>{try{const G=$.joinPath(s,N),Z=o?await n.stat(G):{type:M};return await this.t(n,G,Z,T.length,o,u)}catch(G){return this.b.trace(G),null}}));D.children=(0,S.$Gb)(A)}catch(T){this.b.trace(T),D.children=[]}return D}return D}async resolveAll(n){return P.Promises.settled(n.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const s=await this.j(n),t=await s.stat(n);return this.t(s,n,t,void 0,!0,()=>!1)}async exists(n){const s=await this.j(n);try{return!!await s.stat(n)}catch{return!1}}async canCreateFile(n,s){try{await this.u(n,s)}catch(t){return t}return!0}async u(n,s){if(!s?.overwrite&&await this.exists(n))throw new b.$tl((0,I.localize)(11319,null,this.sb(n)),b.FileOperationResult.FILE_MODIFIED_SINCE,s)}async createFile(n,s=v.$Me.fromString(""),t){await this.u(n,t);const r=await this.writeFile(n,s);return this.r.fire(new b.$ql(n,b.FileOperation.CREATE,r)),r}async writeFile(n,s,t){const r=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(r);let u=t;if((0,b.$hl)(r)&&!u?.atomic){const $=r.enforceAtomicWriteFile?.(n);$&&(u={...t,atomic:$})}try{await this.w(r,n,u)||await this.U(r,o.dirname(n));let D;if((0,b.$bl)(r)&&!(s instanceof v.$Me))if((0,p.$ye)(s)){const T=await(0,p.$Fe)(s,3);T.ended?D=v.$Me.concat(T.buffer):D=T}else D=(0,p.$Ce)(s,T=>v.$Me.concat(T),3);else D=s;!(0,b.$el)(r)||(0,b.$bl)(r)&&D instanceof v.$Me||(0,b.$bl)(r)&&(0,b.$hl)(r)&&u?.atomic?await this.hb(r,n,u,D):await this.db(r,n,u,D instanceof v.$Me?(0,v.$Xe)(D):D),this.r.fire(new b.$ql(n,b.FileOperation.WRITE))}catch($){throw new b.$tl((0,I.localize)(11320,null,this.sb(n),(0,b.$ml)($).toString()),(0,b.$pl)($),u)}return this.resolve(n,{resolveMetadata:!0})}async w(n,s,t){const r=!!t?.unlock;if(r&&!(n.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,I.localize)(11321,null,this.sb(s)));if(!!t?.atomic){if(!(n.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,I.localize)(11322,null,this.sb(s)));if(!(n.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,I.localize)(11323,null,this.sb(s)));if(r)throw new Error((0,I.localize)(11324,null,this.sb(s)))}let u;try{u=await n.stat(s)}catch{return}if(u.type&b.FileType.Directory)throw new b.$tl((0,I.localize)(11325,null,this.sb(s)),b.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(s,u),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Dl&&typeof u.mtime=="number"&&typeof u.size=="number"&&t.mtime<u.mtime&&t.etag!==(0,b.$El)({mtime:t.mtime,size:u.size}))throw new b.$tl((0,I.localize)(11326,null),b.FileOperationResult.FILE_MODIFIED_SINCE,t);return u}async readFile(n,s,t){const r=await this.m(n);return s?.atomic?this.z(r,n,s,t):this.C(r,n,s,t)}async z(n,s,t,r){return new Promise((o,u)=>{this.cb.queueFor(s,async()=>{try{const $=await this.C(n,s,t,r);o($)}catch($){u($)}},this.R(n).providerExtUri)})}async C(n,s,t,r){const o=await this.D(n,s,{...t,preferUnbuffered:!0},r);return{...o,value:await(0,v.$Ye)(o.value)}}async readFileStream(n,s,t){const r=await this.m(n);return this.D(r,n,s,t)}async D(n,s,t,r){const o=new k.$ve(r);let u=t;(0,b.$gl)(n)&&n.enforceAtomicReadFile?.(s)&&(u={...t,atomic:!0});const $=this.J(s,u).then(T=>T,T=>{throw o.dispose(!0),T});let D;try{return typeof u?.etag=="string"&&u.etag!==b.$Dl&&await $,u?.atomic&&(0,b.$gl)(n)||!((0,b.$el)(n)||(0,b.$fl)(n))||(0,b.$bl)(n)&&u?.preferUnbuffered?D=this.I(n,s,u):(0,b.$fl)(n)?D=this.G(n,s,o.token,u):D=this.H(n,s,o.token,u),D.on("end",()=>o.dispose()),D.on("error",()=>o.dispose()),{...await $,value:D}}catch(T){throw D&&await(0,p.$De)(D),this.F(T,s,u)}}F(n,s,t){const r=(0,I.localize)(11327,null,this.sb(s),(0,b.$ml)(n).toString());return n instanceof b.$vl?new b.$vl(r,n.stat,t):n instanceof b.$ul?new b.$ul(r,n.fileOperationResult,n.size,n.options):new b.$tl(r,(0,b.$pl)(n),t)}G(n,s,t,r=Object.create(null)){const o=n.readFileStream(s,r,t);return(0,p.$Je)(o,{data:u=>u instanceof v.$Me?u:v.$Me.wrap(u),error:u=>this.F(u,s,r)},u=>v.$Me.concat(u))}H(n,s,t,r=Object.create(null)){const o=(0,v.$3e)();return(0,h.$Zq)(n,s,o,u=>u,{...r,bufferSize:this.a,errorTransformer:u=>this.F(u,s,r)},t),o}I(n,s,t){const r=(0,p.$Ae)(o=>v.$Me.concat(o));return(async()=>{try{let o;t?.atomic&&(0,b.$gl)(n)?o=await n.readFile(s,{atomic:!0}):o=await n.readFile(s),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(s,o.byteLength,t),r.end(v.$Me.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async J(n,s){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new b.$tl((0,I.localize)(11328,null,this.sb(n)),b.FileOperationResult.FILE_IS_DIRECTORY,s);if(typeof s?.etag=="string"&&s.etag!==b.$Dl&&s.etag===t.etag)throw new b.$vl((0,I.localize)(11329,null),t,s);return this.L(n,t.size,s),t}L(n,s,t){if(typeof t?.limits?.size=="number"&&s>t.limits.size)throw new b.$ul((0,I.localize)(11330,null,this.sb(n)),b.FileOperationResult.FILE_TOO_LARGE,s,t)}async canMove(n,s,t){return this.M(n,s,"move",t)}async canCopy(n,s,t){return this.M(n,s,"copy",t)}async M(n,s,t,r){if(n.toString()!==s.toString())try{const o=t==="move"?this.qb(await this.n(n),n):await this.m(n),u=this.qb(await this.n(s),s);await this.Q(o,n,u,s,t,r)}catch(o){return o}return!0}async move(n,s,t){const r=this.qb(await this.n(n),n),o=this.qb(await this.n(s),s),u=await this.N(r,n,o,s,"move",!!t),$=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$ql(n,u==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,$)),$}async copy(n,s,t){const r=await this.m(n),o=this.qb(await this.n(s),s),u=await this.N(r,n,o,s,"copy",!!t),$=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$ql(n,u==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,$)),$}async N(n,s,t,r,o,u){if(s.toString()===r.toString())return o;const{exists:$,isSameResourceWithDifferentPathCase:D}=await this.Q(n,s,t,r,o,u);if($&&!D&&u&&await this.del(r,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(r)),o==="copy"){if(n===t&&(0,b.$cl)(n))await n.copy(s,r,{overwrite:u});else{const T=await this.resolve(s);T.isDirectory?await this.P(n,T,t,r):await this.O(n,s,t,r)}return o}else return n===t?(await n.rename(s,r,{overwrite:u}),o):(await this.N(n,s,t,r,"copy",u),await this.del(s,{recursive:!0}),"copy")}async O(n,s,t,r){if((0,b.$el)(n)&&(0,b.$el)(t))return this.jb(n,s,t,r);if((0,b.$el)(n)&&(0,b.$bl)(t))return this.pb(n,s,t,r);if((0,b.$bl)(n)&&(0,b.$el)(t))return this.nb(n,s,t,r);if((0,b.$bl)(n)&&(0,b.$bl)(t))return this.lb(n,s,t,r)}async P(n,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await P.Promises.settled(s.children.map(async o=>{const u=this.R(t).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),t,u):this.O(n,o.resource,t,u)}))}async Q(n,s,t,r,o,u){let $=!1;if(n===t){const{providerExtUri:T,isPathCaseSensitive:A}=this.R(n);if(A||($=T.isEqual(s,r)),$&&o==="copy")throw new Error((0,I.localize)(11331,null,this.sb(s),this.sb(r)));if(!$&&T.isEqualOrParent(r,s))throw new Error((0,I.localize)(11332,null,this.sb(s),this.sb(r)))}const D=await this.exists(r);if(D&&!$){if(!u)throw new b.$tl((0,I.localize)(11333,null,this.sb(s),this.sb(r)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(n===t){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(s,r))throw new Error((0,I.localize)(11334,null,this.sb(s),this.sb(r)))}}return{exists:D,isSameResourceWithDifferentPathCase:$}}R(n){const s=this.S(n);return{providerExtUri:s?d.$7g:d.$9g,isPathCaseSensitive:s}}S(n){return!!(n.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const s=this.qb(await this.j(n),n);await this.U(s,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$ql(n,b.FileOperation.CREATE,t)),t}async U(n,s){const t=[],{providerExtUri:r}=this.R(n);for(;!r.isEqual(s,r.dirname(s));)try{if(!((await n.stat(s)).type&b.FileType.Directory))throw new Error((0,I.localize)(11335,null,this.sb(s)));break}catch(o){if((0,b.$ol)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(r.basename(s)),s=r.dirname(s)}for(let o=t.length-1;o>=0;o--){s=r.joinPath(s,t[o]);try{await n.mkdir(s)}catch(u){if((0,b.$ol)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(n,s){try{await this.W(n,s)}catch(t){return t}return!0}async W(n,s){const t=this.qb(await this.j(n),n),r=!!s?.useTrash;if(r&&!(t.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,I.localize)(11336,null,this.sb(n)));const o=s?.atomic;if(o&&!(t.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,I.localize)(11337,null,this.sb(n)));if(r&&o)throw new Error((0,I.localize)(11338,null,this.sb(n)));let u;try{u=await t.stat(n)}catch{}if(u)this.rb(n,u);else throw new b.$tl((0,I.localize)(11339,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!s?.recursive){const D=await this.resolve(n);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,I.localize)(11340,null,this.sb(n)))}return t}async del(n,s){const t=await this.W(n,s);let r=s;if((0,b.$il)(t)&&!r?.atomic){const D=t.enforceAtomicDelete?.(n);D&&(r={...s,atomic:D})}const o=!!r?.useTrash,u=!!r?.recursive,$=r?.atomic??!1;await t.delete(n,{recursive:u,useTrash:o,atomic:$}),this.r.fire(new b.$ql(n,b.FileOperation.DELETE))}async cloneFile(n,s){const t=await this.j(n),r=this.qb(await this.n(s),s);if(!(t===r&&this.R(t).providerExtUri.isEqual(n,s)))return t===r&&(0,b.$dl)(t)?t.cloneFile(n,s):(await this.U(r,this.R(r).providerExtUri.dirname(s)),t===r&&(0,b.$cl)(t)?this.cb.queueFor(n,()=>t.copy(n,s,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(n,()=>this.O(t,n,r,s),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(n,s){return this.watch(n,{...s,correlationId:y.ab++})}watch(n,s={recursive:!1,excludes:[]}){const t=new a.$Sc;let r=!1,o=()=>{r=!0};t.add((0,a.$Rc)(()=>o())),(async()=>{try{const $=await this.bb(n,s);r?(0,a.$Oc)($):o=()=>(0,a.$Oc)($)}catch($){this.b.error($)}})();const u=s.correlationId;if(typeof u=="number"){const $=t.add(new L.$ke);return t.add(this.X.event(T=>{T.correlates(u)&&$.fire(T)})),{onDidChange:$.event,dispose:()=>t.dispose()}}return t}async bb(n,s){const t=await this.j(n),r=(0,R.$rj)([this.R(t).providerExtUri.getComparisonKey(n),s]);let o=this.$.get(r);return o||(o={count:0,disposable:t.watch(n,s)},this.$.set(r,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(r)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,a.$Oc)(n.disposable);this.$.clear()}async db(n,s,t,r){return this.cb.queueFor(s,async()=>{const o=await n.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,p.$ye)(r)||(0,p.$ze)(r)?await this.eb(n,o,r):await this.fb(n,o,r)}catch(u){throw(0,b.$ml)(u)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,s,t){let r=0,o;if((0,p.$ze)(t)){if(t.buffer.length>0){const u=v.$Me.concat(t.buffer);await this.gb(n,s,u,u.byteLength,r,0),r+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((u,$)=>{(0,p.$Ee)(o,{onData:async D=>{o.pause();try{await this.gb(n,s,D,D.byteLength,r,0)}catch(T){return $(T)}r+=D.byteLength,setTimeout(()=>o.resume())},onError:D=>$(D),onEnd:()=>u()})})}async fb(n,s,t){let r=0,o;for(;(o=t.read())!==null;)await this.gb(n,s,o,o.byteLength,r,0),r+=o.byteLength}async gb(n,s,t,r,o,u){let $=0;for(;$<r;){const D=await n.write(s,o+$,t.buffer,u+$,r-$);$+=D}}async hb(n,s,t,r){return this.cb.queueFor(s,()=>this.ib(n,s,t,r),this.R(n).providerExtUri)}async ib(n,s,t,r){let o;r instanceof v.$Me?o=r:(0,p.$ye)(r)?o=await(0,v.$Ye)(r):(0,p.$ze)(r)?o=await(0,v.$Ze)(r):o=(0,v.$We)(r),await n.writeFile(s,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(n,s,t,r){return this.cb.queueFor(r,()=>this.kb(n,s,t,r),this.R(t).providerExtUri)}async kb(n,s,t,r){let o,u;try{o=await n.open(s,{create:!1}),u=await t.open(r,{create:!0,unlock:!1});const $=v.$Me.alloc(this.a);let D=0,T=0,A=0;do A=await n.read(o,D,$.buffer,T,$.byteLength-T),await this.gb(t,u,$,A,D,T),D+=A,T+=A,T===$.byteLength&&(T=0);while(A>0)}catch($){throw(0,b.$ml)($)}finally{await P.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async lb(n,s,t,r){return this.cb.queueFor(r,()=>this.mb(n,s,t,r),this.R(t).providerExtUri)}async mb(n,s,t,r){return t.writeFile(r,await n.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,s,t,r){return this.cb.queueFor(r,()=>this.ob(n,s,t,r),this.R(t).providerExtUri)}async ob(n,s,t,r){const o=await t.open(r,{create:!0,unlock:!1});try{const u=await n.readFile(s);await this.gb(t,o,v.$Me.wrap(u),u.byteLength,0,0)}catch(u){throw(0,b.$ml)(u)}finally{await t.close(o)}}async pb(n,s,t,r){const o=await(0,v.$Ye)(this.H(n,s,k.CancellationToken.None));await this.hb(t,r,void 0,o)}qb(n,s){if(n.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$tl((0,I.localize)(11341,null,this.sb(s)),b.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,s){if((s.permissions??0)&b.FilePermission.Readonly)throw new b.$tl((0,I.localize)(11342,null,this.sb(n)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===c.Schemas.file?n.fsPath:n.toString(!0)}};e.$1q=i,e.$1q=i=y=ve([re(0,g.$$j)],i)}),define(le[109],ue([0,1,32,8,25,13,4,63,2,15,12,16,47,29,5,9,62,106,104,103]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class y extends h.$ar{static{this.L=!1}constructor(l,n){super(l,n),this.onDidChangeCapabilities=L.Event.None,this.P=new v.$zc(s=>c.$8g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=I.FileSystemProviderCapabilities.FileReadWrite|I.FileSystemProviderCapabilities.FileOpenReadWriteClose|I.FileSystemProviderCapabilities.FileReadStream|I.FileSystemProviderCapabilities.FileFolderCopy|I.FileSystemProviderCapabilities.FileWriteUnlock|I.FileSystemProviderCapabilities.FileAtomicRead|I.FileSystemProviderCapabilities.FileAtomicWrite|I.FileSystemProviderCapabilities.FileAtomicDelete|I.FileSystemProviderCapabilities.FileClone,f.$l&&(this.M|=I.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(l){try{const{stat:n,symbolicLink:s}=await d.SymlinkSupport.stat(this.I(l));return{type:this.O(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:I.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const n=await d.Promises.readdir(this.I(l),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async t=>{try{let r;t.isSymbolicLink()?r=(await this.stat((0,c.$eh)(l,t.name))).type:r=this.O(t),s.push([t.name,r])}catch(r){this.a.trace(r)}})),s}catch(n){throw this.hb(n)}}O(l,n){let s;return n?.dangling?s=I.FileType.Unknown:l.isFile()?s=I.FileType.File:l.isDirectory()?s=I.FileType.Directory:s=I.FileType.Unknown,n&&(s|=I.FileType.SymbolicLink),s}async Q(l){const n=this.I(l);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.P.get(l);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const t=new P.$Ch;return this.P.set(l,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,w.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(l)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(l)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),t.open()})}async readFile(l,n){let s;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(l)})`),s=await this.Q(l));const t=this.I(l);return await S.promises.readFile(t)}catch(t){throw this.hb(t)}finally{s?.dispose()}}R(l){y.L&&this.a.trace(l)}readFileStream(l,n,s){const t=(0,m.$Ae)(r=>k.$Me.concat(r.map(o=>k.$Me.wrap(o))).buffer);return(0,b.$Zq)(this,l,t,r=>r.buffer,{...n,bufferSize:256*1024},s),t}async writeFile(l,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(l)?this.U(l,(0,c.$eh)((0,c.$dh)(l),`${(0,c.$bh)(l)}${s.atomic.postfix}`),n,s):this.W(l,n,s)}async S(l){try{const n=this.I(l),{symbolicLink:s}=await d.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async U(l,n,s,t){const r=new w.$Sc;try{r.add(await this.Q(l)),r.add(await this.Q(n)),await this.W(n,s,t,!0);try{await this.rename(n,l,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{r.dispose()}}async W(l,n,s,t){let r;try{const o=this.I(l);if(!s.create||!s.overwrite){if(await d.Promises.exists(o)){if(!s.overwrite)throw(0,I.$ll)((0,p.localize)(11300,null),I.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,I.$ll)((0,p.localize)(11301,null),I.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(l,{create:!0,unlock:s.unlock},t),await this.write(r,0,n,0,n.byteLength)}catch(o){throw await this.ib(l,o)}finally{typeof r=="number"&&await this.close(r)}}static{this.$=!0}static configureFlushOnWrite(l){y.$=l}async open(l,n,s){const t=this.I(l);let r;(0,I.$_k)(n)&&!s&&(r=await this.Q(l));let o;try{if((0,I.$_k)(n)&&n.unlock)try{const{stat:$}=await d.SymlinkSupport.stat(t);$.mode&128||await S.promises.chmod(t,$.mode|128)}catch($){$.code!=="ENOENT"&&this.a.trace($)}let u;if((0,I.$_k)(n)){if(f.$j)try{await S.promises.truncate(t,0),u="r+"}catch($){$.code!=="ENOENT"&&this.a.trace($)}u||(u="w")}else u="r";o=await d.Promises.open(t,u)}catch(u){throw r?.dispose(),(0,I.$_k)(n)?await this.ib(l,u):this.hb(u)}if(this.X.set(o,0),(0,I.$_k)(n)&&this.Z.set(o,l),r){const u=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.Y.set(o,r),u&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),u.dispose())}return o}async close(l){const n=this.Y.get(l);try{if(this.X.delete(l),this.Z.delete(l)&&y.$)try{await d.Promises.fdatasync(l)}catch(s){y.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(l)}catch(s){throw this.hb(s)}finally{n&&(this.Y.get(l)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.Y.delete(l)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),n.dispose())}}async read(l,n,s,t,r){const o=this.ab(l,n);let u=null;try{u=(await d.Promises.read(l,s,t,r,o)).bytesRead}catch($){throw this.hb($)}finally{this.bb(l,o,u)}return u}ab(l,n){return n===this.X.get(l)?null:n}bb(l,n,s){const t=this.X.get(l);typeof t=="number"&&(typeof n=="number"||(typeof s=="number"?this.X.set(l,t+s):this.X.delete(l)))}async write(l,n,s,t,r){return(0,P.$Xh)(()=>this.cb(l,n,s,t,r),100,3)}async cb(l,n,s,t,r){const o=this.ab(l,n);let u=null;try{u=(await d.Promises.write(l,s,t,r,o)).bytesWritten}catch($){throw await this.ib(this.Z.get(l),$)}finally{this.bb(l,o,u)}return u}async mkdir(l){try{await S.promises.mkdir(this.I(l))}catch(n){throw this.hb(n)}}async delete(l,n){try{const s=this.I(l);if(n.recursive){let t;n?.atomic!==!1&&n.atomic.postfix&&(t=(0,a.$ic)((0,a.$lc)(s),`${(0,a.$mc)(s)}${n.atomic.postfix}`)),await d.Promises.rm(s,d.RimRafMode.MOVE,t)}else try{await S.promises.unlink(s)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let r=!1;try{const{stat:o,symbolicLink:u}=await d.SymlinkSupport.stat(s);r=o.isDirectory()&&!u}catch{}if(r)await S.promises.rmdir(s);else throw t}else throw t}}catch(s){throw this.hb(s)}}async rename(l,n,s){const t=this.I(l),r=this.I(n);if(t!==r)try{await this.db(l,n,"move",s.overwrite),await d.Promises.rename(t,r)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,p.localize)(11302,null,(0,a.$mc)(t),(0,a.$mc)((0,a.$lc)(r)),o.toString()))),this.hb(o)}}async copy(l,n,s){const t=this.I(l),r=this.I(n);if(t!==r)try{await this.db(l,n,"copy",s.overwrite),await d.Promises.copy(t,r,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,p.localize)(11303,null,(0,a.$mc)(t),(0,a.$mc)((0,a.$lc)(r)),o.toString()))),this.hb(o)}}async db(l,n,s,t){const r=this.I(l),o=this.I(n);let u=!1;if(!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,R.$Bg)(r,o,!0)),u){if(s==="copy")throw(0,I.$ll)((0,p.localize)(11304,null),I.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const D=await this.N(l);if(!D)throw(0,I.$ll)((0,p.localize)(11305,null),I.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(n);if(T){if(!t)throw(0,I.$ll)((0,p.localize)(11306,null),I.FileSystemProviderErrorCode.FileExists);D.type&I.FileType.File&&T.type&I.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,n){return this.eb(l,n,!1)}async eb(l,n,s){const t=this.I(l),r=this.I(n),o=!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.$Bg)(t,r,!o))return;const u=new w.$Sc;try{u.add(await this.Q(l)),u.add(await this.Q(n)),s&&await S.promises.mkdir((0,a.$lc)(r),{recursive:!0}),await S.promises.copyFile(t,r)}catch($){if($.code==="ENOENT"&&!s)return this.eb(l,n,!0);throw this.hb($)}finally{u.dispose()}}t(l,n,s){return new g.$hr(t=>l(t),t=>n(t),s)}F(l,n,s){return new O.$qr(t=>l(t),t=>n(t),s)}hb(l){if(l instanceof I.$kl)return l;let n=l,s;switch(l.code){case"ENOENT":s=I.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=I.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=I.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=I.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=I.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=I.FileSystemProviderErrorCode.Unknown;break;default:s=I.FileSystemProviderErrorCode.Unknown}return(0,I.$ll)(n,s)}async ib(l,n){let s=this.hb(n);if(l&&s.code===I.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await d.SymlinkSupport.stat(this.I(l));t.mode&128||(s=(0,I.$ll)(n,I.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return s}}e.$rr=y}),define(le[110],ue([0,1,2,6]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ER=void 0;class v extends S.$Tc{constructor(L,R=[]){super(),this.a=new P.$ik([L,...R]),this.B(L.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...R){this.a.trace(L,...R)}debug(L,...R){this.a.debug(L,...R)}info(L,...R){this.a.info(L,...R)}warn(L,...R){this.a.warn(L,...R)}error(L,...R){this.a.error(L,...R)}flush(){this.a.flush()}}e.$ER=v}),define(le[111],ue([0,1,9,6]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=void 0;var v;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(v||(v={}));async function k(a,f,c,m,d){try{const p=await new Promise((b,h)=>{Q(["@vscode/spdlog"],b,h)}).then(ye);p.setFlushOn(v.Trace);const I=await p.createAsyncRotatingLogger(a,f,c,m);return d?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch(p){console.error(p)}return null}function L(a,f,c){switch(f){case P.LogLevel.Trace:a.trace(c);break;case P.LogLevel.Debug:a.debug(c);break;case P.LogLevel.Info:a.info(c);break;case P.LogLevel.Warning:a.warn(c);break;case P.LogLevel.Error:a.error(c);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function R(a,f){switch(f){case P.LogLevel.Trace:a.setLevel(v.Trace);break;case P.LogLevel.Debug:a.setLevel(v.Debug);break;case P.LogLevel.Info:a.setLevel(v.Info);break;case P.LogLevel.Warning:a.setLevel(v.Warning);break;case P.LogLevel.Error:a.setLevel(v.Error);break;case P.LogLevel.Off:a.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class w extends P.$ek{constructor(f,c,m,d,p){super(),this.m=[],this.setLevel(p),this.n=this.s(f,c,m,d),this.B(this.onDidChangeLogLevel(I=>{this.r&&R(this.r,I)}))}async s(f,c,m,d){const p=m?6:1,I=30/p*S.$Gl.MB,b=await k(f,c,I,p,d);if(b){this.r=b,R(this.r,this.getLevel());for(const{level:h,message:g}of this.m)L(this.r,h,g);this.m=[]}}g(f,c){this.r?L(this.r,f,c):this.getLevel()<=f&&this.m.push({level:f,message:c})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$tR=w}),define(le[112],ue([0,1,28,6,111]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uR=void 0;class k extends P.$jk{s(R,w,a){return new v.$tR((0,S.$Zg)(),R.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,w)}}e.$uR=k}),define(le[39],ue([0,1,4,65,2,10]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=void 0,e.$ro=(0,k.$Di)("policy");class L extends v.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$ke),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),P.Iterable.reduce(this.g.entries(),(c,[m,d])=>({...c,[m]:d}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return P.Iterable.reduce(Object.entries(this.f),(a,[f,c])=>({...a,[f]:{definition:c,value:this.g.get(f)}}),{})}}e.$so=L;class R{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$to=R}),define(le[113],ue([0,1,8,4,65,3,9,6,39]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=void 0;function a(c,m){const d=[];for(const p of new Set(v.Iterable.concat(c.keys(),m.keys())))c.get(p)!==m.get(p)&&d.push(p);return d}let f=class extends w.$so{constructor(m,d,p){super(),this.m=m,this.n=d,this.s=p,this.c=this.B(new S.$Bh(500));const I=P.Event.filter(d.onDidFilesChange,b=>b.affects(m));this.B(d.watch(m)),this.B(I(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const d=await this.n.readFile(this.m),p=JSON.parse(d.value.toString());if(!(0,k.$fg)(p))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys(p))this.f[I]&&m.set(I,p[I])}catch(d){d.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",d)}return m}async w(){const m=await this.u(),d=a(this.g,m);this.g=m,d.length>0&&this.h.fire(d)}};e.$uhc=f,e.$uhc=f=ve([re(1,L.$$k),re(2,R.$$j)],f)}),define(le[114],ue([0,1,39,8,2,6]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;let L=class extends S.$so{constructor(w,a){super(),this.m=w,this.n=a,this.a=new P.$xh,this.b=this.B(new v.$Uc)}async j(w){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`);const{createWatcher:a}=await new Promise((f,c)=>{Q(["@vscode/policy-watcher"],f,c)}).then(ye);await this.a.queue(()=>new Promise((f,c)=>{try{this.b.value=a(this.n,w,m=>{this.t(m),f()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),c(m)}}))}t(w){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const a in w){const f=w[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(w))}};e.$thc=L,e.$thc=L=ve([re(0,k.$$j)],L)}),define(le[33],ue([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=void 0,e.$rk=(0,S.$Di)("productService"),e.$sk="vscode://schemas/vscode-product"}),define(le[37],ue([0,1,75,3]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,S=ye(S),P=ye(P);class v{constructor(){this.a=new Map}add(L,R){S.ok(P.$dg(L)),S.ok(P.$fg(R)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,R)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$po=new v}),define(le[115],ue([0,1,4,78,37]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,v=ye(v),e.$qo={JSONContribution:"base.contributions.json"};function k(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class L{constructor(){this.b=new S.$ke,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(a,f){this.a[k(a)]=f,this.b.fire(a)}notifySchemaChanged(a){this.b.fire(a)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(a){const f=this.a[a];return f?(0,P.$6j)(f):void 0}hasSchemaContent(a){return!!this.a[a]}}const R=new L;v.$po.add(e.$qo.JSONContribution,R)}),define(le[40],ue([0,1,19,4,3,5,30,115,37]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.ConfigurationScope=e.$uo=e.EditPresentationTypes=void 0,e.$Fo=I,e.$Go=b,e.$Ho=h,e.$Io=O,e.$Jo=y,e.$Ko=i,e.$Lo=l,v=ye(v),k=ye(k);var a;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$uo={Configuration:"base.contributions.configuration"};var f;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo="vscode://schemas/settings/resourceLanguage",e.$Co="vscode://schemas/settings/configurationDefaults";const c=w.$po.as(R.$qo.JSONContribution);class m{constructor(){this.a=[],this.i=new Set,this.j=new P.$ke,this.onDidSchemaChange=this.j.event,this.k=new P.$ke,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(11536,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},c.registerSchema(e.$Bo,this.h),this.z()}registerConfiguration(s,t=!0){this.registerConfigurations([s],t)}registerConfigurations(s,t=!0){const r=new Set;this.r(s,t,r),c.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:r})}deregisterConfigurations(s){const t=new Set;this.s(s,t),c.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:s,remove:t}){const r=new Set;this.s(t,r),this.r(s,!1,r),c.registerSchema(e.$Bo,this.h),this.j.fire(),this.k.fire({properties:r})}registerDefaultConfigurations(s){const t=new Set;this.l(s,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(s,t){this.a.push(...s);const r=[];for(const{overrides:o,source:u}of s)for(const $ in o){t.add($);const D=this.b.get($)??this.b.set($,{configurationDefaultOverrides:[]}).get($),T=o[$];if(D.configurationDefaultOverrides.push({value:T,source:u}),e.$Eo.test($)){const A=this.o($,T,u,D.configurationDefaultOverrideValue);if(!A)continue;D.configurationDefaultOverrideValue=A,this.n($,A,u),r.push(...I($))}else{const A=this.p($,T,u,D.configurationDefaultOverrideValue);if(!A)continue;D.configurationDefaultOverrideValue=A;const N=this.e[$];N&&(this.A($,N),this.w($,N))}}this.q(r)}deregisterDefaultConfigurations(s){const t=new Set;this.m(s,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(s,t){for(const r of s){const o=this.a.indexOf(r);o!==-1&&this.a.splice(o,1)}for(const{overrides:r,source:o}of s)for(const u in r){const $=this.b.get(u);if(!$)continue;const D=$.configurationDefaultOverrides.findIndex(T=>o?T.source?.id===o.id:T.value===r[u]);if(D!==-1){if($.configurationDefaultOverrides.splice(D,1),$.configurationDefaultOverrides.length===0&&this.b.delete(u),e.$Eo.test(u)){let T;for(const A of $.configurationDefaultOverrides)T=this.o(u,A.value,A.source,T);T&&!v.$qg(T.value)?($.configurationDefaultOverrideValue=T,this.n(u,T,o)):(this.b.delete(u),delete this.e[u],delete this.c.properties[u])}else{let T;for(const N of $.configurationDefaultOverrides)T=this.p(u,N.value,N.source,T);$.configurationDefaultOverrideValue=T;const A=this.e[u];A&&(this.A(u,A),this.w(u,A))}t.add(u)}}this.y()}n(s,t,r){const o={type:"object",default:t.value,description:k.localize(11537,null,(0,L.$hj)(s)),$ref:e.$Bo,defaultDefaultValue:t.value,source:r,defaultValueSource:r};this.e[s]=o,this.c.properties[s]=o}o(s,t,r,o){const u=o?.value||{},$=o?.source??new Map;if(!($ instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const D of Object.keys(t)){const T=t[D];if(v.$fg(T)&&(v.$kg(u[D])||v.$fg(u[D]))){if(u[D]={...u[D]??{},...T},r)for(const N in T)$.set(`${D}.${N}`,r)}else u[D]=T,r?$.set(D,r):$.delete(D)}return{value:u,source:$}}p(s,t,r,o){const u=this.e[s],$=o?.value??u?.defaultDefaultValue;let D=r;if(v.$fg(t)&&(u!==void 0&&u.type==="object"||u===void 0&&(v.$kg($)||v.$fg($)))){if(D=o?.source??new Map,!(D instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in t)r&&D.set(`${s}.${A}`,r);t={...v.$fg($)?$:{},...t}}return{value:t,source:D}}deltaConfiguration(s){let t=!1;const r=new Set;s.removedDefaults&&(this.m(s.removedDefaults,r),t=!0),s.addedDefaults&&(this.l(s.addedDefaults,r),t=!0),s.removedConfigurations&&this.s(s.removedConfigurations,r),s.addedConfigurations&&this.r(s.addedConfigurations,!1,r),this.j.fire(),this.k.fire({properties:r,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...s){this.j.fire()}registerOverrideIdentifiers(s){this.q(s),this.j.fire()}q(s){for(const t of s)this.i.add(t);this.y()}r(s,t,r){s.forEach(o=>{this.u(o,t,o.extensionInfo,o.restrictedProperties,void 0,r),this.d.push(o),this.v(o)})}s(s,t){const r=o=>{if(o.properties)for(const u in o.properties){t.add(u);const $=this.e[u];$?.policy?.name&&this.f.delete($.policy.name),delete this.e[u],this.x(u,o.properties[u])}o.allOf?.forEach(u=>r(u))};for(const o of s){r(o);const u=this.d.indexOf(o);u!==-1&&this.d.splice(u,1)}}u(s,t=!0,r,o,u=f.WINDOW,$){u=v.$mg(s.scope)?u:s.scope;const D=s.properties;if(D)for(const A in D){const N=D[A];if(t&&O(A,N)){delete D[A];continue}if(N.source=r,N.defaultDefaultValue=D[A].default,this.A(A,N),e.$Eo.test(A)?N.scope=void 0:(N.scope=v.$mg(N.scope)?u:N.scope,N.restricted=v.$mg(N.restricted)?!!o?.includes(A):N.restricted),D[A].hasOwnProperty("included")&&!D[A].included){this.g[A]=D[A],delete D[A];continue}else this.e[A]=D[A],D[A].policy?.name&&this.f.set(D[A].policy.name,A);!D[A].deprecationMessage&&D[A].markdownDeprecationMessage&&(D[A].deprecationMessage=D[A].markdownDeprecationMessage),$.add(A)}const T=s.allOf;if(T)for(const A of T)this.u(A,t,r,o,u,$)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const s=new Map;for(const[t,r]of this.b)r.configurationDefaultOverrideValue&&s.set(t,r.configurationDefaultOverrideValue);return s}v(s){const t=r=>{const o=r.properties;if(o)for(const $ in o)this.w($,o[$]);r.allOf?.forEach(t)};t(s)}w(s,t){switch(e.$vo.properties[s]=t,t.scope){case f.APPLICATION:e.$wo.properties[s]=t;break;case f.MACHINE:e.$xo.properties[s]=t;break;case f.MACHINE_OVERRIDABLE:e.$yo.properties[s]=t;break;case f.WINDOW:e.$zo.properties[s]=t;break;case f.RESOURCE:e.$Ao.properties[s]=t;break;case f.LANGUAGE_OVERRIDABLE:e.$Ao.properties[s]=t,this.h.properties[s]=t;break}}x(s,t){switch(delete e.$vo.properties[s],t.scope){case f.APPLICATION:delete e.$wo.properties[s];break;case f.MACHINE:delete e.$xo.properties[s];break;case f.MACHINE_OVERRIDABLE:delete e.$yo.properties[s];break;case f.WINDOW:delete e.$zo.properties[s];break;case f.RESOURCE:case f.LANGUAGE_OVERRIDABLE:delete e.$Ao.properties[s],delete this.h.properties[s];break}}y(){for(const s of this.i.values()){const t=`[${s}]`,r={type:"object",description:k.localize(11538,null),errorMessage:k.localize(11539,null),$ref:e.$Bo};this.A(t,r),e.$vo.properties[t]=r,e.$wo.properties[t]=r,e.$xo.properties[t]=r,e.$yo.properties[t]=r,e.$zo.properties[t]=r,e.$Ao.properties[t]=r}}z(){const s={type:"object",description:k.localize(11540,null),errorMessage:k.localize(11541,null),$ref:e.$Bo};e.$vo.patternProperties[e.$Do]=s,e.$wo.patternProperties[e.$Do]=s,e.$xo.patternProperties[e.$Do]=s,e.$yo.patternProperties[e.$Do]=s,e.$zo.patternProperties[e.$Do]=s,e.$Ao.patternProperties[e.$Do]=s,this.j.fire()}A(s,t){const r=this.b.get(s)?.configurationDefaultOverrideValue;let o,u;r&&(!t.disallowConfigurationDefault||!r.source)&&(o=r.value,u=r.source),v.$kg(o)&&(o=t.defaultDefaultValue,u=void 0),v.$kg(o)&&(o=h(t.type)),t.default=o,t.defaultValueSource=u}}const d="\\[([^\\]]+)\\]",p=new RegExp(d,"g");e.$Do=`^(${d})+$`,e.$Eo=new RegExp(e.$Do);function I(n){const s=[];if(e.$Eo.test(n)){let t=p.exec(n);for(;t?.length;){const r=t[1].trim();r&&s.push(r),t=p.exec(n)}}return(0,S.$Lb)(s)}function b(n){return n.reduce((s,t)=>`${s}[${t}]`,"")}function h(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new m;w.$po.add(e.$uo.Configuration,g);function O(n,s){return n.trim()?e.$Eo.test(n)?k.localize(11543,null,n):g.getConfigurationProperties()[n]!==void 0?k.localize(11544,null,n):s.policy?.name&&g.getPolicyConfigurations().get(s.policy?.name)!==void 0?k.localize(11545,null,n,s.policy?.name,g.getPolicyConfigurations().get(s.policy?.name)):null:k.localize(11542,null)}function y(){const n=[],s=g.getConfigurationProperties();for(const t of Object.keys(s))n.push([t,s[t].scope]);return n.push(["launch",f.RESOURCE]),n.push(["task",f.RESOURCE]),n}function i(n){const s={};for(const t of n){const r=t.properties;if(v.$fg(r))for(const o in r)s[o]=r[o];t.allOf&&Object.assign(s,i(t.allOf))}return s}function l(n){switch(n){case"application":return f.APPLICATION;case"machine":return f.MACHINE;case"resource":return f.RESOURCE;case"machine-overridable":return f.MACHINE_OVERRIDABLE;case"language-overridable":return f.LANGUAGE_OVERRIDABLE;default:return f.WINDOW}}}),define(le[66],ue([0,1,19,4,34,2,25,27,3,11,30,40,9,37]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Po=e.$Oo=e.$No=e.$Mo=void 0,e.$Qo=y,S=ye(S),v=ye(v),R=ye(R),w=ye(w);function p(s){return Object.isFrozen(s)?s:R.$do(s)}class I{static createEmptyModel(t){return new I({},[],[],void 0,t)}constructor(t,r,o,u,$){this.b=t,this.c=r,this.d=o,this.raw=u,this.f=$,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(r=>{if(r instanceof I)return r;const o=new b("",this.f);return o.parseRaw(r),o.configurationModel});this.g=t.reduce((r,o)=>o===r?o:r.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,f.$fj)(this.contents,t):this.contents}inspect(t,r){const o=this;return{get value(){return p(o.rawConfiguration.getValue(t))},get override(){return r?p(o.rawConfiguration.getOverrideValue(t,r)):void 0},get merged(){return p(r?o.rawConfiguration.override(r).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const u=[];for(const{contents:$,identifiers:D,keys:T}of o.rawConfiguration.overrides){const A=new I($,T,[],void 0,o.f).getValue(t);A!==void 0&&u.push({identifiers:D,value:A})}return u.length?p(u):void 0}}}getOverrideValue(t,r){const o=this.j(r);return o?t?(0,f.$fj)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const r=[];for(const o of this.overrides)o.identifiers.includes(t)&&r.push(...o.keys);return S.$Lb(r)}getAllOverrideIdentifiers(){const t=[];for(const r of this.overrides)t.push(...r.identifiers);return S.$Lb(t)}override(t){let r=this.a.get(t);return r||(r=this.h(t),this.a.set(t,r)),r}merge(...t){const r=R.$co(this.contents),o=R.$co(this.overrides),u=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const D of t)if($.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(r,D.contents);for(const T of D.overrides){const[A]=o.filter(N=>S.$tb(N.identifiers,T.identifiers));A?(this.i(A.contents,T.contents),A.keys.push(...T.keys),A.keys=S.$Lb(A.keys)):o.push(R.$co(T))}for(const T of D.keys)u.indexOf(T)===-1&&u.push(T)}return new I(r,u,o,$.every(D=>D instanceof I)?void 0:$,this.f)}h(t){const r=this.j(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const o={};for(const u of S.$Lb([...Object.keys(this.contents),...Object.keys(r)])){let $=this.contents[u];const D=r[u];D&&(typeof $=="object"&&typeof D=="object"?($=R.$co($),this.i($,D)):$=D),o[u]=$}return new I(o,this.keys,this.overrides,void 0,this.f)}i(t,r){for(const o of Object.keys(r)){if(o in t&&w.$fg(t[o])&&w.$fg(r[o])){this.i(t[o],r[o]);continue}t[o]=R.$co(r[o])}}j(t){let r=null,o=null;const u=$=>{$&&(o?this.i(o,$):o=R.$co($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===t?r=$.contents:$.identifiers.includes(t)&&u($.contents);return u(r),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,r){this.k(t,r,!0)}setValue(t,r){this.k(t,r,!1)}removeValue(t){const r=this.keys.indexOf(t);r!==-1&&(this.keys.splice(r,1),(0,f.$ej)(this.contents,t),c.$Eo.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>S.$tb(o.identifiers,(0,c.$Fo)(t))),1))}k(t,r,o){if((0,f.$dj)(this.contents,t,r,u=>this.f.error(u)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),c.$Eo.test(t)){const u=(0,c.$Fo)(t),$={identifiers:u,keys:Object.keys(this.contents[t]),contents:(0,f.$cj)(this.contents[t],T=>this.f.error(T))},D=this.overrides.findIndex(T=>S.$tb(T.identifiers,u));D!==-1?this.overrides[D]=$:this.overrides.push($)}}}e.$Mo=I;class b{constructor(t,r){this.f=t,this.g=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||I.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,r){if(!w.$mg(t)){const o=this.h(t);this.parseRaw(o,r)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,r){this.a=t;const{contents:o,keys:u,overrides:$,restricted:D,hasExcludedProperties:T}=this.i(t,r);this.b=new I(o,u,$,T?[t]:void 0,this.g),this.c=D||[]}h(t){let r={},o=null,u=[];const $=[],D=[];function T(N){Array.isArray(u)?u.push(N):o!==null&&(u[o]=N)}const A={onObjectBegin:()=>{const N={};T(N),$.push(u),u=N,o=null},onObjectProperty:N=>{o=N},onObjectEnd:()=>{u=$.pop()},onArrayBegin:()=>{const N=[];T(N),$.push(u),u=N,o=null},onArrayEnd:()=>{u=$.pop()},onLiteralValue:T,onError:(N,M,G)=>{D.push({error:N,offset:M,length:G})}};if(t)try{v.$4n(t,A),r=u[0]||{}}catch(N){this.g.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return r}i(t,r){const o=d.$po.as(c.$uo.Configuration).getConfigurationProperties(),u=this.j(t,o,!0,r);t=u.raw;const $=(0,f.$cj)(t,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),D=Object.keys(t),T=this.l(t,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:$,keys:D,overrides:T,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}j(t,r,o,u){let $=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:$};const D={},T=[];for(const A in t)if(c.$Eo.test(A)&&o){const N=this.j(t[A],r,!1,u);D[A]=N.raw,$=$||N.hasExcludedProperties,T.push(...N.restricted)}else{const N=r[A],M=N?typeof N.scope<"u"?N.scope:c.ConfigurationScope.WINDOW:void 0;N?.restricted&&T.push(A),!u.exclude?.includes(A)&&(u.include?.includes(A)||(M===void 0||u.scopes===void 0||u.scopes.includes(M))&&!(u.skipRestricted&&N?.restricted))?D[A]=t[A]:$=!0}return{raw:D,restricted:T,hasExcludedProperties:$}}l(t,r){const o=[];for(const u of Object.keys(t))if(c.$Eo.test(u)){const $={};for(const D in t[u])$[D]=t[u][D];o.push({identifiers:(0,c.$Fo)(u),keys:Object.keys($),contents:(0,f.$cj)($,r)})}return o}}e.$No=b;class h extends k.$Tc{constructor(t,r,o,u,$){super(),this.c=t,this.f=r,this.g=u,this.h=$,this.b=this.B(new P.$ke),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),$),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(m.FileOperation.CREATE)||D.isOperation(m.FileOperation.COPY)||D.isOperation(m.FileOperation.DELETE)||D.isOperation(m.FileOperation.WRITE))&&o.isEqual(D.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return I.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Oo=h;class g{constructor(t,r,o,u,$,D,T,A,N,M,G,Z,ee){this.a=t,this.b=r,this.c=o,this.overrideIdentifiers=u,this.d=$,this.f=D,this.g=T,this.h=A,this.i=N,this.j=M,this.k=G,this.l=Z,this.m=ee}get value(){return p(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class O{constructor(t,r,o,u,$,D,T,A,N,M){this.j=t,this.l=r,this.m=o,this.n=u,this.p=$,this.q=D,this.r=T,this.s=A,this.t=N,this.u=M,this.h=null,this.i=new L.$zc,this.v=null}getValue(t,r,o){return this.w(t,r,o).getValue(t)}updateValue(t,r,o={}){let u;o.resource?(u=this.t.get(o.resource),u||(u=I.createEmptyModel(this.u),this.t.set(o.resource,u))):u=this.s,r===void 0?u.removeValue(t):u.setValue(t,r),o.resource||(this.h=null)}inspect(t,r,o){const u=this.w(t,r,o),$=this.A(r.resource,o),D=r.resource?this.t.get(r.resource)||this.s:this.s,T=new Set;for(const A of u.overrides)for(const N of A.identifiers)u.getOverrideValue(t,N)!==void 0&&T.add(N);return new g(t,r,u.getValue(t),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,$||void 0,D)}keys(t){const r=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,r){this.r.set(t,r),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=[];if(!r){const{added:u,updated:$,removed:D}=l(this.j,t);r=[...u,...$,...D]}for(const u of r)for(const $ of(0,c.$Fo)(u)){const D=this.j.getKeysForOverrideIdentifier($),T=t.getKeysForOverrideIdentifier($),A=[...T.filter(N=>D.indexOf(N)===-1),...D.filter(N=>T.indexOf(N)===-1),...D.filter(N=>!R.$go(this.j.override($).getValue(N),t.override($).getValue(N)))];o.push([$,A])}return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:r,updated:o,removed:u}=l(this.l,t),$=[...r,...o,...u];return $.length&&this.updatePolicyConfiguration(t),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:r,updated:o,removed:u,overrides:$}=l(this.applicationConfiguration,t),D=[...r,...o,...u];return D.length&&this.updateApplicationConfiguration(t),{keys:D,overrides:$}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:u,overrides:$}=l(this.localUserConfiguration,t),D=[...r,...o,...u];return D.length&&this.updateLocalUserConfiguration(t),{keys:D,overrides:$}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:u,overrides:$}=l(this.remoteUserConfiguration,t),D=[...r,...o,...u];return D.length&&this.updateRemoteUserConfiguration(t),{keys:D,overrides:$}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:u,overrides:$}=l(this.workspaceConfiguration,t),D=[...r,...o,...u];return D.length&&this.updateWorkspaceConfiguration(t),{keys:D,overrides:$}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:u,updated:$,removed:D,overrides:T}=l(o,r),A=[...u,...$,...D];return(A.length||!o)&&this.updateFolderConfiguration(t,r),{keys:A,overrides:T}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:u,removed:$,overrides:D}=l(r,void 0);return{keys:[...o,...u,...$],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,r,o){let u=this.x(r,o);return r.overrideIdentifier&&(u=u.override(r.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(u=u.merge(this.l)),u}x({resource:t},r){let o=this.y();if(r&&t){const u=r.getFolder(t);u&&(o=this.z(u.uri)||o);const $=this.t.get(t);$&&(o=o.merge($))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let r=this.i.get(t);if(!r){const o=this.y(),u=this.r.get(t);u?(r=o.merge(u),this.i.set(t,r)):r=o}return r}A(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,r)=>{const{contents:o,overrides:u,keys:$}=this.r.get(r);return t.push([r,{contents:o,overrides:u,keys:$}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(r=>t.add(r)),this.userConfiguration.keys.forEach(r=>t.add(r)),this.q.keys.forEach(r=>t.add(r)),this.r.forEach(r=>r.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(r=>t.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>t.add(r)),this.q.getAllOverrideIdentifiers().forEach(r=>t.add(r)),this.r.forEach(r=>r.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const r=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u))),[...r.values()]}static parse(t,r){const o=this.E(t.defaults,r),u=this.E(t.policy,r),$=this.E(t.application,r),D=this.E(t.user,r),T=this.E(t.workspace,r),A=t.folders.reduce((N,M)=>(N.set(a.URI.revive(M[0]),this.E(M[1],r)),N),new L.$zc);return new O(o,u,$,D,I.createEmptyModel(r),T,A,I.createEmptyModel(r),new L.$zc,r)}static E(t,r){return new I(t.contents,t.keys,t.overrides,void 0,r)}}e.$Po=O;function y(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const u of s)u.keys.forEach($=>t.add($)),u.overrides.forEach(([$,D])=>{const T=(0,L.$wc)(r,$,new Set);D.forEach(A=>T.add(A))});const o=[];return r.forEach((u,$)=>o.push([$,[...u.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,r,o,u,$){this.change=t,this.f=r,this.g=o,this.h=u,this.i=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of t.keys)this.affectedKeys.add(D);for(const[,D]of t.overrides)for(const T of D)this.affectedKeys.add(T);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=O.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,r){const o=this.a+t,u=this.d.indexOf(o);if(u<0)return!1;const $=u+o.length;if($>=this.d.length)return!1;const D=this.d.charCodeAt($);if(D!==this.b&&D!==this.c)return!1;if(r){const T=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.f?.workspace):void 0,A=this.g.getValue(t,r,this.h);return!R.$go(T,A)}return!0}}e.$Ro=i;function l(s,t){const{added:r,removed:o,updated:u}=n(t?.rawConfiguration,s?.rawConfiguration),$=[],D=s?.getAllOverrideIdentifiers()||[],T=t?.getAllOverrideIdentifiers()||[];if(t){const A=T.filter(N=>!D.includes(N));for(const N of A)$.push([N,t.getKeysForOverrideIdentifier(N)])}if(s){const A=D.filter(N=>!T.includes(N));for(const N of A)$.push([N,s.getKeysForOverrideIdentifier(N)])}if(t&&s){for(const A of D)if(T.includes(A)){const N=n({contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)},{contents:t.getOverrideValue(void 0,A)||{},keys:t.getKeysForOverrideIdentifier(A)});$.push([A,[...N.added,...N.removed,...N.updated]])}}return{added:r,removed:o,updated:u,overrides:$}}function n(s,t){const r=s?t?s.keys.filter($=>t.keys.indexOf($)===-1):[...s.keys]:[],o=t?s?t.keys.filter($=>s.keys.indexOf($)===-1):[...t.keys]:[],u=[];if(s&&t){for(const $ of t.keys)if(s.keys.indexOf($)!==-1){const D=(0,f.$fj)(t.contents,$),T=(0,f.$fj)(s.contents,$);R.$go(D,T)||u.push($)}}return{added:r,removed:o,updated:u}}}),define(le[116],ue([0,1,19,4,2,27,3,66,40,6,39,37]),function(Q,e,S,P,v,k,L,R,w,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=void 0;class m extends v.$Tc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new P.$ke),this.onDidChangeConfiguration=this.a.event,this.b=R.$Mo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(c.$po.as(w.$uo.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:h})=>this.f(Array.from(b),h))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,h){this.j(b,c.$po.as(w.$uo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=R.$Mo.createEmptyModel(this.c);const b=c.$po.as(w.$uo.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,h){const g=this.g();for(const O of b){const y=g[O],i=h[O];y!==void 0?this.b.setValue(O,y):i?this.b.setValue(O,i.default):this.b.removeValue(O)}}}e.$So=m;class d{constructor(){this.onDidChangeConfiguration=P.Event.None,this.configurationModel=R.$Mo.createEmptyModel(new a.$lk)}async initialize(){return this.configurationModel}}e.$To=d;let p=class extends v.$Tc{get configurationModel(){return this.b}constructor(b,h,g){super(),this.c=b,this.f=h,this.g=g,this.a=this.B(new P.$ke),this.onDidChangeConfiguration=this.a.event,this.b=R.$Mo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const h={},g=[],O=c.$po.as(w.$uo.Configuration).getConfigurationProperties();for(const y of b){const i=O[y];if(!i){g.push(y);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}g.push(y),h[i.policy.name]={type:i.type}}}return(0,L.$qg)(h)||await this.f.updatePolicyDefinitions(h),g}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const h=c.$po.as(w.$uo.Configuration).getPolicyConfigurations(),g=(0,S.$Gb)(b.map(O=>h.get(O)));this.m(g,!0)}m(b,h){this.g.trace("PolicyConfiguration#update",b);const g=c.$po.as(w.$uo.Configuration).getConfigurationProperties(),O=[],y=this.b.isEmpty();for(const i of b){const l=g[i]?.policy?.name;if(l){const n=this.f.getPolicyValue(l);(y?n!==void 0:!(0,k.$go)(this.b.getValue(i),n))&&O.push([i,n])}else this.b.getValue(i)!==void 0&&O.push([i,void 0])}if(O.length){this.g.trace("PolicyConfiguration#changed",O);const i=this.b;this.b=R.$Mo.createEmptyModel(this.g);for(const l of i.keys)this.b.setValue(l,i.getValue(l));for(const[l,n]of O)n===void 0?this.b.removeValue(l):this.b.setValue(l,n);h&&this.a.fire(this.b)}}};e.$Uo=p,e.$Uo=p=ve([re(1,f.$ro),re(2,a.$$j)],p)}),define(le[117],ue([0,1,19,8,13,4,34,77,2,25,27,12,16,30,66,40,116,9,39]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=void 0;class O extends w.$Tc{constructor(l,n,s,t){super(),this.m=l,this.n=t,this.h=this.B(new k.$ke),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$So(t)),this.c=s instanceof g.$to?new b.$To:this.B(new b.$Uo(this.b,s,t)),this.f=this.B(new p.$Oo(this.m,{},m.$8g,n,t)),this.a=new p.$Po(this.b.configurationModel,this.c.configurationModel,p.$Mo.createEmptyModel(t),p.$Mo.createEmptyModel(t),p.$Mo.createEmptyModel(t),p.$Mo.createEmptyModel(t),new a.$zc,p.$Mo.createEmptyModel(t),new a.$zc,t),this.j=new y(l,n,this),this.g=this.B(new P.$Ph(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:o})=>this.s(r,o))),this.B(this.c.onDidChangeConfiguration(r=>this.t(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,n,s]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$Po(l,n,p.$Mo.createEmptyModel(this.n),s,p.$Mo.createEmptyModel(this.n),p.$Mo.createEmptyModel(this.n),new a.$zc,p.$Mo.createEmptyModel(this.n),new a.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,n){const s=typeof l=="string"?l:void 0,t=(0,d.$$i)(l)?l:(0,d.$$i)(n)?n:{};return this.a.getValue(s,t,void 0)}async updateValue(l,n,s,t,r){const o=(0,d.$_i)(s)?s:(0,d.$$i)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,u=o?t:s;if(u!==void 0&&u!==d.ConfigurationTarget.USER_LOCAL&&u!==d.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,S.$Lb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const $=this.inspect(l,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if($.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,f.$go)(n,$.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(N=>(0,S.$tb)([...N.identifiers].sort(),T));A&&(o.overrideIdentifiers=A.identifiers)}const D=o?.overrideIdentifiers?.length?[(0,I.$Go)(o.overrideIdentifiers),l]:[l];await this.j.write(D,n),await this.reloadConfiguration()}inspect(l,n={}){return this.a.inspect(l,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const n=this.a.toData(),s=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(s,n,d.ConfigurationTarget.USER)}s(l,n){const s=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(l,n);this.u(t,s,d.ConfigurationTarget.DEFAULT)}t(l){const n=this.a.toData(),s=this.a.compareAndUpdatePolicyConfiguration(l);this.u(s,n,d.ConfigurationTarget.DEFAULT)}u(l,n,s){const t=new p.$Ro(l,{data:n},this.a,void 0,this.n);t.source=s,this.h.fire(t)}}e.$Vo=O;class y{constructor(l,n,s){this.b=l,this.c=n,this.d=s,this.a=new P.$Kh}write(l,n){return this.a.queue(()=>this.e(l,n))}async e(l,n){let s;try{s=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND)s="{}";else throw o}const t=[];if((0,L.$Wn)(s,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(s,l,n);s=(0,R.$bo)(s,r),await this.c.writeFile(this.b,v.$Me.fromString(s))}f(l,n,s){const{tabSize:t,insertSpaces:r,eol:o}=this.h;if(!n.length){const u=JSON.stringify(s,null,r?" ".repeat(t):"	");return[{content:u,length:u.length,offset:0}]}return(0,R.$$n)(l,n,s,{tabSize:t,insertSpaces:r,eol:o})}get h(){if(!this.g){let l=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(l=n),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[67],ue([0,1,14]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=P,e.$gn=v,e.$hn=k,e.$in=L;function P(w){return w.scheme===S.Schemas.vscodeRemote?w.authority:void 0}function v(w){if(!w)return;const a=w.indexOf("+");return a<0?w:w.substr(0,a)}function k(w){const{host:a,port:f}=R(w);if(typeof f>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function L(w,a){let{host:f,port:c}=R(w);return typeof c>"u"&&(c=a),{host:f,port:c}}function R(w){const a=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=w.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const c=w.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:w,port:void 0}}}),define(le[22],ue([0,1,31,10,67]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$rn=e.$qn=e.$pn=e.TargetPlatform=e.ExtensionType=e.$on=e.$mn=e.$ln=e.$kn=e.$jn=void 0,e.$nn=k,e.$sn=c,e.$tn=m,e.$un=d,e.$vn=p,e.$wn=I,e.$xn=b,S=ye(S),e.$jn="extensions.user.cache",e.$kn="extensions.builtin.cache",e.$ln="undefined_publisher",e.$mn=["ui","workspace","web"];function k(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$on=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class w{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,O){if(typeof g>"u"||g===null)return typeof O>"u"||O===null;if(typeof O>"u"||O===null)return!1;if(typeof g=="string"||typeof O=="string"){const y=typeof g=="string"?g:g.value,i=typeof O=="string"?O:O.value;return S.$Ef(y,i)}return g._lower===O._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$pn=w;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const O of g)this.add(O)}add(g){this.c.add(w.toKey(g))}delete(g){return this.c.delete(w.toKey(g))}has(g){return this.c.has(w.toKey(g))}}e.$qn=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(w.toKey(g))}get(g){return this.c.get(w.toKey(g))}has(g){return this.c.has(w.toKey(g))}set(g,O){this.c.set(w.toKey(g),O)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$rn=f;function c(h){return m(h)}function m(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function d(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function p(h,g){if(g){const O=`onResolveRemoteAuthority:${(0,v.$gn)(g)}`;return!!h.activationEvents?.includes(O)}return!1}function I(h){return h.map(g=>{const[O,y]=g.split("@");return{proposalName:O,version:y?parseInt(y):void 0}})}function b(h){return h.map(g=>g.split("@")[0])}e.$yn=(0,P.$Di)("IBuiltinExtensionsScannerService")}),define(le[20],ue([0,1,12,5,22,10]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.ExtensionManagementErrorCode=e.$kp=e.ExtensionGalleryErrorCode=e.$jp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$dp=R,e.$ep=w,e.$fp=a,e.$gp=f,e.$hp=c,e.$ip=m,e.$9o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$0o=new RegExp(e.$9o),e.$$o="__web_extension",e.$_o="skipWalkthrough",e.$ap="extensionInstallSource",e.$bp="dependecyOrPackExtensionInstall",e.$cp="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function R(i){switch(i){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function w(i){switch(i){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function a(i,l){switch(i){case S.Platform.Windows:return l==="x64"?v.TargetPlatform.WIN32_X64:l==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Linux:return l==="x64"?v.TargetPlatform.LINUX_X64:l==="arm64"?v.TargetPlatform.LINUX_ARM64:l==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?v.TargetPlatform.ALPINE_X64:l==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Mac:return l==="x64"?v.TargetPlatform.DARWIN_X64:l==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Web:return v.TargetPlatform.WEB}}function f(i,l){return l===v.TargetPlatform.WEB&&!i.includes(v.TargetPlatform.WEB)}function c(i,l,n){return f(l,n)?!1:i===v.TargetPlatform.UNDEFINED||i===v.TargetPlatform.UNIVERSAL?!0:i===v.TargetPlatform.UNKNOWN?!1:i===n}function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var d;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var p;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var I;(function(i){i.Install="install",i.Uninstall="uninstall"})(I||(e.StatisticType=I={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$jp=(0,k.$Di)("extensionGalleryService");var h;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(h||(e.ExtensionGalleryErrorCode=h={}));class g extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$kp=g;var O;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(O||(e.ExtensionManagementErrorCode=O={}));class y extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$lp=y,e.$mp=(0,k.$Di)("extensionManagementService"),e.$np="extensionsIdentifiers/disabled",e.$op="extensionsIdentifiers/enabled",e.$pp=(0,k.$Di)("IGlobalExtensionEnablementService"),e.$qp=(0,k.$Di)("IExtensionTipsService"),e.$rp=(0,P.localize2)(11426,"Extensions"),e.$sp=(0,P.localize2)(11427,"Preferences")}),define(le[118],ue([0,1,2,22,9]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class k extends S.$Tc{constructor(R,w,a,f,c){super(),this.a=R,this.b=w,this.c=a,this.f=c,this.B(f.onDidInstallExtensions(m=>this.g(m))),this.B(f.onDidUninstallExtension(m=>this.h(m)))}g(R){for(const w of R)w.local&&this.invalidate(w.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,R)&&await this.j(w);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,P.$jn))}catch(w){(0,v.$pl)(w)!==v.FileOperationResult.FILE_NOT_FOUND&&this.f.error(w)}}}e.$Uq=k});var ze=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(le[44],ue([0,1,16,57,5,45,22,97]),function(Q,e,S,P,v,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=f,e.$Yp=c,e.$Zp=m,e.$1p=d,e.$2p=p,e.$3p=I,e.$4p=b,e.$5p=h,P=ze(P),v=ye(v),k=ye(k);const w=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function f(y){return y=y.trim(),y==="*"||w.test(y)}function c(y){if(!f(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=y.match(w);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function m(y){if(!y)return null;const i=y.majorBase,l=y.majorMustEqual,n=y.minorBase;let s=y.minorMustEqual;const t=y.patchBase;let r=y.patchMustEqual;y.hasCaret&&(i===0||(s=!1),r=!1);let o=0;if(y.preRelease){const u=a.exec(y.preRelease);if(u){const[,$,D,T]=u;o=Date.UTC(Number($),Number(D)-1,Number(T))}}return{majorBase:i,majorMustEqual:l,minorBase:n,minorMustEqual:s,patchBase:t,patchMustEqual:r,isMinimum:y.hasGreaterEquals,notBefore:o}}function d(y,i,l){let n;typeof y=="string"?n=m(c(y)):n=y;let s;i instanceof Date?s=i.getTime():typeof i=="string"&&(s=new Date(i).getTime());let t;if(typeof l=="string"?t=m(c(l)):t=l,!n||!t)return!1;const r=n.majorBase,o=n.minorBase,u=n.patchBase;let $=t.majorBase,D=t.minorBase,T=t.patchBase;const A=t.notBefore;let N=t.majorMustEqual,M=t.minorMustEqual,G=t.patchMustEqual;return t.isMinimum?r>$?!0:r<$?!1:o>D?!0:o<D||s&&s<A?!1:u>=T:(r===1&&$===0&&(!N||!M||!G)&&($=1,D=0,T=0,N=!0,M=!1,G=!1),r<$?!1:r>$?!N:o<D?!1:o>D?!M:u<T?!1:u>T?!G:!(s&&s<A))}function p(y,i,l,n,s,t){const r=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return r.push([P.default.Error,v.localize(11357,null)]),r;if(typeof n.name!="string")return r.push([P.default.Error,v.localize(11358,null,"name")]),r;if(typeof n.version!="string")return r.push([P.default.Error,v.localize(11359,null,"version")]),r;if(!n.engines)return r.push([P.default.Error,v.localize(11360,null,"engines")]),r;if(typeof n.engines.vscode!="string")return r.push([P.default.Error,v.localize(11361,null,"engines.vscode")]),r;if(typeof n.extensionDependencies<"u"&&!O(n.extensionDependencies))return r.push([P.default.Error,v.localize(11362,null,"extensionDependencies")]),r;if(typeof n.activationEvents<"u"){if(!O(n.activationEvents))return r.push([P.default.Error,v.localize(11363,null,"activationEvents")]),r;if(typeof n.main>"u"&&typeof n.browser>"u")return r.push([P.default.Error,v.localize(11364,null,"activationEvents","main","browser")]),r}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&r.push([P.default.Warning,v.localize(11365,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return r.push([P.default.Error,v.localize(11366,null,"main")]),r;{const $=(0,S.$eh)(l,n.main);(0,S.$$g)($,l)||r.push([P.default.Warning,v.localize(11367,null,$.path,l.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return r.push([P.default.Error,v.localize(11368,null,"browser")]),r;{const $=(0,S.$eh)(l,n.browser);(0,S.$$g)($,l)||r.push([P.default.Warning,v.localize(11369,null,$.path,l.path)])}}if(!k.valid(n.version))return r.push([P.default.Error,v.localize(11370,null)]),r;const o=[];if(!I(y,i,n,s,o))for(const $ of o)r.push([P.default.Error,$]);if(t&&n.enabledApiProposals?.length){const $=[];if(!h([...n.enabledApiProposals],$))for(const D of $)r.push([P.default.Error,D])}return r}function I(y,i,l,n,s){return n||typeof l.main>"u"&&typeof l.browser>"u"?!0:g(y,i,l.engines.vscode,s)}function b(y,i,l){return y==="*"||g(i,l,y)}function h(y,i){if(y.length===0)return!0;const l=Array.isArray(i)?i:void 0,n=(l?void 0:i)??R.allApiProposals,s=[],t=(0,L.$wn)(y);for(const{proposalName:r,version:o}of t){const u=n[r];u&&o&&u.version!==o&&s.push(v.localize(11371,null,r))}return l?.push(...s),s.length===0}function g(y,i,l,n=[]){const s=m(c(l));if(!s)return n.push(v.localize(11372,null,l)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return n.push(v.localize(11373,null,l)),!1}else if(!s.majorMustEqual)return n.push(v.localize(11374,null,l)),!1;return d(y,i,s)?!0:(n.push(v.localize(11375,null,y,l)),!1)}function O(y){if(!Array.isArray(y))return!1;for(let i=0,l=y.length;i<l;i++)if(typeof y[i]!="string")return!1;return!0}}),define(le[68],ue([0,1,21,2,12,5,20,10]),function(Q,e,S,P,v,k,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=void 0,e.$9r=w;function w(f){return f.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}e.$0r=(0,R.$Di)("languagePackService");let a=class extends P.$Tc{constructor(c){super(),this.c=c}async getAvailableLanguages(){const c=new S.$ve;setTimeout(()=>c.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const p=m.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(b=>b.startsWith("lp-"))).map(I=>{const b=I.properties.localizedLanguages?.[0],h=w(I);return{...this.f(h,b,I),extensionId:I.identifier.id,galleryExtension:I}});return p.push(this.f("en","English")),p}f(c,m,d){const p=m??c;let I;if(p!==c&&(I=`(${c})`),c.toLowerCase()===v.$x.toLowerCase()&&(I??="",I+=(0,k.localize)(11279,null)),d?.installCount){I??="";const b=d.installCount;let h;b>1e6?h=`${Math.floor(b/1e5)/10}M`:b>1e3?h=`${Math.floor(b/1e3)}K`:h=String(b),I+=` $(cloud-download) ${h}`}return{id:c,label:p,description:I}}};e.$$r=a,e.$$r=a=ve([re(0,L.$jp)],a)}),define(le[46],ue([0,1,13,7,2,5,40,10,6,37]),function(Q,e,S,P,v,k,L,R,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$8p=m,e.$9p=d,e.$0p=p,e.$$p=I,e.$_p=b,e.$aq=h,e.$6p=(0,R.$Di)("requestService");class f{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?i[l]="*****":i[l]=this.b[l];this.a=i}return this.a}}class c extends v.$Tc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,k.localize)(11144,null),when:w.$qk.isEqualTo((0,w.$nk)(w.LogLevel.Trace)).serialize()})}async c(i,l,n){const s=`${i} #${++this.b}: ${l.url}`;this.a.trace(`${s} - begin`,l.type,new f(l.headers??{}));try{const t=await n();return this.a.trace(`${s} - end`,l.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${s} - error`,l.type,(0,P.$9)(t)),t}}}e.$7p=c;function m(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function d(y){return y.res.statusCode===204}async function p(y){return d(y)?null:(await(0,S.$Ye)(y.stream)).toString()}async function I(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);return p(y)}async function b(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);if(d(y))return null;const l=(await(0,S.$Ye)(y.stream)).toString();try{return JSON.parse(l)}catch(n){throw n.message+=`:
`+l,n}}function h(y){O(y)}let g;function O(y){const i=a.$po.as(L.$uo.Configuration),l=g;g={id:"http",order:15,title:(0,k.localize)(11145,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(11146,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(11147,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(11148,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(11149,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(11150,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(11151,null),(0,k.localize)(11152,null),(0,k.localize)(11153,null),(0,k.localize)(11154,null)],default:"override",description:(0,k.localize)(11155,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11156,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(11157,null),restricted:!0}}},i.updateConfigurations({add:[g],remove:l?[l]:[]})}O(L.ConfigurationScope.APPLICATION)}),define(le[119],ue([0,1,21,14,9,46]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0;let L=class{constructor(w,a){this.a=w,this.b=a}async download(w,a,f=S.CancellationToken.None){if(w.scheme===P.Schemas.file||w.scheme===P.Schemas.vscodeRemote){await this.b.copy(w,a);return}const c={type:"GET",url:w.toString(!0)},m=await this.a.request(c,f);if(m.res.statusCode===200)await this.b.writeFile(a,m.stream);else{const d=await(0,k.$$p)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};e.$TR=L,e.$TR=L=ve([re(0,k.$6p),re(1,v.$$k)],L)}),define(le[120],ue([0,1,121,3]),function(Q,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=k;function v(L,R){return L.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:L.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function k(L,R,w={}){const a=(0,S.parse)(L),f=w.proxyUrl||v(a,R);if(!f)return null;const c=(0,S.parse)(f);if(!/^https?:$/.test(c.protocol||""))return null;const m={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,P.$jg)(w.strictSSL)?w.strictSSL:!0};if(a.protocol==="http:"){const d=await new Promise((p,I)=>{Q(["http-proxy-agent"],p,I)}).then(ye);return new d.HttpProxyAgent(f,m)}else{const d=await new Promise((p,I)=>{Q(["https-proxy-agent"],p,I)}).then(ye);return new d.HttpsProxyAgent(f,m)}}}),define(le[122],ue([0,1,60,15,5,21,38,7,12,28,86,152,8,79]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=I;let p;async function I(h,g,O,y){return O["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$j?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.$Im)(y)&&!O["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.$Im)(y)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(i,l)=>{const n=new k.$ve;let s=1e4;const t=h.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(s=(0,d.$Jm)(t,1,120)*1e3);const r=setTimeout(()=>{n.dispose(!0),l(new Error((0,v.localize)(11141,null)))},s);try{i(await b(g,n.token))}catch(o){!(0,R.$3)(o)&&!n.token.isCancellationRequested?l(new Error((0,v.localize)(11142,null,(0,L.$oj)(o)))):i({})}finally{clearTimeout(r),n.dispose()}})),p)}async function b(h,g){const O=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",O);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",y);const i=(0,a.$Zg)().replace(/-/g,"").substr(0,12),l=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",n);const s=await(0,f.$ym)(w.OS,n);return h.trace("getUnixShellEnvironment#shell",s),new Promise((t,r)=>{if(g.isCancellationRequested)return r(new R.$4);const o=(0,P.$mc)(s);let u,$;const D="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${D} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,$=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${D} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,$=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,$=["-i","-l","-c"]):(u=`'${process.execPath}' ${D} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?$=["-ic"]:$=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify($),u);const T=(0,S.spawn)(s,[...$,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});g.onCancellationRequested(()=>(T.kill(),r(new R.$4))),T.on("error",M=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,L.$oj)(M)),r(M)});const A=[];T.stdout.on("data",M=>A.push(M));const N=[];T.stderr.on("data",M=>N.push(M)),T.on("close",(M,G)=>{const Z=Buffer.concat(A).toString("utf8");h.trace("getUnixShellEnvironment#raw",Z);const ee=Buffer.concat(N).toString("utf8");if(ee.trim()&&h.trace("getUnixShellEnvironment#stderr",ee),M||G)return r(new Error((0,v.localize)(11143,null,M,G)));const oe=l.exec(Z),ce=oe?oe[1]:"{}";try{const fe=JSON.parse(ce);O?fe.ELECTRON_RUN_AS_NODE=O:delete fe.ELECTRON_RUN_AS_NODE,y?fe.ELECTRON_NO_ATTACH_CONSOLE=y:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",fe),t(fe)}catch(fe){h.error("getUnixShellEnvironment#errorCaught",(0,L.$oj)(fe)),r(fe)}})})}}),define(le[123],ue([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wR=e.$vR=void 0,e.$vR=(0,S.$Di)("stateReadService"),e.$wR=(0,S.$Di)("stateService")}),define(le[69],ue([0,1,8,13,2,3,17,9,6]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=e.$yR=e.$xR=e.SaveStrategy=void 0;var a;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class f extends v.$Tc{constructor(p,I,b,h){super(),this.h=p,this.j=I,this.m=b,this.n=h,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Bh(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==R.FileOperationResult.FILE_NOT_FOUND&&this.m.error(p)}}getItem(p,I){const b=this.a[p];return(0,k.$mg)(b)?I:b}setItem(p,I){this.setItems([{key:p,data:I}])}setItems(p){let I=!1;for(const{key:b,data:h}of p)this.a[b]!==h&&((0,k.$mg)(h)?(0,k.$kg)(this.a[b])||(this.a[b]=void 0,I=!0):(this.a[b]=h,I=!0));I&&this.s()}removeItem(p){(0,k.$kg)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,P.$Me.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(I){this.m.error(I)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$xR=f;let c=class extends v.$Tc{constructor(p,I,b,h){super(),this.a=this.B(new f(I.stateResource,p,b,h))}async init(){await this.a.init()}getItem(p,I){return this.a.getItem(p,I)}};e.$yR=c,e.$yR=c=ve([re(1,L.$Ki),re(2,w.$$j),re(3,R.$$k)],c);class m extends c{setItem(p,I){this.a.setItem(p,I)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$zR=m}),define(le[70],ue([0,1,12,36,28]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=L,e.$up=R;function k(w){if(S.$v===S.Platform.Linux&&/^penguin(\.|$)/i.test(w))return"chromebook"}function L(w,a,f,c,m,d,p,I,b,h){const g=Object.create(null);g["common.machineId"]=d,g["common.sqmId"]=p,g["common.devDeviceId"]=I,g.sessionID=(0,v.$Zg)()+Date.now(),g.commitHash=c,g.version=m,g["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.$i)(S.$v),g["common.nodePlatform"]=P.$cc,g["common.nodeArch"]=f,g["common.product"]=h||"desktop",b&&(g["common.msftInternal"]=b);let O=0;const y=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>O++,enumerable:!0}}),S.$m&&(g["common.snap"]="true");const i=k(a);return i&&(g["common.platformDetail"]=i),g}function R(w){const a=P.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return w.some(c=>f===c)}}),define(le[18],ue([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l=(0,S.$Di)("telemetryService"),e.$$l=(0,S.$Di)("customEndpointTelemetryService"),e.$_l="telemetry.currentSessionDate",e.$am="telemetry.firstSessionDate",e.$bm="telemetry.lastSessionDate",e.$cm="telemetry.machineId",e.$dm="telemetry.sqmId",e.$em="telemetry.devDeviceId",e.$fm="telemetry",e.$gm="telemetry.telemetryLevel",e.$hm="telemetry.enableCrashReporter",e.$im="telemetry.enableTelemetry";var P;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var v;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(v||(e.TelemetryConfiguration=v={}))}),define(le[71],ue([0,1,7,10,6,18]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.ExtensionSignatureVerificationCode=e.$rq=void 0,e.$rq=(0,P.$Di)("IExtensionSignatureVerificationService");var L;(function(a){a.Success="Success",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(e.ExtensionSignatureVerificationCode=L={}));class R extends Error{constructor(f){super(f),this.code=f}}e.$sq=R;let w=class{constructor(f,c){this.b=f,this.c=c}d(){return this.a||(this.a=new Promise((f,c)=>Q(["@vscode/vsce-sign"],async m=>f(m),c))),this.a}async verify(f,c,m,d){let p;const I=f.identifier.id;try{p=await this.d()}catch(O){return this.b.error("Could not load vsce-sign module",(0,S.$9)(O)),this.b.info(`Extension signature verification is not done: ${I}`),!1}const b=new Date().getTime();let h;try{this.b.trace(`Verifying extension signature for ${I}...`),h=await p.verify(c,m,this.b.getLevel()===v.LogLevel.Trace)}catch(O){h={code:L.UnknownError,didExecute:!1,output:(0,S.$9)(O)}}const g=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${I}: ${h.code}. Executed: ${h.didExecute}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${I}:
${h.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:I,extensionVersion:f.version,code:h.code,internalCode:h.internalCode,duration:g,didExecute:h.didExecute,clientTargetPlatform:d}),h.code===L.Success)return!0;throw new R(h.code)}};e.$tq=w,e.$tq=w=ve([re(0,v.$$j),re(1,k.$0l)],w)}),define(le[41],ue([0,1,27,3,67,70,18]),function(Q,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$Cp=f,e.$Dp=c,e.$Ep=m,e.$Fp=d,e.$Gp=I,e.$Hp=h,e.$Ip=g,e.$Jp=i;class R{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$vp=R;class w{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$wp=w,e.$xp=new w;class a{async publicLog(n,s,t){}async publicLogError(n,s,t){}}e.$yp=a,e.$zp="telemetry",e.$Ap="extensionTelemetryLog",e.$Bp={log:()=>null,flush:()=>Promise.resolve(null)};function f(l,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!l.enableTelemetry)}function c(l,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function m(l){const n=l.getValue(L.$gm),s=l.getValue(L.$hm);if(l.getValue(L.$im)===!1||s===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function d(l){const n={},s={},t={};b(l,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const o=t[r];typeof o=="number"?s[r]=o:typeof o=="boolean"?s[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),n[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[r]=o)}return{properties:n,measurements:s}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function I(l){if(!l)return"none";const n=(0,v.$gn)(l);return p.has(n)?n:"other"}function b(l,n,s=0,t){if(l)for(const r of Object.getOwnPropertyNames(l)){const o=l[r],u=t?t+r:r;Array.isArray(o)?n[u]=(0,S.$ho)(o):o instanceof Date?n[u]=o.toISOString():(0,P.$fg)(o)?s<2?b(o,n,s+1,u+"."):n[u]=(0,S.$ho)(o):n[u]=o}}function h(l,n){const s=l.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,k.$up)(s)||t}function g(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function O(l,n){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let s=l;const t=[];for(const $ of n)for(;;){const D=$.exec(l);if(!D)break;t.push([D.index,$.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(s="";;){const $=o.exec(l);if(!$)break;const D=t.some(([T,A])=>$.index<A&&T<o.lastIndex);!r.test($[0])&&!D&&(s+=l.substring(u,$.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<l.length&&(s+=l.substr(u)),s}function y(l){if(!l)return l;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of n)if(s.regex.test(l))return`<REDACTED: ${s.label}>`;return l}function i(l,n){return(0,S.$eo)(l,s=>{if(s instanceof R||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let t=s.replaceAll("%20"," ");t=O(t,n);for(const r of n)t=t.replace(r,"");return t=y(t),t}})}}),define(le[26],ue([0,1,31,20,22,12,11,7,36,41]),function(Q,e,S,P,v,k,L,R,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Lp=void 0,e.$Kp=f,e.$Mp=p,e.$Np=I,e.$Op=b,e.$Pp=h,e.$Qp=g,e.$Rp=O,e.$Sp=y,e.$Up=i,e.$Vp=n;function f(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,S.$zf)(s.id,t.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new m(t.identifier,r,o)}static parse(t){const r=c.exec(t);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o=v.TargetPlatform.UNDEFINED){this.identifier=t,this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof m?f(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Lp=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(s){const t=d.exec(s);return t&&t[1]?[b(t[1]),t[2]]:[b(s),void 0]}function I(s,t){return`${s}.${t}`}function b(s){return s.toLowerCase()}function h(s,t){return b(I(s??v.$ln,t))}function g(s,t){const r=[],o=u=>{for(const $ of r)if($.some(D=>f(t(D),t(u))))return $;return null};for(const u of s){const $=o(u);$?$.push(u):r.push([u])}return r}function O(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function y(s){return{id:new a.$vp(s.identifier.id),name:new a.$vp(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Tp=new v.$pn("pprice.better-merge");function i(s,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&r.every($=>!f($.identifier,{id:u}))){const $=s.filter(D=>f(D.identifier,{id:u}));$.length===1&&(r.push($[0]),o.push(...$[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function l(s,t){if(!k.$l)return!1;let r;try{r=(await s.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,R.$9)(u))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(s,t){const r=await l(s,t),o=(0,P.$fp)(r?"alpine":k.$v,w.$dc);return t.debug("ComputeTargetPlatform:",o),o}}),define(le[124],ue([0,1,21,7,14,16,45,11,5,20,26,22]),function(Q,e,S,P,v,k,L,R,w,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;const m=I=>(0,w.localize)(11394,null,I),d=(0,w.localize)(11395,null,"ms-dotnettools.csharp");let p=class{constructor(b,h,g){this.a=b,this.b=h,this.d=g}get f(){}async listExtensions(b,h,g){let O=await this.b.getInstalled(c.ExtensionType.User,g);const y=c.$on.map(l=>l.toLowerCase());if(h&&h!==""){if(y.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}O=O.filter(l=>l.manifest.categories?l.manifest.categories.map(s=>s.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),y.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,w.localize)(11396,null,this.f)),O=O.sort((l,n)=>l.identifier.id.localeCompare(n.identifier.id));let i;for(const l of O)i!==l.identifier.id&&(i=l.identifier.id,this.a.info(b?`${i}@${l.manifest.version}`:i))}async installExtensions(b,h,g,O){const y=[];try{b.length&&this.a.info(this.f?(0,w.localize)(11397,null,this.f):(0,w.localize)(11398,null));const i=[],l=[],n=(t,r,o)=>{l.push({id:t,version:r!=="prerelease"?r:void 0,installOptions:{...g,isBuiltin:o,installPreReleaseVersion:r==="prerelease"||g.installPreReleaseVersion}})};for(const t of b)if(t instanceof R.URI)i.push({vsix:t,installOptions:g});else{const[r,o]=(0,f.$Mp)(t);n(r,o,!1)}for(const t of h)if(t instanceof R.URI)i.push({vsix:t,installOptions:{...g,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[r,o]=(0,f.$Mp)(t);n(r,o,!0)}const s=await this.b.getInstalled(void 0,g.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:r})=>{try{await this.h(t,r,O,s)}catch(o){this.a.error(o),y.push(t.toString())}})),l.length){const t=await this.g(l,s,O);y.push(...t)}}catch(i){throw this.a.error((0,w.localize)(11399,null,(0,P.$9)(i))),i}if(y.length)throw new Error((0,w.localize)(11400,null,y.join(", ")))}async updateExtensions(b){const h=await this.b.getInstalled(c.ExtensionType.User,b),g=[];for(const l of h)l.identifier.uuid&&g.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,w.localize)(11401,null,g.length));const O=await this.d.getExtensions(g,{compatible:!0},S.CancellationToken.None),y=[];for(const l of O)for(const n of h)(0,f.$Kp)(n.identifier,l.identifier)&&(0,L.gt)(l.version,n.manifest.version)&&y.push({extension:l,options:{operation:a.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:b,isApplicationScoped:n.isApplicationScoped}});if(!y.length){this.a.info((0,w.localize)(11402,null));return}this.a.info((0,w.localize)(11403,null,y.map(l=>l.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(y);for(const l of i)l.error?this.a.error((0,w.localize)(11404,null,l.identifier.id,(0,P.$9)(l.error))):this.a.info((0,w.localize)(11405,null,l.identifier.id,l.local?.manifest.version))}async g(b,h,g){if(b=b.filter(({id:l,version:n})=>{const s=h.find(t=>(0,f.$Kp)(t.identifier,{id:l}));if(s){if(!g&&(!n||n==="prerelease"&&s.preRelease))return this.a.info((0,w.localize)(11406,null,l,s.manifest.version,l)),!1;if(n&&s.manifest.version===n)return this.a.info((0,w.localize)(11407,null,`${l}@${n}`)),!1}return!0}),!b.length)return[];const O=[],y=[],i=await this.j(b);if(await Promise.all(b.map(async({id:l,version:n,installOptions:s})=>{const t=i.get(l.toLowerCase());if(!t){this.a.error(`${m(n?`${l}@${n}`:l)}
${d}`),O.push(l);return}try{const o=await this.d.getManifest(t,S.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),O.push(l);return}const r=h.find(o=>(0,f.$Kp)(o.identifier,t.identifier));if(r){if(t.version===r.manifest.version){this.a.info((0,w.localize)(11408,null,n?`${l}@${n}`:l));return}this.a.info((0,w.localize)(11409,null,l,t.version))}s.isBuiltin?this.a.info(n?(0,w.localize)(11410,null,l,n):(0,w.localize)(11411,null,l)):this.a.info(n?(0,w.localize)(11412,null,l,n):(0,w.localize)(11413,null,l)),y.push({extension:t,options:{...s,installGivenVersion:!!n,isApplicationScoped:s.isApplicationScoped||r?.isApplicationScoped}})})),y.length){const l=await this.b.installGalleryExtensions(y);for(const n of l)n.error?(this.a.error((0,w.localize)(11414,null,n.identifier.id,(0,P.$9)(n.error))),O.push(n.identifier.id)):this.a.info((0,w.localize)(11415,null,n.identifier.id,n.local?.manifest.version))}return O}async h(b,h,g,O){const y=await this.b.getManifest(b);if(!y)throw new Error("Invalid vsix");if(await this.l(y,g,h.profileLocation,O))try{await this.b.install(b,{...h,installGivenVersion:!0}),this.a.info((0,w.localize)(11416,null,(0,k.$bh)(b)))}catch(l){if((0,P.$3)(l))this.a.info((0,w.localize)(11417,null,(0,k.$bh)(b)));else throw l}}async j(b){const h=new Map,g=b.some(i=>i.installOptions.installPreReleaseVersion),O=await this.b.getTargetPlatform(),y=[];for(const i of b)a.$0o.test(i.id)&&y.push({...i,preRelease:g});if(y.length){const i=await this.d.getExtensions(y,{targetPlatform:O},S.CancellationToken.None);for(const l of i)h.set(l.identifier.id.toLowerCase(),l)}return h}k(b){return!0}async l(b,h,g,O){if(!h){const y={id:(0,f.$Pp)(b.publisher,b.name)},i=O.find(l=>(0,f.$Kp)(y,l.identifier)&&(0,L.gt)(l.manifest.version,b.version));if(i)return this.a.info((0,w.localize)(11418,null,i.identifier.id,i.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,h,g){const O=async i=>{if(i instanceof R.URI){const l=await this.b.getManifest(i);return(0,f.$Np)(l.publisher,l.name)}return i},y=[];for(const i of b){const l=await O(i),s=(await this.b.getInstalled(void 0,g)).filter(t=>(0,f.$Kp)(t.identifier,{id:l}));if(!s.length)throw new Error(`${this.m(l)}
${d}`);if(s.some(t=>t.type===c.ExtensionType.System)){this.a.info((0,w.localize)(11419,null,l));return}if(!h&&s.some(t=>t.isBuiltin)){this.a.info((0,w.localize)(11420,null,l));return}this.a.info((0,w.localize)(11421,null,l));for(const t of s)await this.b.uninstall(t,{profileLocation:g}),y.push(t);this.f?this.a.info((0,w.localize)(11422,null,l,this.f)):this.a.info((0,w.localize)(11423,null,l))}}async locateExtension(b){const h=await this.b.getInstalled();b.forEach(g=>{h.forEach(O=>{if(O.identifier.id===g&&O.location.scheme===v.Schemas.file){this.a.info(O.location.fsPath);return}})})}m(b){return this.f?(0,w.localize)(11424,null,b,this.f):(0,w.localize)(11425,null,b)}};e.$uq=p,e.$uq=p=ve([re(1,a.$mp),re(2,a.$jp)],p)}),define(le[125],ue([0,1,7,4,2,25,26,22,9]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class a extends v.$Tc{constructor(c,m,d,p,I,b,h){super(),this.f=c,this.g=m,this.h=d,this.j=p,this.m=I,this.n=b,this.r=h,this.a=this.B(new P.$ke),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new v.$3c),this.s().then(null,g=>h.error("Error while initializing Extensions Watcher",(0,S.$9)(g)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(m=>(this.c.set(m.id,(0,v.$Qc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(c){for(const m of c.extensions)this.I(this.L(m.identifier,m.version),c.profileLocation)}async y(c){for(const m of c.extensions){const d=this.L(m.identifier,m.version);c.error?this.J(d,c.profileLocation):this.I(d,c.profileLocation)}}async z(c){for(const m of c.extensions)this.J(this.L(m.identifier,m.version),c.profileLocation)}async C(c){const m=[],d=[];for(const p of c.extensions){const I=this.L(p.identifier,p.version);c.error?this.I(I,c.profileLocation):(this.J(I,c.profileLocation),this.b.has(I)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),d.push(this.f.scanInstalledExtensionAtLocation(p.location).then(b=>{b?m.push(b):this.r.info("Extension not found at the location",p.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(d),m.length&&await this.H(m)}catch(p){this.r.error(p)}}D(c){for(const m of this.h.profiles)c.contains(m.extensionsResource,w.FileChangeType.UPDATED,w.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(c){const m=[],d=[],p=await this.j.scanProfileExtensions(c),I=new Set,b=new Set;for(const[h,g]of this.b)g.has(c)&&b.add(h);for(const h of p){const g=this.L(h.identifier,h.version);I.add(g),b.has(g)||(m.push(h.identifier),this.I(g,c))}for(const h of b)if(!I.has(h)){const g=this.M(h);g&&(d.push(g.identifier),this.J(h,c))}(m.length||d.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:c}:void 0,removed:d.length?{extensions:d,profileLocation:c}:void 0})}async G(c){const m=await this.j.scanProfileExtensions(c);for(const d of m)this.I(this.L(d.identifier,d.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(d=>!this.b.has(this.L(d.identifier,d.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,m){let d=this.b.get(c);d||this.b.set(c,d=new k.$Ac(p=>this.m.extUri.getComparisonKey(p))),d.add(m)}J(c,m){const d=this.b.get(c);d&&d.delete(m),d?.size||this.b.delete(c)}L(c,m){return`${R.$pn.toKey(c.id)}@${m}`}M(c){const[m,d]=(0,L.$Mp)(c);return d?{identifier:{id:m},version:d}:void 0}}e.$Vq=a}),define(le[126],ue([0,1,32,153,19,8,2,14,15,29,17,20,26,6,68,11]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0,S=ye(S);let b=class extends p.$$r{constructor(y,i,l,n){super(l),this.h=y,this.j=n,this.g=this.B(new h(i,n)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(y,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const s=n.translations[y];return s?I.URI.file(s):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),i=Object.keys(y).map(l=>{const n=y[l];return{...this.f(l,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((l,n)=>l.label.localeCompare(n.label)),i}async m(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",y.identifier.id),await this.update())}async n(y){const i=await this.g.getLanguagePacks();Object.keys(i).some(l=>i[l]&&i[l].extensions.some(n=>(0,m.$Kp)(n.extensionIdentifier,y.identifier)))&&(this.j.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(i);return!(0,v.$tb)(Object.keys(y),Object.keys(l))}};e.$_r=b,e.$_r=b=ve([re(0,c.$mp),re(1,f.$Li),re(2,c.$jp),re(3,d.$$j)],b);let h=class extends L.$Tc{constructor(y,i){super(),this.j=i,this.c={},this.f=(0,w.$ic)(y.userDataPath,"languagepacks.json"),this.g=new k.$Kh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.s(i=>{Object.keys(i).forEach(l=>delete i[l]),this.m(i,...y)}).then(()=>this.c)}m(y,...i){for(const l of i)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(y,l);Object.keys(y).forEach(l=>this.r(y[l]))}n(y,i){const l=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const s of n)if(i.location.scheme===R.Schemas.file&&g(s)){let t=y[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},y[s.languageId]=t);const r=t.extensions.filter(o=>(0,m.$Kp)(o.extensionIdentifier,l))[0];r?r.version=i.manifest.version:t.extensions.push({extensionIdentifier:l,version:i.manifest.version});for(const o of s.translations)t.translations[o.id]=(0,w.$ic)(i.location.fsPath,o.path)}}r(y){if(y){const i=(0,P.createHash)("md5");for(const l of y.extensions)i.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);y.hash=i.digest("hex")}}s(y=()=>null){return this.g.queue(()=>{let i=null;return S.promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(i=y(l),l)).then(l=>{for(const s of Object.keys(l))l[s]||delete l[s];this.c=l,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),a.Promises.writeFile(this.f,n)}).then(()=>i,l=>this.j.error(l))})}};h=ve([re(0,f.$Li),re(1,d.$$j)],h);function g(O){if(typeof O.languageId!="string"||!Array.isArray(O.translations)||O.translations.length===0)return!1;for(const y of O.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(O.languageName&&typeof O.languageName!="string"||O.localizedLanguageName&&typeof O.localizedLanguageName!="string")}}),define(le[127],ue([0,1,82,7,27,41]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rR=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function w(f,c,m){const d=await(0,S.$AE)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,S.$AE)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new d.AppInsightsCore,b=new p.PostChannel,h={instrumentationKey:f,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(m){h.extensionConfig={};const g={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};h.extensionConfig[b.identifier]=g}return I.initialize(h,[]),I.addTelemetryInitializer(g=>{g.ext=g.ext??{},g.ext.web=g.ext.web??{},g.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&(g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),I}class a{constructor(c,m,d,p,I){this.e=c,this.f=m,this.g=d,this.h=I,this.c=L,this.d=R,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(c){if(this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(m=>{c(m)},m=>{(0,P.$Y)(m),console.error(m)})}}log(c,m){if(!this.a)return;m=(0,v.$fo)(m,this.g),m=(0,k.$Fp)(m);const d=this.f+"/"+c;try{this.i(p=>{p.pluginVersionString=m?.properties.version??"Unknown",p.track({name:d,baseData:{name:d,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}e.$rR=a});var ze=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(le[128],ue([0,1,2,27,12,31,5,30,40,129,33,37,18,41]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0,a=ze(a);let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,g,O){this.k=g,this.l=O,this.d={},this.i=new S.$Sc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,k.$gf)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$gf)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(m.$gm)||y.affectsConfiguration(m.$im)||y.affectsConfiguration(m.$hm))&&this.m()}))}setExperimentProperty(h,g){this.d[h]=g}m(){let h=(0,d.$Ep)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const O=g.usage?m.TelemetryLevel.USAGE:g.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;h=Math.min(h,O)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,g,O){this.g<g||(O=(0,P.$fo)(O,this.d),O=(0,d.$Jp)(O,this.j),O=(0,P.$fo)(O,this.c),this.b.forEach(y=>y.log(h,O)))}publicLog(h,g){this.n(h,m.TelemetryLevel.USAGE,g)}publicLog2(h,g){this.publicLog(h,g)}publicLogError(h,g){this.h&&this.n(h,m.TelemetryLevel.ERROR,g)}publicLogError2(h,g){this.publicLogError(h,g)}};e.$fs=p,e.$fs=p=ve([re(1,R.$0i),re(2,f.$rk)],p);function I(){const b=(0,L.localize)(11122,null,a.default.nameLong),h=a.default.privacyStatementUrl?(0,L.localize)(11124,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,L.localize)(11123,null,"https://aka.ms/vscode-telemetry"),g=v.$p?"":(0,L.localize)(11125,null),O=(0,L.localize)(11126,null),y=(0,L.localize)(11127,null),i=(0,L.localize)(11128,null),l=(0,L.localize)(11129,null),n=`
|       | ${O} | ${y} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,L.localize)(11130,null);return`
${b} ${h} ${g}

&nbsp;

${l}
${n}

&nbsp;

${s}
`}c.$po.as(w.$uo.Configuration).registerConfiguration({id:m.$fm,order:1,type:"object",title:(0,L.localize)(11131,null),properties:{[m.$gm]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(11132,null),(0,L.localize)(11133,null),(0,L.localize)(11134,null),(0,L.localize)(11135,null)],markdownDescription:I(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.$po.as(w.$uo.Configuration).registerConfiguration({id:m.$fm,order:110,type:"object",title:(0,L.localize)(11136,null),properties:{[m.$im]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,L.localize)(11138,null,a.default.nameLong,a.default.privacyStatementUrl):(0,L.localize)(11137,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(11139,null,`\`#${m.$gm}#\``),scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[130],ue([0,1,13,21,154,127]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sR=void 0,v=ye(v);async function L(f,c){const m=await c.request(f,P.CancellationToken.None),d=(await(0,S.$Ye)(m.stream)).toString(),p=m.res.statusCode??200;return{headers:m.res.headers,statusCode:p,responseData:d}}async function R(f){const c={method:f.type,headers:f.headers};return new Promise((d,p)=>{const I=v.request(f.url??"",c,b=>{b.on("data",function(h){d({headers:b.headers,statusCode:b.statusCode??200,responseData:h.toString()})}),b.on("error",function(h){p(h)})});I.write(f.data,b=>{b&&p(b)}),I.end()})}async function w(f,c,m){const d=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),p={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:d};try{const I=f?await L(p,f):await R(p);m(I.statusCode,I.headers,I.responseData)}catch{m(0,{})}}class a extends k.$rR{constructor(c,m,d,p,I){const b={sendPOST:(h,g)=>{w(c,h,g)}};super(m,d,p,I,b)}}e.$sR=a}),define(le[131],ue([0,1,32,15,29]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=k,S=ye(S);async function k(L,R){const w=Object.create(null),a=(c,m)=>{const d=JSON.parse(c);w[m]=d};if(R){const c=[],m=await v.Promises.readdir(R);for(const p of m)try{(await S.promises.stat((0,P.$ic)(R,p))).isDirectory()&&c.push(p)}catch{}const d=[];for(const p of c)(await v.Promises.readdir((0,P.$ic)(R,p))).filter(b=>b==="telemetry.json").length===1&&d.push(p);for(const p of d){const I=(await S.promises.readFile((0,P.$ic)(R,p,"telemetry.json"))).toString();a(I,p)}}let f=(await S.promises.readFile((0,P.$ic)(L,"telemetry-core.json"))).toString();return a(f,"vscode-core"),f=(await S.promises.readFile((0,P.$ic)(L,"telemetry-extensions.json"))).toString(),a(f,"vscode-extensions"),JSON.stringify(w,null,4)}}),define(le[132],ue([0,1,12,84,18]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=k,e.$9gc=L,e.$0gc=R;async function k(w,a){let f=w.getItem(v.$cm);return(typeof f!="string"||S.$k&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,P.$Rn)(a.error.bind(a))),f}async function L(w,a){let f=w.getItem(v.$dm);return typeof f!="string"&&(f=await(0,P.$Sn)(a.error.bind(a))),f}async function R(w,a){let f=w.getItem(v.$em);return typeof f!="string"&&(f=await(0,P.$Tn)(a.error.bind(a))),f}}),define(le[23],ue([0,1,10]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0,e.$Il=(0,S.$Di)("IUriIdentityService")}),define(le[133],ue([0,1,23,98,9,16,80,4,2]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class a{static{this._clock=0}constructor(m){this.uri=m,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(m){this.g=m,this.c=new w.$Sc,this.f=2**16;const d=new Map,p=I=>{let b=d.get(I.scheme);return b===void 0&&(b=m.hasProvider(I)&&!this.g.hasCapability(I,v.FileSystemProviderCapabilities.PathCaseSensitive),d.set(I.scheme,b)),b};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(I=>{d.delete(I.scheme)})),this.extUri=new k.$6g(p),this.d=new L.$Rs((I,b)=>this.extUri.compare(I,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,k.$fh)(m));const d=this.d.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new a(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((p,I)=>p[1].time<I[1].time?1:p[1].time>I[1].time?-1:0);a._clock=0,this.d.clear();const d=this.f*.5;for(let p=0;p<d;p++)this.d.set(m[p][0],m[p][1].touch())}};e.$Ss=f,e.$Ss=f=ve([re(0,v.$$k)],f),(0,P.$Ps)(S.$Il,f,P.InstantiationType.Delayed)}),define(le[134],ue([0,1,4,2,9,49,25]),function(Q,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class R extends P.$Tc{constructor(a,f,c,m,d,p){super(),this.f=a,this.g=f,this.h=c,this.j=m,this.m=d,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$ke),this.onDidChangeFile=this.a.event,this.b=k.$Ji.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new L.$Ac(I=>this.m.extUri.getComparisonKey(this.t(I))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(I=>this.s(I)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,c,m,d){return this.g.read(a,f,c,m,d)}write(a,f,c,m,d){return this.g.write(a,f,c,m,d)}watch(a,f){this.b.set(a,a);const c=this.g.watch(this.t(a),f);return(0,P.$Rc)(()=>{this.b.delete(a),c.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,c){return this.g.rename(this.t(a),this.t(f),c)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,c){return this.g.readFileStream(this.t(a),f,c)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,c){return this.g.writeFile(this.t(a),f,c)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,c){if((0,v.$cl)(this.g))return this.g.copy(this.t(a),this.t(f),c);throw new Error("copy not supported")}cloneFile(a,f){if((0,v.$dl)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const c of a){if(c.resource.scheme!==this.f)continue;const m=this.u(c.resource);this.b.findSubstr(m)&&f.push({resource:m,type:c.type,cId:c.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$vhc=R}),define(le[135],ue([0,1,5,15,49,16,11,10,14]),function(Q,e,S,P,v,k,L,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Xi=e.$Wi=e.WorkbenchState=e.$Qi=e.$Pi=e.$Mi=void 0,e.$Ni=a,e.$Oi=f,e.$Ri=c,e.$Si=m,e.$Ti=d,e.$Ui=I,e.$Vi=b,e.$Yi=O,e.$4i=y,e.$5i=i,e.$7i=l,e.$8i=n,e.$9i=s,e.$Mi=(0,R.$Di)("contextService");function a(t){const r=t;return typeof r?.id=="string"&&L.URI.isUri(r.uri)}function f(t){return typeof t?.id=="string"&&!a(t)&&!m(t)}e.$Pi={id:"ext-dev"},e.$Qi={id:"empty-window"};function c(t,r){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,P.$mc)(t)}:r?e.$Pi:e.$Qi;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function m(t){const r=t;return typeof r?.id=="string"&&L.URI.isUri(r.configPath)}function d(t){const r=t;if(r?.uri)return{id:r.id,uri:L.URI.revive(r.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var p;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function I(t){const r=t;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function b(t){const r=t;return!!(r&&typeof r=="object"&&L.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class h{constructor(r,o,u,$,D){this.h=r,this.j=u,this.k=$,this.l=D,this.c=v.$Ji.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=v.$Ji.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Wi=h;class g{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,k.$eh)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Xi=g;function O(t){return new g({uri:t,index:0,name:(0,k.$ah)(t)},{uri:t.toString()})}e.$Zi="code-workspace",e.$1i=`.${e.$Zi}`,e.$2i=[{name:(0,S.localize)(10955,null),extensions:[e.$Zi]}],e.$3i="workspace.json";function y(t,r){return k.$8g.isEqualOrParent(t,r.untitledWorkspacesHome)}function i(t){let r;return L.URI.isUri(t)?r=t:r=t.configuration,r?.scheme===w.Schemas.tmp}e.$6i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(t){return t.id===e.$6i}function n(t,r){return!y(t,r)&&!i(t)}function s(t){return(typeof t=="string"?(0,P.$nc)(t):(0,k.$ch)(t))===e.$1i}}),define(le[24],ue([0,1,43,4,2,16,11,5,17,9,10,6,135,25,23,8,28,31,3]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Kl=e.ProfileResourceType=void 0,e.$Jl=y,e.$Ll=i,e.$Ml=l;var O;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(O||(e.ProfileResourceType=O={}));function y(t){const r=t;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&L.URI.isUri(r.location)&&L.URI.isUri(r.globalStorageHome)&&L.URI.isUri(r.settingsResource)&&L.URI.isUri(r.keybindingsResource)&&L.URI.isUri(r.tasksResource)&&L.URI.isUri(r.snippetsHome)&&L.URI.isUri(r.extensionsResource))}e.$Kl=(0,f.$Di)("IUserDataProfilesService");function i(t,r){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:L.URI.revive(t.location).with({scheme:r}),globalStorageHome:L.URI.revive(t.globalStorageHome).with({scheme:r}),settingsResource:L.URI.revive(t.settingsResource).with({scheme:r}),keybindingsResource:L.URI.revive(t.keybindingsResource).with({scheme:r}),tasksResource:L.URI.revive(t.tasksResource).with({scheme:r}),snippetsHome:L.URI.revive(t.snippetsHome).with({scheme:r}),extensionsResource:L.URI.revive(t.extensionsResource).with({scheme:r}),cacheHome:L.URI.revive(t.cacheHome).with({scheme:r}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function l(t,r,o,u,$,D){return{id:t,name:r,location:o,isDefault:!1,shortName:$?.shortName,icon:$?.icon,globalStorageHome:D&&$?.useDefaultFlags?.globalState?D.globalStorageHome:(0,k.$eh)(o,"globalStorage"),settingsResource:D&&$?.useDefaultFlags?.settings?D.settingsResource:(0,k.$eh)(o,"settings.json"),keybindingsResource:D&&$?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,k.$eh)(o,"keybindings.json"),tasksResource:D&&$?.useDefaultFlags?.tasks?D.tasksResource:(0,k.$eh)(o,"tasks.json"),snippetsHome:D&&$?.useDefaultFlags?.snippets?D.snippetsHome:(0,k.$eh)(o,"snippets"),extensionsResource:D&&$?.useDefaultFlags?.extensions?D.extensionsResource:(0,k.$eh)(o,"extensions.json"),cacheHome:(0,k.$eh)(u,t),useDefaultFlags:$?.useDefaultFlags,isTransient:$?.transient}}let n=class extends v.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,o,u,$){super(),this.t=r,this.u=o,this.w=u,this.y=$,this.f=!0,this.h=this.B(new P.$ke),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$ke),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$ke),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$ke),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new d.$zc,workspaces:new d.$zc,emptyWindows:new Map},this.profilesHome=(0,k.$eh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$eh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),o=[r];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,g.$dg)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(l((0,k.$bh)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},r))}}catch(D){this.y.error(D)}const u=new d.$zc,$=new Map;if(o.length)try{const D=this.Q();if(D.workspaces)for(const[T,A]of Object.entries(D.workspaces)){const N=L.URI.parse(T),M=o.find(G=>G.id===A);M&&u.set(N,M)}if(D.emptyWindows)for(const[T,A]of Object.entries(D.emptyWindows)){const N=o.find(M=>M.id===A);N&&$.set(T,N)}}catch(D){this.y.error(D)}this.z={profiles:o,workspaces:u,emptyWindows:$}}return this.z}D(){const r=l("__default__profile__",(0,R.localize)(11002,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const o="Temp",u=new RegExp(`${(0,h.$gf)(o)}\\s(\\d+)`);let $=0;for(const T of this.profiles){const A=u.exec(T.name),N=A?parseInt(A[1]):0;$=N>$?N:$}const D=`${o} ${$+1}`;return this.createProfile((0,S.$rj)((0,b.$Zg)()).toString(16),D,{transient:!0},r)}async createNamedProfile(r,o,u){return this.createProfile((0,S.$rj)((0,b.$Zg)()).toString(16),r,o,u)}async createProfile(r,o,u,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(r,o,u);return $&&await this.setProfileForWorkspace($,D),D}async F(r,o,u){if(!(0,g.$dg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let $=this.r.get(o);return $||($=(async()=>{try{if(this.profiles.find(N=>N.name===o||N.id===r))throw new Error(`Profile with ${o} name already exists`);const T=l(r,o,(0,k.$eh)(this.profilesHome,r),this.g,u,this.defaultProfile);await this.u.createFolder(T.location);const A=[];return this.j.fire({profile:T,join(N){A.push(N)}}),await I.Promises.settled(A),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,$)),$}async updateProfile(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find($=>$.id===r.id);if(!u)throw new Error(`Profile '${r.name}' does not exist`);return u=l(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find($=>$.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const u=[];this.m.fire({profile:o,join($){u.push($)}});try{await Promise.allSettled(u)}catch($){this.y.error($)}for(const $ of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get($)?.id&&this.C.emptyWindows.delete($);for(const $ of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get($)?.id&&this.C.workspaces.delete($);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch($){(0,a.$pl)($)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error($)}}async setProfileForWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find($=>$.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.L(r,u)}unsetWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.G(r),u=L.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return u||((0,m.$Ni)(r)?this.s.folders.get(r.uri):(0,m.$Si)(r)?this.s.workspaces.get(r.configPath):this.s.emptyWindows.get(r.id))}G(r){return(0,m.$Ni)(r)?r.uri:(0,m.$Si)(r)?r.configPath:r.id}H(r){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,r.location)))}I(r,o,u){const $=[...this.profiles,...r],D=[],T=this.s.profiles;this.s.profiles=[];for(let A of $){if(A.isDefault||o.some(M=>A.id===M.id))continue;A=u.find(M=>A.id===M.id)??A;const N=T.find(M=>A.id===M.id);if(A.isTransient)this.s.profiles.push(A);else{if(N){for(const[M,G]of this.s.emptyWindows.entries())if(A.id===G.id){this.L({id:M},A);break}for(const[M,G]of this.s.workspaces.entries())if(A.id===G.id){this.L({id:"",configPath:M},A);break}for(const[M,G]of this.s.folders.entries())if(A.id===G.id){this.L({id:"",uri:M},A);break}}D.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(D),this.z=void 0,this.J(r,o,u)}J(r,o,u){this.h.fire({added:r,removed:o,updated:u,all:this.profiles})}L(r,o,u){if(u=o?.isTransient?!0:u,u)(0,m.$Ni)(r)?(this.s.folders.delete(r.uri),o&&this.s.folders.set(r.uri,o)):(0,m.$Si)(r)?(this.s.workspaces.delete(r.configPath),o&&this.s.workspaces.set(r.configPath,o)):(this.s.emptyWindows.delete(r.id),o&&this.s.emptyWindows.set(r.id,o));else{this.L(r,void 0,!0);const $=this.G(r);L.URI.isUri($)?(this.C.workspaces.delete($),o&&this.C.workspaces.set($,o)):(this.C.emptyWindows.delete($),o&&this.C.emptyWindows.set($,o)),this.M()}}M(){const r={};for(const[u,$]of this.C.workspaces.entries())r[u.toString()]=$.id;const o={};for(const[u,$]of this.C.emptyWindows.entries())o[u.toString()]=$.id;this.R({workspaces:r,emptyWindows:o}),this.z=void 0}N(r){const o={},u=this.D();if(r.workspaces)for(const[D,T]of Object.entries(r.workspaces)){const A=L.URI.parse(T);o[D]=this.w.extUri.isEqual(A,u.location)?u.id:this.w.extUri.basename(A)}const $={};if(r.emptyWindows)for(const[D,T]of Object.entries(r.emptyWindows)){const A=L.URI.parse(T);$[D]=this.w.extUri.isEqual(A,u.location)?u.id:this.w.extUri.basename(A)}return{workspaces:o,emptyWindows:$}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$Nl=n,e.$Nl=n=ve([re(0,w.$Ki),re(1,a.$$k),re(2,p.$Il),re(3,c.$$j)],n);class s extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$Ol=s}),define(le[53],ue([0,1,19,8,21,7,4,2,25,12,3,11,5,20,26,22,44,6,33,18,23,24]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g,O,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Dq=void 0,e.$Eq=n,m=ye(m);let l=class extends R.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(o,u,$,D,T,A){super(),this.z=o,this.C=u,this.D=$,this.F=D,this.G=T,this.H=A,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$ke),this.s=this.B(new L.$ke),this.t=this.B(new L.$ke),this.u=this.B(new L.$ke),this.w=this.B(new L.$ke),this.y=[],this.B((0,R.$Rc)(()=>{this.j.forEach(({task:N})=>N.cancel()),this.m.forEach(N=>N.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(o){const u=await this.getTargetPlatform();return o.allTargetPlatforms.some($=>(0,d.$hp)($,o.allTargetPlatforms,u))}async installFromGallery(o,u={}){try{const D=(await this.installGalleryExtensions([{extension:o,options:u}])).find(({identifier:T})=>(0,p.$Kp)(T,o.identifier));if(D?.local)return D?.local;throw D?.error?D.error:new d.$lp(`Unknown error while installing extension ${o.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch($){throw n($)}}async installGalleryExtensions(o){if(!this.z.isEnabled())throw new d.$lp(m.localize(11428,null),d.ExtensionManagementErrorCode.NotAllowed);const u=[],$=[];return await Promise.allSettled(o.map(async({extension:D,options:T})=>{try{const A=await this.N(D,!!T?.installGivenVersion,!!T?.installPreReleaseVersion,T.productVersion??{version:this.G.version,date:this.G.date});$.push({...A,options:T})}catch(A){u.push({identifier:D.identifier,operation:d.InstallOperation.Install,source:D,error:A,profileLocation:T.profileLocation??this.W()})}})),$.length&&u.push(...await this.I($)),u}async uninstall(o,u){return this.F.trace("ExtensionManagementService#uninstall",o.identifier.id),this.uninstallExtensions([{extension:o,options:u}])}async toggleAppliationScope(o,u){if((0,I.$sn)(o.manifest)||o.isBuiltin)return o;if(o.isApplicationScoped){let $=await this.updateMetadata(o,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(u,this.H.defaultProfile.extensionsResource)||($=await this.Z(o,this.H.defaultProfile.extensionsResource,u));for(const D of this.H.profiles){const T=(await this.getInstalled(I.ExtensionType.User,D.extensionsResource)).find(A=>(0,p.$Kp)(A.identifier,o.identifier));T?this.w.fire({local:T,profileLocation:D.extensionsResource}):this.u.fire({identifier:o.identifier,profileLocation:D.extensionsResource})}return $}else{const $=this.D.extUri.isEqual(u,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(o,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(o,u,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:$.identifier,operation:d.InstallOperation.Install,local:$,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),$}}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.g||o-this.h>1e3*60*5)&&(this.g=this.U(),this.h=o),this.g}registerParticipant(o){this.y.push(o)}async resetPinnedStateForAllUserExtensions(o){try{await this.L(this.H.profiles.map(async u=>{const $=await this.getInstalled(I.ExtensionType.User,u.extensionsResource);await this.L($.map(async D=>{D.pinned!==o&&await this.updateMetadata(D,{pinned:o},u.extensionsResource)}))}))}catch(u){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$9)(u)),u}}async I(o){const u=new Map,$=new Map,D=[],T=(N,M)=>`${p.$Lp.create(N).toString()}-${M.toString()}`,A=(N,M,G,Z)=>{const ee=this.X(N,M,G),oe=`${(0,p.$Pp)(N.publisher,N.name)}-${G.profileLocation.toString()}`;$.set(oe,{task:ee,root:Z}),this.n.fire({identifier:ee.identifier,source:M,profileLocation:G.profileLocation}),this.F.info("Installing extension:",ee.identifier.id,G),c.URI.isUri(M)||this.j.set(T(M,G.profileLocation),{task:ee,waitingTasks:[]})};try{for(const{manifest:N,extension:M,options:G}of o){const Z=G.isApplicationScoped||G.isBuiltin||(0,I.$sn)(N),ee={...G,installOnlyNewlyAddedFromExtensionPack:G.installOnlyNewlyAddedFromExtensionPack??!c.URI.isUri(M),isApplicationScoped:Z,profileLocation:Z?this.H.defaultProfile.extensionsResource:G.profileLocation??this.W(),productVersion:G.productVersion??{version:this.G.version,date:this.G.date}},oe=c.URI.isUri(M)?void 0:this.j.get(T(M,ee.profileLocation));oe?(this.F.info("Extension is already requested to install",oe.task.identifier.id,ee.profileLocation.toString()),D.push(oe.task.waitUntilTaskIsFinished())):A(N,M,ee,void 0)}return await Promise.all([...$.values()].map(async({task:N})=>{if(N.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const M=await this.M(N.identifier,N.manifest,!!N.options.installOnlyNewlyAddedFromExtensionPack,!!N.options.installPreReleaseVersion,N.options.profileLocation,N.options.productVersion),G=await this.getInstalled(void 0,N.options.profileLocation,N.options.productVersion),Z={...N.options,context:{...N.options.context,[d.$bp]:!0}};for(const{gallery:ee,manifest:oe}of(0,S.$Lb)(M,({gallery:ce})=>ce.identifier.id)){if($.has(`${ee.identifier.id.toLowerCase()}-${Z.profileLocation.toString()}`))continue;const ce=this.j.get(T(ee,Z.profileLocation));if(ce){if(this.J(N,ce.task)){const fe=ce.task.identifier;this.F.info("Waiting for already requested installing extension",fe.id,N.identifier.id,Z.profileLocation.toString()),ce.waitingTasks.push(N),D.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,x=>x.some(Y=>(0,p.$Kp)(Y.identifier,fe)))).then(x=>{if(this.F.info("Finished waiting for already requested installing extension",fe.id,N.identifier.id,Z.profileLocation.toString()),!x.find(B=>(0,p.$Kp)(B.identifier,fe))?.local)throw new Error(`Extension ${fe.id} is not installed`)}))}}else G.some(({identifier:fe})=>(0,p.$Kp)(fe,ee.identifier))||A(oe,ee,Z,N)}}catch(M){if(c.URI.isUri(N.source))(0,S.$Kb)(N.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",N.identifier.id,M.message),(0,S.$Kb)(N.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",N.identifier.id,M.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),M}})),await this.L([...$.entries()].map(async([N,{task:M}])=>{const G=new Date().getTime();let Z;try{Z=await M.run(),await this.L(this.y.map(ee=>ee.postInstall(Z,M.source,M.options,v.CancellationToken.None)),d.ExtensionManagementErrorCode.PostInstall)}catch(ee){const oe=n(ee);throw c.URI.isUri(M.source)||s(this.C,M.operation===d.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Sp)(M.source),error:oe,source:M.options.context?.[d.$ap]}),u.set(N,{error:oe,identifier:M.identifier,operation:M.operation,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,applicationScoped:M.options.isApplicationScoped}),this.F.error("Error while installing the extension",M.identifier.id,(0,k.$9)(oe),M.options.profileLocation.toString()),oe}if(!c.URI.isUri(M.source)){const ee=M.operation===d.InstallOperation.Update,oe=ee?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(s(this.C,ee?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Sp)(M.source),verificationStatus:M.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:oe,source:M.options.context?.[d.$ap]}),a.$p&&M.operation!==d.InstallOperation.Update)try{await this.z.reportStatistic(Z.manifest.publisher,Z.manifest.name,Z.manifest.version,d.StatisticType.Install)}catch{}}u.set(N,{local:Z,identifier:M.identifier,operation:M.operation,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,applicationScoped:Z.isApplicationScoped})})),D.length&&await this.L(D),[...u.values()]}catch(N){const M=(ee,oe,ce)=>{const fe=[];ee.manifest.extensionDependencies?.length&&fe.push(...ee.manifest.extensionDependencies),ee.manifest.extensionPack?.length&&fe.push(...ee.manifest.extensionPack);for(const x of fe){if(ce.includes(x.toLowerCase()))continue;ce.push(x.toLowerCase());const Y=u.get(`${x.toLowerCase()}-${oe.toString()}`);Y?.local&&(ce=M(Y.local,oe,ce))}return ce},G=ee=>({identifier:ee.identifier,operation:d.InstallOperation.Install,source:ee.source,context:ee.options.context,profileLocation:ee.options.profileLocation,error:N}),Z=[];for(const[ee,{task:oe,root:ce}]of $){const fe=u.get(ee);fe?fe.local&&ce&&!u.get(`${ce.identifier.id.toLowerCase()}-${oe.options.profileLocation.toString()}`)?.local&&(Z.push(this.Y(fe.local,{versionOnly:!0,profileLocation:oe.options.profileLocation})),u.set(ee,G(oe))):(oe.cancel(),u.set(ee,G(oe)))}for(const[ee,{task:oe}]of $){const ce=u.get(ee);if(!ce?.local||oe.options.donotIncludePackAndDependencies)continue;M(ce.local,oe.options.profileLocation,[ce.local.identifier.id.toLowerCase()]).slice(1).some(x=>$.has(`${x.toLowerCase()}-${oe.options.profileLocation.toString()}`)&&!u.get(`${x.toLowerCase()}-${oe.options.profileLocation.toString()}`)?.local)&&(Z.push(this.Y(ce.local,{versionOnly:!0,profileLocation:oe.options.profileLocation})),u.set(ee,G(oe)))}throw Z.length&&await Promise.allSettled(Z.map(async ee=>{try{await ee.run(),this.F.info("Rollback: Uninstalled extension",ee.extension.identifier.id)}catch(oe){this.F.warn("Rollback: Error while uninstalling extension",ee.extension.identifier.id,(0,k.$9)(oe))}})),N}finally{for(const{task:N}of $.values())N.source&&!c.URI.isUri(N.source)&&this.j.delete(T(N.source,N.options.profileLocation));if(u.size){const N=[...u.values()];for(const M of N)M.local&&this.F.info("Extension installed successfully:",M.identifier.id,M.profileLocation.toString());this.s.fire(N)}}}J(o,u){for(const[,{task:$,waitingTasks:D}]of this.j.entries())if($===o&&(D.includes(u)||D.some(T=>this.J(T,u)))||$===u&&D[0]&&!this.J(o,D[0]))return!1;return!0}async L(o,u){const $=[],D=[],T=await Promise.allSettled(o);for(const N of T)N.status==="fulfilled"?$.push(N.value):D.push(n(N.reason,u));if(!D.length)return $;if(D.length===1)throw D[0];let A=new d.$lp("",d.ExtensionManagementErrorCode.Unknown);for(const N of D)A=new d.$lp(A.message?`${A.message}, ${N.message}`:N.message,N.code!==d.ExtensionManagementErrorCode.Unknown&&N.code!==d.ExtensionManagementErrorCode.Internal?N.code:A.code);throw A}async M(o,u,$,D,T,A){if(!this.z.isEnabled())return[];const N=await this.getInstalled(void 0,T,A),M=[],G=[],Z=async(ee,oe)=>{M.push(ee);const ce=oe.extensionDependencies||[],fe=[...ce];if(oe.extensionPack){const x=$?N.find(Y=>(0,p.$Kp)(Y.identifier,ee)):void 0;for(const Y of oe.extensionPack)x&&x.manifest.extensionPack&&x.manifest.extensionPack.some(B=>(0,p.$Kp)({id:B},{id:Y}))||fe.every(B=>!(0,p.$Kp)({id:B},{id:Y}))&&fe.push(Y)}if(fe.length){const x=fe.filter(Y=>M.every(B=>!(0,p.$Kp)(B,{id:Y})));if(x.length){const Y=await this.z.getExtensions(x.map(B=>({id:B,preRelease:D})),v.CancellationToken.None);for(const B of Y){if(M.find(X=>(0,p.$Kp)(X,B.identifier)))continue;const z=ce.some(X=>(0,p.$Kp)({id:X},B.identifier));let K;try{K=await this.N(B,!1,D,A)}catch(X){if(z)throw X;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,k.$9)(X));continue}G.push({gallery:K.extension,manifest:K.manifest}),await Z(K.extension.identifier,K.manifest)}}}};return await Z(o,u),G}async N(o,u,$,D){let T;const A=await this.getExtensionsControlManifest();if(A.malicious.some(G=>(0,p.$Kp)(o.identifier,G)))throw new d.$lp(m.localize(11429,null,o.identifier.id),d.ExtensionManagementErrorCode.Malicious);const N=A.deprecated[o.identifier.id.toLowerCase()];if(N?.extension?.autoMigrate){if(this.F.info(`The '${o.identifier.id}' extension is deprecated, fetching the compatible '${N.extension.id}' extension instead.`),T=(await this.z.getExtensions([{id:N.extension.id,preRelease:N.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:D},v.CancellationToken.None))[0],!T)throw new d.$lp(m.localize(11430,null,o.identifier.id,N.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(o)){const G=await this.getTargetPlatform();throw new d.$lp(m.localize(11431,null,o.identifier.id,this.G.nameLong,(0,d.$dp)(G)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(T=await this.O(o,u,$,D),!T){const G=[];throw(0,b.$5p)(o.properties.enabledApiProposals??[],G)?!$&&o.properties.isPreReleaseVersion&&(await this.z.getExtensions([o.identifier],v.CancellationToken.None))[0]?new d.$lp(m.localize(11433,null,o.displayName??o.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$lp(m.localize(11434,null,o.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible):new d.$lp(m.localize(11432,null,o.displayName??o.identifier.id,G[0]),d.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",T.identifier.id);const M=await this.z.getManifest(T,v.CancellationToken.None);if(M===null)throw new d.$lp(`Missing manifest for extension ${T.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(M.version!==T.version)throw new d.$lp(`Cannot install '${T.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:T,manifest:M}}async O(o,u,$,D){const T=await this.getTargetPlatform();let A=null;return!u&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==$&&(A=(await this.z.getExtensions([{...o.identifier,preRelease:$}],{targetPlatform:T,compatible:!0,productVersion:D},v.CancellationToken.None))[0]||null),!A&&await this.z.isExtensionCompatible(o,$,T,D)&&(A=o),A||(u?A=(await this.z.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:T,compatible:!0,productVersion:D},v.CancellationToken.None))[0]||null:A=await this.z.getCompatibleExtension(o,$,T,D)),A}async uninstallExtensions(o){const u=(G,Z)=>`${G.identifier.id.toLowerCase()}${Z.versionOnly?`-${G.manifest.version}`:""}@${Z.profileLocation.toString()}`,$=(G,Z)=>{const ee=this.Y(G,Z);return this.m.set(u(ee.extension,Z),ee),this.F.info("Uninstalling extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,Z.profileLocation.toString()),this.t.fire({identifier:G.identifier,profileLocation:Z.profileLocation,applicationScoped:G.isApplicationScoped}),ee},D=(G,Z,ee)=>{ee?this.F.error("Failed to uninstall extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,Z.profileLocation.toString(),ee.message):this.F.info("Successfully uninstalled extension from the profile",`${G.identifier.id}@${G.manifest.version}`,Z.profileLocation.toString()),s(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$Rp)(G),error:ee}),this.u.fire({identifier:G.identifier,error:ee?.code,profileLocation:Z.profileLocation,applicationScoped:G.isApplicationScoped})},T=[],A=[],N=[],M=new w.$zc;for(const{extension:G,options:Z}of o){const ee={...Z,profileLocation:G.isApplicationScoped?this.H.defaultProfile.extensionsResource:Z?.profileLocation??this.W()},oe=this.m.get(u(G,ee));oe?(this.F.info("Extensions is already requested to uninstall",G.identifier.id),N.push(oe.waitUntilTaskIsFinished())):T.push($(G,ee))}try{for(const G of T.slice(0)){let Z=M.get(G.options.profileLocation);if(Z||M.set(G.options.profileLocation,Z=await this.getInstalled(I.ExtensionType.User,G.options.profileLocation)),G.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${G.extension.identifier.id}@${G.extension.manifest.version}`);else{const ee=this.R(G.extension,Z);for(const oe of ee)this.m.has(u(oe,G.options))?this.F.info("Extensions is already requested to uninstall",oe.identifier.id):T.push($(oe,G.options))}G.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${G.extension.identifier.id}@${G.extension.manifest.version}`):this.P(T.map(ee=>ee.extension),Z,G.extension)}await this.L(T.map(async G=>{try{if(await G.run(),await this.L(this.y.map(Z=>Z.postUninstall(G.extension,G.options,v.CancellationToken.None))),G.extension.identifier.uuid)try{await this.z.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,d.StatisticType.Uninstall)}catch{}}catch(Z){const ee=n(Z);throw D(G.extension,G.options,ee),ee}finally{A.push(G)}})),N.length&&await this.L(N);for(const G of T)D(G.extension,G.options)}catch(G){const Z=n(G);for(const ee of T){try{ee.cancel()}catch{}A.includes(ee)||D(ee.extension,ee.options,Z)}throw Z}finally{for(const G of T)this.m.delete(u(G.extension,G.options))||this.F.warn("Uninstallation task is not found in the cache",G.extension.identifier.id)}}P(o,u,$){for(const D of o){const T=this.S(D,u);if(T.length){const A=T.filter(N=>!o.some(M=>(0,p.$Kp)(M.identifier,N.identifier)));if(A.length)throw new Error(this.Q(D,A,$))}}}Q(o,u,$){return $===o?u.length===1?m.localize(11435,null,$.manifest.displayName||$.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?m.localize(11436,null,$.manifest.displayName||$.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):m.localize(11437,null,$.manifest.displayName||$.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?m.localize(11438,null,$.manifest.displayName||$.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?m.localize(11439,null,$.manifest.displayName||$.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):m.localize(11440,null,$.manifest.displayName||$.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}R(o,u,$=[]){if($.indexOf(o)!==-1)return[];$.push(o);const D=o.manifest.extensionPack?o.manifest.extensionPack:[];if(D.length){const T=u.filter(N=>!N.isBuiltin&&D.some(M=>(0,p.$Kp)({id:M},N.identifier))),A=[];for(const N of T)A.push(...this.R(N,u,$));return[...T,...A]}return[]}S(o,u){return u.filter($=>$.manifest.extensionDependencies&&$.manifest.extensionDependencies.some(D=>(0,p.$Kp)({id:D},o.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(o){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$9)(o)),{malicious:[],deprecated:{},search:[]}}}};e.$Dq=l,e.$Dq=l=ve([re(0,d.$jp),re(1,O.$0l),re(2,y.$Il),re(3,h.$$j),re(4,g.$rk),re(5,i.$Kl)],l);function n(r,o){if(r instanceof d.$lp)return r;let u;return r instanceof d.$kp?u=new d.$lp(r.message,r.code===d.ExtensionGalleryErrorCode.DownloadFailedWriting?d.ExtensionManagementErrorCode.DownloadFailedWriting:d.ExtensionManagementErrorCode.Gallery):u=new d.$lp(r.message,(0,k.$3)(r)?d.ExtensionManagementErrorCode.Cancelled:o??d.ExtensionManagementErrorCode.Internal),u.stack=r.stack,u}function s(r,o,{extensionData:u,verificationStatus:$,duration:D,error:T,source:A,durationSinceUpdate:N}){let M,G;(0,f.$lg)($)&&($===!0?$="Verified":($===!1||(M=d.ExtensionManagementErrorCode.Signature,G=$),$="Unverified")),T&&(M=T.code,T.code===d.ExtensionManagementErrorCode.Signature&&(G=T.message)),r.publicLog(o,{...u,verificationStatus:$,success:!T,duration:D,errorcode:M,errorcodeDetail:G,durationSinceUpdate:N,source:A})}class t{constructor(){this.d=new P.$Ch}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,P.$qh)(o=>this.h(o))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,P.$qh)(o=>new Promise((u,$)=>{const D=o.onCancellationRequested(()=>{D.dispose(),$(new k.$4)})})),this.d.open()),this.g.cancel()}}e.$Fq=t}),define(le[42],ue([0,1,8,13,2,4,25,11,20,26,9,10,6,24,23,3,7,18]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class O extends Error{constructor(s,t){super(s),this.code=t}}e.$Gq=O,e.$Hq=(0,c.$Di)("IExtensionsProfileScannerService");let y=class extends v.$Tc{constructor(s,t,r,o,u,$){super(),this.j=s,this.m=t,this.n=r,this.r=o,this.s=u,this.t=$,this.b=this.B(new k.$ke),this.onAddExtensions=this.b.event,this.c=this.B(new k.$ke),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$ke),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$ke),this.onDidRemoveExtensions=this.g.event,this.h=new L.$zc}scanProfileExtensions(s,t){return this.u(s,void 0,t)}async addExtensionsToProfile(s,t,r){const o=[],u=[];try{return await this.u(t,$=>{const D=[];if(r)D.push(...$);else for(const T of $)s.some(([A])=>(0,a.$Kp)(A.identifier,T.identifier)&&A.manifest.version!==T.version)?o.push(T):D.push(T);for(const[T,A]of s){const N=D.findIndex(G=>(0,a.$Kp)(G.identifier,T.identifier)&&G.version===T.manifest.version),M={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:A};N===-1?(u.push(M),D.push(M)):D.splice(N,1,M)}return u.length&&this.b.fire({extensions:u,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),D}),u.length&&this.c.fire({extensions:u,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),u}catch($){throw u.length&&this.c.fire({extensions:u,error:$,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:$,profileLocation:t}),$}}async updateMetadata(s,t){const r=[];return await this.u(t,o=>{const u=[];for(const $ of o){const D=s.find(([T])=>(0,a.$Kp)(T.identifier,$.identifier)&&T.manifest.version===$.version);D&&($.metadata={...$.metadata,...D[1]},r.push($)),u.push($)}return u}),r}async removeExtensionFromProfile(s,t){const r=[];try{await this.u(t,o=>{const u=[];for(const $ of o)(0,a.$Kp)($.identifier,s.identifier)?r.push($):u.push($);return r.length&&this.f.fire({extensions:r,profileLocation:t}),u}),r.length&&this.g.fire({extensions:r,profileLocation:t})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:t}),o}}async u(s,t,r){return this.F(s).queue(async()=>{let o=[],u;try{const $=await this.m.readFile(s);u=JSON.parse($.value.toString().trim()||"[]")}catch($){if((0,f.$pl)($)!==f.FileOperationResult.FILE_NOT_FOUND)throw $;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&r?.bailOutWhenFileNotFound)throw new O((0,b.$9)($),g.ERROR_PROFILE_NOT_FOUND)}if(u){Array.isArray(u)||this.w(s);let $=!1;for(const D of u){i(D)||this.w(s);let T;if((0,I.$dg)(D.relativeLocation)&&D.relativeLocation)T=this.z(D.relativeLocation);else if((0,I.$dg)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{T=R.URI.revive(D.location);const A=this.y(T);A&&($=!0,D.relativeLocation=A)}(0,I.$kg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&($=!0,D.metadata.hasPreReleaseVersion=!0),o.push({identifier:D.identifier,location:T,version:D.version,metadata:D.metadata})}$&&await this.m.writeFile(s,P.$Me.fromString(JSON.stringify(u)))}if(t){o=t(o);const $=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(s,P.$Me.fromString(JSON.stringify($)))}return o})}w(s){const t=new O(`Invalid extensions content in ${s.toString()}`,g.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let r;try{r=(await this.m.readFile(s)).value.toString()}catch(u){if((0,f.$pl)(u)===f.FileOperationResult.FILE_NOT_FOUND)return;throw u}this.t.info("Migrating extensions from old default profile location",s.toString());let o;try{const u=JSON.parse(r);Array.isArray(u)&&u.every($=>i($))?o=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,P.$Me.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,f.$pl)(u)===f.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(s)}catch(u){(0,f.$pl)(u)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}try{await this.m.del(t)}catch(u){(0,f.$pl)(u)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}return o})()),this.C}F(s){let t=this.h.get(s);return t||(t=new S.$Kh,this.h.set(s,t)),t}};e.$Iq=y,e.$Iq=y=ve([re(1,f.$$k),re(2,d.$Kl),re(3,p.$Il),re(4,h.$0l),re(5,m.$$j)],y);function i(n){return(0,I.$fg)(n)&&(0,w.$ip)(n.identifier)&&(l(n.location)||(0,I.$dg)(n.location)&&n.location)&&((0,I.$kg)(n.relativeLocation)||(0,I.$dg)(n.relativeLocation))&&n.version&&(0,I.$dg)(n.version)}function l(n){return n?(0,I.$dg)(n.path)&&(0,I.$dg)(n.scheme):!1}});var ze=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(le[54],ue([0,1,19,8,27,13,7,34,90,2,14,15,12,16,45,57,3,11,5,17,26,22,44,9,10,6,33,4,48,42,24,23,96]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g,O,y,i,l,n,s,t,r,o,u,$,D,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Nq=e.$Mq=e.$Lq=e.Translations=void 0,e.$Oq=oe,v=ye(v),c=ye(c),m=ye(m),p=ye(p),I=ze(I);var N;(function(fe){function x(Y,B){if(Y===B)return!0;const z=Object.keys(Y),K=new Set;for(const X of Object.keys(B))K.add(X);if(z.length!==K.size)return!1;for(const X of z){if(Y[X]!==B[X])return!1;K.delete(X)}return K.size===0}fe.equals=x})(N||(e.Translations=N={})),e.$Lq=(0,s.$Di)("IExtensionsScannerService");let M=class extends a.$Tc{constructor(x,Y,B,z,K,X,te,ne,F,V,q,E){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=Y,this.r=B,this.s=z,this.t=K,this.u=X,this.w=te,this.y=ne,this.z=F,this.C=V,this.D=q,this.F=E,this.g=this.B(new o.$ke),this.onDidChangeCache=this.g.event,this.h=(0,d.$eh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ee,this.s,this.h)),this.m=this.B(this.F.createInstance(ee,this.s,this.h)),this.n=this.B(this.F.createInstance(Z,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Vp)(this.w,this.y)),this.G}async scanAllExtensions(x,Y,B){const[z,K]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(Y)]),X=B?await this.scanExtensionsUnderDevelopment(x,[...z,...K]):[];return this.L(z,K,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const Y=[];Y.push(this.M(!!x.useCache,x.language)),Y.push(this.N(x.language,!!x.checkControlFile));const[B,z]=await Promise.all(Y);return this.J([...B,...z],i.ExtensionType.System,x,!1)}async scanUserExtensions(x){const Y=x.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const B=this.D.extUri.isEqual(x.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(Y,!!x.profileLocation,i.ExtensionType.User,!x.includeUninstalled,x.language,!0,B,x.productVersion??this.R()),K=x.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let X;try{X=await K.scanExtensions(z)}catch(te){if(te instanceof $.$Gq&&te.code===$.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),X=await K.scanExtensions(z);else throw te}return X=await this.J(X,i.ExtensionType.User,x,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(x,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===f.Schemas.file).map(async z=>{const K=await this.P(z,!1,i.ExtensionType.User,!0,x.language,!1,void 0,x.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(K)).map(te=>(te.type=Y.find(ne=>(0,y.$Kp)(ne.identifier,te.identifier))?.type??te.type,this.n.validate(te,K)))}))).flat();return this.J(B,"development",x,!0)}return[]}async scanExistingExtension(x,Y,B){const z=await this.P(x,!1,Y,!0,B.language,!0,void 0,B.productVersion??this.R()),K=await this.n.scanExtension(z);return!K||!B.includeInvalid&&!K.isValid?null:K}async scanOneOrMultipleExtensions(x,Y,B){const z=await this.P(x,!1,Y,!0,B.language,!0,void 0,B.productVersion??this.R()),K=await this.n.scanOneOrMultipleExtensions(z);return this.J(K,Y,B,!0)}async scanMultipleExtensions(x,Y,B){const z=[];return await Promise.all(x.map(async K=>{const X=await this.scanOneOrMultipleExtensions(K,Y,B);z.push(...X)})),this.J(z,Y,B,!0)}async scanMetadata(x){const Y=(0,d.$eh)(x,"package.json"),B=(await this.w.readFile(Y)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(x,Y){const B=(0,d.$eh)(x,"package.json"),z=(await this.w.readFile(B)).value.toString(),K=JSON.parse(z);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,K.__metadata={...K.__metadata,...Y},await this.w.writeFile((0,d.$eh)(x,"package.json"),k.$Me.fromString(JSON.stringify(K,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof $.$Gq&&x.code===$.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw x}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.u.addExtensionsToProfile(x.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Me.fromString(JSON.stringify([])))}catch(Y){(0,n.$pl)(Y)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$9)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.y.error(x)}finally{this.H=void 0}})()),this.H}async J(x,Y,B,z){return B.includeAllVersions||(x=this.L(Y===i.ExtensionType.System?x:void 0,Y===i.ExtensionType.User?x:void 0,Y==="development"?x:void 0,await this.getTargetPlatform(),z)),B.includeInvalid||(x=x.filter(K=>K.isValid)),x.sort((K,X)=>{const te=c.$mc(K.location.fsPath),ne=c.$mc(X.location.fsPath);return te<ne?-1:te>ne?1:0})}L(x,Y,B,z,K){const X=(ne,F,V)=>{if(ne.isValid&&!F.isValid)return!1;if(ne.isValid===F.isValid){if(K&&p.gt(ne.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if(p.eq(ne.manifest.version,F.manifest.version)){if(ne.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===z)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return V?this.y.warn(`Overwriting user extension ${ne.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${ne.location.path} with ${F.location.path}.`),!0},te=new i.$rn;return x?.forEach(ne=>{const F=te.get(ne.identifier.id);(!F||X(F,ne,!1))&&te.set(ne.identifier.id,ne)}),Y?.forEach(ne=>{const F=te.get(ne.identifier.id);if(!F&&x&&ne.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!F||X(F,ne,!1))&&te.set(ne.identifier.id,ne)}),B?.forEach(ne=>{const F=te.get(ne.identifier.id);(!F||X(F,ne,!0))&&te.set(ne.identifier.id,ne),te.set(ne.identifier.id,ne)}),[...te.values()]}async M(x,Y){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Y,!0,void 0,this.R()),K=await(x&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",K.length),K}async N(x,Y){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const z=Y?await this.O():{},K=[],X=h.URI.file(c.$gc(c.$ic(f.$Xg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of B){const F=z[ne.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":K.push((0,d.$eh)(X,ne.name));break;default:K.push(h.URI.file(F));break}}const te=await Promise.all(K.map(async ne=>this.n.scanExtension(await this.P(ne,!1,i.ExtensionType.System,!0,x,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,S.$Gb)(te)}async O(){try{const x=await this.w.readFile(this.r);return JSON.parse(x.value.toString())}catch{return{}}}async P(x,Y,B,z,K,X,te,ne){const F=await this.f(K??m.$x),V=await this.Q(x),q=Y&&!this.D.extUri.isEqual(x,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=q?await this.Q(q):void 0;return new G(x,V,q,E,Y,te,B,z,X,ne.version,ne.date,this.C.commit,!this.z.isBuilt,K,F)}async Q(x){try{const Y=await this.w.stat(x);if(typeof Y.mtime=="number")return Y.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Mq=M,e.$Mq=M=ve([re(4,D.$Kl),re(5,$.$Hq),re(6,n.$$k),re(7,t.$$j),re(8,O.$Ki),re(9,r.$rk),re(10,T.$Il),re(11,s.$Ci)],M);class G{constructor(x,Y,B,z,K,X,te,ne,F,V,q,E,j,U,C){this.location=x,this.mtime=Y,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=z,this.profile=K,this.profileScanOptions=X,this.type=te,this.excludeObsolete=ne,this.validate=F,this.productVersion=V,this.productDate=q,this.productCommit=E,this.devMode=j,this.language=U,this.translations=C}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,Y){return(0,d.$0g)(x.location,Y.location)&&x.mtime===Y.mtime&&(0,d.$0g)(x.applicationExtensionslocation,Y.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&x.profile===Y.profile&&v.$go(x.profileScanOptions,Y.profileScanOptions)&&x.type===Y.type&&x.excludeObsolete===Y.excludeObsolete&&x.validate===Y.validate&&x.productVersion===Y.productVersion&&x.productDate===Y.productDate&&x.productCommit===Y.productCommit&&x.devMode===Y.devMode&&x.language===Y.language&&N.equals(x.translations,Y.translations)}}e.$Nq=G;let Z=class extends a.$Tc{constructor(x,Y,B,z,K,X,te){super(),this.g=x,this.h=Y,this.j=B,this.m=z,this.n=X,this.r=te,this.f=K.extensionsEnabledWithApiProposalVersion?.map(ne=>ne.toLowerCase())??[]}async scanExtensions(x){const Y=x.profile?await this.t(x):await this.s(x);let B={};if(x.excludeObsolete&&x.type===i.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(z)}catch{}return(0,b.$qg)(B)?Y:Y.filter(z=>!B[y.$Lp.create(z).toString()])}async s(x){const Y=await this.m.resolve(x.location);if(!Y.children?.length)return[];const B=await Promise.all(Y.children.map(async z=>{if(!z.isDirectory||x.type===i.ExtensionType.User&&(0,d.$bh)(z.resource).indexOf(".")===0)return null;const K=new G(z.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(K)}));return(0,S.$Gb)(B).sort((z,K)=>z.location.path<K.location.path?-1:1)}async t(x){let Y=await this.u(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.j.extUri.isEqual(x.location,x.applicationExtensionslocation)){Y=Y.filter(z=>!z.metadata?.isApplicationScoped);const B=await this.u(x.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,x);Y.push(...B)}return Y}async u(x,Y,B){const z=await this.h.scanProfileExtensions(x,B.profileScanOptions);if(!z.length)return[];const K=await Promise.all(z.map(async X=>{if(Y(X)){const te=new G(X.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(te,X.metadata)}return null}));return(0,S.$Gb)(K)}async scanOneOrMultipleExtensions(x){try{if(await this.m.exists((0,d.$eh)(x.location,"package.json"))){const Y=await this.scanExtension(x);return Y?[Y]:[]}else return await this.scanExtensions(x)}catch(Y){return this.r.error(`Error scanning extensions at ${x.location.path}:`,(0,L.$9)(Y)),[]}}async scanExtension(x,Y){try{let B=await this.w(x.location);if(B){B.publisher||(B.publisher=i.$ln),Y=Y??B.__metadata,delete B.__metadata;const z=(0,y.$Pp)(B.publisher,B.name),K=Y?.id?{id:z,uuid:Y.id}:{id:z},X=Y?.isSystem?i.ExtensionType.System:x.type,te=X===i.ExtensionType.System||!!Y?.isBuiltin;B=await this.y(x.location,B,G.createNlsConfiguration(x));let ne={type:X,identifier:K,manifest:B,location:x.location,isBuiltin:te,targetPlatform:Y?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Y?.publisherDisplayName,metadata:Y,isValid:!0,validations:[]};return x.validate&&(ne=this.validate(ne,x)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(z.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,i.$xn)([...B.enabledApiProposals])),ne}}catch(B){x.type!==i.ExtensionType.System&&this.r.error(B)}return null}validate(x,Y){let B=!0;const z=this.n.isBuilt&&this.f.includes(x.identifier.id.toLowerCase()),K=(0,l.$2p)(Y.productVersion,Y.productDate,Y.location,x.manifest,x.isBuiltin,z);for(const[X,te]of K)X===I.default.Error&&(B=!1,this.r.error(this.F(Y.location,te)));return x.isValid=B,x.validations=K,x}async w(x){const Y=(0,d.$eh)(x,"package.json");let B;try{B=(await this.m.readFile(Y)).value.toString()}catch(K){return(0,n.$pl)(K)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(x,(0,g.localize)(11386,null,Y.path,K.message))),null}let z;try{z=JSON.parse(B)}catch{const X=[];(0,R.$Wn)(B,X);for(const te of X)this.r.error(this.F(x,(0,g.localize)(11387,null,Y.path,te.offset,te.length,(0,w.$Jq)(te.error))));return null}return(0,R.$5n)(z)!=="object"?(this.r.error(this.F(x,(0,g.localize)(11388,null,Y.path))),null):z}async y(x,Y,B){const z=await this.z(x,Y,B);if(z)try{const K=[],X=await this.C(z.default,K);if(K.length>0)return K.forEach(ne=>{this.r.error(this.F(x,(0,g.localize)(11389,null,z.default?.path,(0,w.$Jq)(ne.error))))}),Y;if((0,R.$5n)(z)!=="object")return this.r.error(this.F(x,(0,g.localize)(11390,null,z.default?.path))),Y;const te=z.values||Object.create(null);return(0,A.$Kq)(this.r,Y,te,X)}catch{}return Y}async z(x,Y,B){const z=(0,d.$eh)(x,"package.nls.json"),K=(F,V)=>{V.forEach(q=>{this.r.error(this.F(x,(0,g.localize)(11391,null,F?.path,(0,w.$Jq)(q.error))))})},X=F=>{this.r.error(this.F(x,(0,g.localize)(11392,null,F?.path)))},te=`${Y.publisher}.${Y.name}`,ne=B.translations[te];if(ne)try{const F=h.URI.file(ne),V=(await this.m.readFile(F)).value.toString(),q=[],E=(0,R.$Wn)(V,q);return q.length>0?(K(F,q),{values:void 0,default:z}):(0,R.$5n)(E)!=="object"?(X(F),{values:void 0,default:z}):{values:E.contents?E.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let V;try{V=await this.D(x,B)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const q=(await this.m.readFile(V.localized)).value.toString(),E=[],j=(0,R.$Wn)(q,E);return E.length>0?(K(V.localized,E),{values:void 0,default:V.original}):(0,R.$5n)(j)!=="object"?(X(V.localized),{values:void 0,default:V.original}):{values:j,default:V.original}}catch{return{values:void 0,default:V.original}}}}async C(x,Y){if(x)try{const B=(await this.m.readFile(x)).value.toString();return(0,R.$Wn)(B,Y)}catch{}}D(x,Y){return new Promise((B,z)=>{const K=X=>{const te=(0,d.$eh)(x,`package.nls.${X}.json`);this.m.exists(te).then(ne=>{ne&&B({localized:te,original:(0,d.$eh)(x,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?B({localized:(0,d.$eh)(x,"package.nls.json"),original:null}):(X=X.substring(0,F),K(X))})};if(Y.devMode||Y.pseudo||!Y.language)return B({localized:(0,d.$eh)(x,"package.nls.json"),original:null});K(Y.language)})}F(x,Y){return`[${x.path}]: ${Y}`}};Z=ve([re(1,$.$Hq),re(2,T.$Il),re(3,n.$$k),re(4,r.$rk),re(5,O.$Ki),re(6,t.$$j)],Z);let ee=class extends Z{constructor(x,Y,B,z,K,X,te,ne,F){super(Y,z,K,X,te,ne,F),this.J=x,this.L=B,this.H=this.B(new P.$Bh(3e3)),this.I=this.B(new o.$ke),this.onDidChangeCache=this.I.event}async scanExtensions(x){const Y=this.P(x),B=await this.M(Y);if(this.G=x,B&&B.input&&G.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",x.type===i.ExtensionType.System?"system":"user",x.location.toString()),this.H.trigger(()=>this.O()),B.result.map(K=>(K.location=h.URI.revive(K.location),K));const z=await super.scanExtensions(x);return await this.N(Y,{input:x,result:z}),z}async M(x){try{const Y=await this.m.readFile(x),B=JSON.parse(Y.value.toString());return{result:B.result,input:(0,u.$ai)(B.input)}}catch(Y){this.r.debug("Error while reading the extension cache file:",x.path,(0,L.$9)(Y))}return null}async N(x,Y){try{await this.m.writeFile(x,k.$Me.fromString(JSON.stringify(Y)))}catch(B){this.r.debug("Error while writing the extension cache file:",x.path,(0,L.$9)(B))}}async O(){if(!this.G)return;const x=this.P(this.G),Y=await this.M(x);if(!Y)return;const B=Y.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!v.$go(z,B))try{this.r.info("Invalidating Cache",B,z),await this.m.del(x),this.I.fire()}catch(K){this.r.error(K)}}P(x){const Y=this.Q(x);return this.j.extUri.joinPath(Y.cacheHome,x.type===i.ExtensionType.System?i.$kn:i.$jn)}Q(x){return x.type===i.ExtensionType.System?this.L.defaultProfile:x.profile?this.j.extUri.isEqual(x.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Y=>this.j.extUri.isEqual(x.location,Y.extensionsResource))??this.J:this.L.defaultProfile}};ee=ve([re(2,D.$Kl),re(3,$.$Hq),re(4,T.$Il),re(5,n.$$k),re(6,r.$rk),re(7,O.$Ki),re(8,t.$$j)],ee);function oe(fe,x){const Y=(0,y.$Np)(fe.manifest.publisher,fe.manifest.name);return{id:Y,identifier:new i.$pn(Y),isBuiltin:fe.type===i.ExtensionType.System,isUserBuiltin:fe.type===i.ExtensionType.User&&fe.isBuiltin,isUnderDevelopment:x,extensionLocation:fe.location,uuid:fe.identifier.uuid,targetPlatform:fe.targetPlatform,publisherDisplayName:fe.publisherDisplayName,...fe.manifest}}class ce extends M{constructor(x,Y,B,z,K,X,te,ne,F,V,q,E){super(x,Y,(0,d.$eh)(B,".vscode-oss-dev","extensions","control.json"),z,K,X,te,ne,F,V,q,E),this.S=(async()=>{if(m.$A)try{const j=await this.w.readFile(h.URI.file(m.$A));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}f(x){return this.S}}e.$Pq=ce}),define(le[136],ue([0,1,60,8,38,4,2,14,15,29,6,24]),function(Q,e,S,P,v,k,L,R,w,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;let m=class extends L.$Tc{constructor(p,I){super(),this.b=p,this.f=I,this.a=new P.$Jh(5)}async postUninstall(p){const I=this.g(p,"uninstall");I&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(I.script,"uninstall",I.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(b)}}));try{await a.Promises.rm(this.m(p))}catch(b){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(b)}}g(p,I){const b=`vscode:${I}`;if(p.location.scheme===R.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[b]=="string"){const h=p.manifest.scripts[b].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${b} should be a node script`),null):{script:(0,w.$ic)(p.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(p,I,b,h,g){return new Promise((O,y)=>{const i=this.j(p,I,b,g);let l;const n=s=>{l&&(clearTimeout(l),l=null),s?y(s):O(void 0)};i.on("error",s=>{n((0,v.$oj)(s)||"Unknown")}),i.on("exit",(s,t)=>{n(s?`post-${I} process exited with code ${s}`:void 0)}),h&&(l=setTimeout(()=>{l=null,i.kill(),y("timed out")},5e3))})}j(p,I,b,h){const g={silent:!0,execArgv:void 0},O=(0,S.fork)(p,[`--type=extension-post-${I}`,...b],g);O.stdout.setEncoding("utf8"),O.stderr.setEncoding("utf8");const y=k.Event.fromNodeEventEmitter(O.stdout,"data"),i=k.Event.fromNodeEventEmitter(O.stderr,"data");this.B(y(s=>this.f.info(h.identifier.id,h.manifest.version,`post-${I}`,s))),this.B(i(s=>this.f.error(h.identifier.id,h.manifest.version,`post-${I}`,s)));const l=k.Event.any(k.Event.map(y,s=>({data:`%c${s}`,format:[""]}),this.q),k.Event.map(i,s=>({data:`%c${s}`,format:["color: red"]}),this.q));return k.Event.debounce(l,(s,t)=>s?{data:s.data+t.data,format:[...s.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(s=>{console.group(h.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),O}m(p){return(0,w.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$Tq=m,e.$Tq=m=ve([re(0,c.$Kl),re(1,f.$$j)],m)}),define(le[72],ue([0,1,50,5,53,20]),function(Q,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=L,e.$Rq=R;function L(w){let a=k.ExtensionManagementErrorCode.Extract;return w instanceof S.$zq&&(w.type==="CorruptZip"?a=k.ExtensionManagementErrorCode.CorruptZip:w.type==="Incomplete"&&(a=k.ExtensionManagementErrorCode.IncompleteZip)),(0,v.$Eq)(w,a)}async function R(w){let a;try{a=await(0,S.$Cq)(w,"extension/package.json")}catch(f){throw L(f)}try{return JSON.parse(a.toString("utf8"))}catch{throw new k.$lp((0,P.localize)(11376,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(le[137],ue([0,1,8,7,2,14,16,45,3,28,29,50,30,17,53,20,26,72,71,9,6,18]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g,O,y,i){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0,R=ye(R);let n=class extends v.$Tc{static{l=this}static{this.c=".sigzip"}constructor(t,r,o,u,$,D,T){super(),this.h=r,this.j=o,this.m=u,this.n=$,this.r=D,this.t=T,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,r,o,u){await this.g;const $=await this.w(t,r);let D=!1;if(o&&this.u(t)){let T;try{T=await this.y(t)}catch(A){try{await this.delete($)}catch(N){this.t.error(N)}throw A}try{D=await this.n.verify(t,$.fsPath,T.fsPath,u)}catch(A){if(D=A.code,D===g.ExtensionSignatureVerificationCode.PackageIsInvalidZip||D===g.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete($)}catch(N){this.t.error(N)}throw new I.$lp(c.$yq,I.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(A){this.t.error(A)}}}return{location:$,verificationStatus:D}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,w.$jg)(r)?r:!0}async w(t,r){try{const o=(0,L.$eh)(this.extensionsDownloadDir,this.G(t)),u=await this.C(t,"vsix",async()=>{await this.z(t,o,$=>this.j.download(t,$,r));try{await this.D(o.fsPath,"extension/package.json")}catch($){try{await this.h.del(o)}catch(D){this.t.warn(`Error while deleting: ${o.path}`,(0,P.$9)(D))}throw $}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:u}),o}catch(o){throw(0,p.$Eq)(o,I.ExtensionManagementErrorCode.Download)}}async y(t){try{const r=(0,L.$eh)(this.extensionsDownloadDir,`.${(0,a.$Zg)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,r);try{await this.D(r.fsPath,".signature.p7s")}catch(u){try{await this.h.del(r)}catch($){this.t.warn(`Error while deleting: ${r.path}`,(0,P.$9)($))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),r}catch(r){throw(0,p.$Eq)(r,I.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,r,o){if(await this.h.exists(r))return;if(r.scheme!==k.Schemas.file){await o(r);return}const u=(0,L.$eh)(this.extensionsDownloadDir,`.${(0,a.$Zg)()}`);try{await o(u)}catch($){try{await this.h.del(u)}catch{}throw $}try{await f.Promises.rename(u.fsPath,r.fsPath,2*60*1e3)}catch($){try{await this.h.del(u)}catch{}let D=!1;try{D=await this.h.exists(r)}catch{}if(D)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.t.info(`Rename failed because of ${(0,P.$9)($)}. Deleted the file from downloaded location`,u.path),$}}async C(t,r,o,u){let $=1;for(;;)try{return await o(),$}catch(D){if($++>u)throw D;this.t.warn(`Failed downloading ${r}. ${(0,P.$9)(D)}. Retry again...`,t.identifier.id)}}async D(t,r){try{await(0,c.$Cq)(t,r)}catch(o){throw(0,h.$Qq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],o=[],u=[];for(const T of t.children)if(T.name.endsWith(l.c))u.push(T.resource);else{const A=b.$Lp.parse(T.name);A&&o.push([A,T])}const $=(0,b.$Qp)(o,([T])=>T),D=[];for(const T of $)T.sort((A,N)=>R.rcompare(A[0].version,N[0].version)),r.push(...T.slice(1).map(A=>A[1].resource)),D.push(T[0][1]);D.sort((T,A)=>T.mtime-A.mtime),r.push(...D.slice(0,Math.max(0,D.length-this.f)).map(T=>T.resource)),r.push(...u),await S.Promises.settled(r.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(t){this.t.error(t)}}G(t){return this.f?b.$Lp.create(t).toString().toLowerCase():(0,a.$Zg)()}};e.$Sq=n,e.$Sq=n=l=ve([re(0,d.$Li),re(1,O.$$k),re(2,I.$jp),re(3,m.$0i),re(4,g.$rq),re(5,i.$0l),re(6,y.$$j)],n)}),define(le[138],ue([0,1,32,8,13,21,38,7,4,43,2,25,14,15,16,45,3,11,28,29,50,5,61,17,53,20,26,42,54,137,136,72,118,125,22,44,9,10,6,33,18,23,24]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g,O,y,i,l,n,s,t,r,o,u,$,D,T,A,N,M,G,Z,ee,oe,ce,fe,x,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=void 0,S=ye(S),d=ye(d),I=ye(I),O=ye(O),i=ye(i),e.$Wq=(0,ee.$Ei)(t.$mp);const B=".vsctmp";let z=class extends s.$Dq{constructor(F,V,q,E,j,U,C,H,J,se,ae,de){super(F,V,ae,q,se,de),this.db=j,this.eb=U,this.fb=C,this.gb=H,this.hb=J,this.cb=new Map,this.sb=new c.$Ac;const me=this.B(H.createInstance(D.$Tq));this.$=this.B(H.createInstance(K,we=>me.postUninstall(we))),this.ab=this.B(new A.$Uq(de,J,ae,this,this.F)),this.bb=this.B(H.createInstance($.$Sq));const ge=this.B(new N.$Vq(this,this.db,de,U,ae,J,q));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.rb(we))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,r.$Vp)(this.hb,this.F)),this.ib}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const V=await this.qb(F),q=await(0,y.zip)((0,p.$eh)(this.bb.extensionsDownloadDir,(0,g.$Zg)()).fsPath,V);return h.URI.file(q)}async getManifest(F){const{location:V,cleanup:q}=await this.kb(F),E=d.$jc(V.fsPath);try{return await(0,T.$Rq)(E)}finally{await q()}}getInstalled(F,V=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(F??null,V,q)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.$.scanUserExtensionAtLocation(F)}async install(F,V={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:q,cleanup:E}=await this.kb(F);try{const j=await(0,T.$Rq)(d.$jc(q.fsPath)),U=(0,r.$Pp)(j.publisher,j.name);if(j.engines&&j.engines.vscode&&!(0,G.$4p)(j.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(11377,null,U,this.G.version));const H=(await this.I([{manifest:j,extension:q,options:V}])).find(({identifier:J})=>(0,r.$Kp)(J,{id:U}));if(H?.local)return H.local;throw H?.error?H.error:(0,s.$Eq)(new Error(`Unknown error while installing extension ${U}`))}finally{await E()}}async installFromLocation(F,V){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const q=await this.$.scanUserExtensionAtLocation(F);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.vb([[q,{source:"resource"}]],V),this.F.info("Successfully installed extension",q.identifier.id,V.toString()),q}async installExtensionsFromProfile(F,V,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,V.toString(),q.toString());const E=(await this.getInstalled(M.ExtensionType.User,V)).filter(j=>F.some(U=>(0,r.$Kp)(U,j.identifier)));if(E.length){const j=await Promise.all(E.map(U=>this.$.scanMetadata(U,V)));await this.vb(E.map((U,C)=>[U,j[C]]),q),this.F.info("Successfully installed extensions",E.map(U=>U.identifier.id),q.toString())}return E}async updateMetadata(F,V,q){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),V.isPreReleaseVersion&&(V.preRelease=!0,V.hasPreReleaseVersion=!0),V.isMachineScoped===!1&&(V.isMachineScoped=void 0),V.isBuiltin===!1&&(V.isBuiltin=void 0),V.pinned===!1&&(V.pinned=void 0),F=await this.$.updateMetadata(F,V,q),this.ab.invalidate(q),this.w.fire({local:F,profileLocation:q}),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(i.localize(11378,null));const V=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:V,compatible:!0},k.CancellationToken.None);if(!q)throw new Error(i.localize(11379,null));await this.$.setUninstalled(F);try{await this.$.removeUninstalledExtension(F)}catch(E){throw new Error(i.localize(11380,null,(0,L.$oj)(E)))}return this.installFromGallery(q)}Z(F,V,q,E){return this.$.copyExtension(F,V,q,E)}copyExtensions(F,V){return this.$.copyExtensions(F,V,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.$.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(F){this.F.error(F)}}async download(F,V,q){const{location:E}=await this.bb.download(F,V,!q);return E}async kb(F){if(F.scheme===m.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const V=(0,p.$eh)(this.bb.extensionsDownloadDir,(0,g.$Zg)());return await this.fb.download(F,V),this.F.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.hb.del(V)}catch(E){this.F.error(E)}}}}W(){return this.H.defaultProfile.extensionsResource}X(F,V,q){const E=V instanceof h.URI?new r.$Lp({id:(0,r.$Pp)(F.publisher,F.name)},F.version):r.$Lp.create(V);return this.gb.createInstance(X,E,F,V,q,(j,U)=>{if(V instanceof h.URI)return this.pb(E,V,q,U);let C=this.cb.get(E.toString());return C||(this.cb.set(E.toString(),C=this.ob(E,V,j,q,U)),C.finally(()=>this.cb.delete(E.toString()))),C},this.$)}Y(F,V){return new te(F,V,this.eb)}async ob(F,V,q,E,j){const{verificationStatus:U,location:C}=await this.bb.download(V,q,!E.donotVerifySignature,E.context?.[t.$cp]);try{if(j.isCancellationRequested)throw new R.$4;const H=await(0,T.$Rq)(C.fsPath);if(!new r.$Lp(V.identifier,V.version).equals(new r.$Lp({id:(0,r.$Pp)(H.publisher,H.name)},H.version)))throw new t.$lp(i.localize(11381,null,V.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(F,C.fsPath,{id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName,targetPlatform:V.properties.targetPlatform,isApplicationScoped:E.isApplicationScoped,isMachineScoped:E.isMachineScoped,isBuiltin:E.isBuiltin,isPreReleaseVersion:V.properties.isPreReleaseVersion,hasPreReleaseVersion:V.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:E.installGivenVersion?!0:!!E.pinned,preRelease:(0,b.$jg)(E.preRelease)?E.preRelease:E.installPreReleaseVersion||V.properties.isPreReleaseVersion,source:"gallery"},!1,j),verificationStatus:U}}catch(H){try{await this.bb.delete(C)}catch(J){this.F.warn("Error while deleting the downloaded file",C.toString(),(0,R.$9)(J))}throw(0,s.$Eq)(H)}}async pb(F,V,q,E){return{local:await this.$.extractUserExtension(F,d.$jc(V.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},q.keepExisting??!0,E)}}async qb(F){const V=async E=>{let j=await O.Promises.readdir(E);j=j.map(H=>d.$ic(E,H));const U=await Promise.all(j.map(H=>S.promises.stat(H)));let C=Promise.resolve([]);return U.forEach((H,J)=>{const se=j[J];H.isFile()&&(C=C.then(ae=>[...ae,se])),H.isDirectory()&&(C=C.then(ae=>V(se).then(de=>[...ae,...de])))}),C};return(await V(F.location.fsPath)).map(E=>({path:`extension/${d.$kc(F.location.fsPath,E)}`,localPath:E}))}async rb({added:F,removed:V}){if(V){const q=F&&this.D.extUri.isEqual(V.profileLocation,F.profileLocation)?V.extensions.filter(E=>F.extensions.every(j=>!(0,r.$Kp)(j,E))):V.extensions;for(const E of q)this.F.info("Extensions removed from another source",E.id,V.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:V.profileLocation})}if(F){const E=(await this.getInstalled(M.ExtensionType.User,F.profileLocation)).filter(j=>F.extensions.some(U=>(0,r.$Kp)(U,j.identifier)));this.s.fire(E.map(j=>(this.F.info("Extensions added from another source",j.identifier.id,F.profileLocation.toString()),{identifier:j.identifier,local:j,profileLocation:F.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(V=>this.sb.add(V)));const F=await this.hb.resolve(this.db.userExtensionsLocation);for(const V of F.children??[])V.isDirectory&&this.sb.add(V.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(V=>this.ub(V)))}async ub(F){if(!F.affects(this.db.userExtensionsLocation,Z.FileChangeType.ADDED))return;const V=[];for(const q of F.rawAdded){if(this.sb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.db.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.hb.stat(q)).isDirectory)continue;const E=await this.$.scanUserExtensionAtLocation(q);E&&E.installedTimestamp===void 0&&(this.sb.add(q),V.push(E))}V.length&&(await this.vb(V.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",V.map(q=>q.identifier.id)))}async vb(F,V){const q=F.map(E=>E[0]);await this.wb(q),await this.eb.addExtensionsToProfile(F,V),this.s.fire(q.map(E=>({local:E,identifier:E.identifier,operation:t.InstallOperation.None,profileLocation:V})))}async wb(F){const V=await this.$.getUninstalledExtensions();for(const q of F){const E=r.$Lp.create(q);V[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.$.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$Xq=z,e.$Xq=z=ve([re(0,t.$jp),re(1,fe.$0l),re(2,oe.$$j),re(3,n.$Li),re(4,u.$Lq),re(5,o.$Hq),re(6,l.$Zo),re(7,ee.$Ci),re(8,Z.$$k),re(9,ce.$rk),re(10,x.$Il),re(11,Y.$Kl)],z);let K=class extends f.$Tc{constructor(F,V,q,E,j,U,C){super(),this.n=F,this.s=V,this.t=q,this.u=E,this.w=j,this.y=U,this.z=C,this.h=this.B(new w.$ke),this.onExtract=this.h.event,this.j=new c.$zc,this.m=new c.$zc,this.c=(0,p.$eh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Kh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(F,V,q){try{const E={includeInvalid:!0,profileLocation:V,productVersion:q};let j=[];if(F===null||F===M.ExtensionType.System){let U=this.j.get(V);U||(U=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},E,!1).finally(()=>this.j.delete(V)),this.j.set(V,U)),j.push(...await U)}else if(F===M.ExtensionType.User){let U=this.m.get(V);U||(U=this.t.scanUserExtensions(E).finally(()=>this.m.delete(V)),this.m.set(V,U)),j.push(...await U)}return j=F!==null?j.filter(U=>U.type===F):j,await Promise.all(j.map(U=>this.H(U)))}catch(E){throw(0,s.$Eq)(E,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(F){try{const V=await this.t.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(V.map(q=>this.H(q)))}catch(V){throw(0,s.$Eq)(V,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(F){try{const V=await this.t.scanExistingExtension(F,M.ExtensionType.User,{includeInvalid:!0});if(V)return await this.H(V)}catch(V){this.z.error(V)}return null}async extractUserExtension(F,V,q,E,j){const U=F.toString(),C=h.URI.file(d.$ic(this.t.userExtensionsLocation.fsPath,`.${(0,g.$Zg)()}`)),H=h.URI.file(d.$ic(this.t.userExtensionsLocation.fsPath,U));if(await this.s.exists(H)){if(!E)try{return await this.scanLocalExtension(H,M.ExtensionType.User)}catch(J){this.z.warn(`Error while scanning the existing extension at ${H.path}. Deleting the existing extension and extracting it.`,(0,R.$9)(J))}try{await this.D(F.id,H,"removeExisting")}catch{throw new t.$lp(i.localize(11382,null,H.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}}try{if(j.isCancellationRequested)throw new R.$4;try{this.z.trace(`Started extracting the extension from ${V} to ${H.fsPath}`),await(0,y.$Bq)(V,C.fsPath,{sourcePath:"extension",overwrite:!0},j),this.z.info(`Extracted extension to ${H}:`,F.id)}catch(J){throw(0,T.$Qq)(J)}try{await this.t.updateMetadata(C,q)}catch(J){throw this.y.publicLog2("extension:extract",{extensionId:F.id,code:`${(0,Z.$pl)(J)}`}),(0,s.$Eq)(J,t.ExtensionManagementErrorCode.UpdateMetadata)}if(j.isCancellationRequested)throw new R.$4;try{this.z.trace(`Started renaming the extension from ${C.fsPath} to ${H.fsPath}`),await this.G(C.fsPath,H.fsPath),this.z.info("Renamed to",H.fsPath)}catch(J){if(J.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);try{await this.s.del(C,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,R.$9)(J)}. Deleted from extracted location`,C),J}this.h.fire(H)}catch(J){try{await this.s.del(C,{recursive:!0})}catch{}throw J}return this.scanLocalExtension(H,M.ExtensionType.User)}async scanMetadata(F,V){return V?(await this.C(F,V))?.metadata:this.t.scanMetadata(F.location)}async C(F,V){return(await this.u.scanProfileExtensions(V)).find(E=>(0,r.$Kp)(E.identifier,F.identifier))}async updateMetadata(F,V,q){try{q?await this.u.updateMetadata([[F,V]],q):await this.t.updateMetadata(F.location,V)}catch(E){throw this.y.publicLog2("extension:extract",{extensionId:F.identifier.id,code:`${(0,Z.$pl)(E)}`,isProfile:!!q}),(0,s.$Eq)(E,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(F.location,F.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(F){throw(0,s.$Eq)(F,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...F){const V=F.map(q=>r.$Lp.create(q));await this.F(q=>V.forEach(E=>{q[E.toString()]=!0,this.z.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(F){try{await this.F(V=>delete V[F.toString()])}catch(V){throw(0,s.$Eq)(V,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(F,V){if(this.w.extUri.isEqualOrParent(F.location,this.t.userExtensionsLocation))return this.D(F.identifier.id,F.location,V)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.F(V=>delete V[r.$Lp.create(F).toString()])}async copyExtension(F,V,q,E){const j=await this.C(F,V),U=await this.C(F,q);if(E={...j?.metadata,...E},U)if(this.w.extUri.isEqual(U.location,F.location))await this.u.updateMetadata([[F,{...U.metadata,...E}]],q);else{const C=await this.scanLocalExtension(U.location,F.type,q);await this.u.removeExtensionFromProfile(C,q),await this.u.addExtensionsToProfile([[F,{...U.metadata,...E}]],q)}else await this.u.addExtensionsToProfile([[F,E]],q);return this.scanLocalExtension(F.location,F.type,q)}async copyExtensions(F,V,q){const E=await this.scanExtensions(M.ExtensionType.User,F,q),j=await Promise.all(E.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,F)]));await this.u.addExtensionsToProfile(j,V)}async D(F,V,q){this.z.trace(`Deleting ${q} extension from disk`,F,V.fsPath);const E=this.w.extUri.joinPath(this.w.extUri.dirname(V),`${this.w.extUri.basename(V)}.${(0,a.$rj)((0,g.$Zg)()).toString(16)}${B}`);await this.G(V.fsPath,E.fsPath),await this.s.del(E,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,F,V.fsPath)}F(F){return this.g.queue(async()=>{let V;try{V=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,Z.$pl)(E)!==Z.FileOperationResult.FILE_NOT_FOUND)throw E}let q={};if(V)try{q=JSON.parse(V)}catch{}return F&&(F(q),Object.keys(q).length?await this.s.writeFile(this.c,v.$Me.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(F,V){try{await O.Promises.rename(F,V,2*60*1e3)}catch(q){throw(0,s.$Eq)(q,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,V,q){try{if(q){const j=(await this.t.scanUserExtensions({profileLocation:q})).find(U=>this.w.extUri.isEqual(U.location,F));if(j)return await this.H(j)}else{const E=await this.t.scanExistingExtension(F,V,{includeInvalid:!0});if(E)return await this.H(E)}throw new t.$lp(i.localize(11383,null,F.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(E){throw(0,s.$Eq)(E,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(F){const V=await this.s.resolve(F.location);let q,E;return V.children&&(q=V.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,E=V.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:q,changelogUrl:E,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async I(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(F));const V=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const j of V)F[r.$Lp.create(j).toString()]||q.add(j.identifier.id.toLowerCase());try{const j=(0,r.$Qp)(V,U=>U.identifier);await P.Promises.settled(j.map(async U=>{const C=U.sort((H,J)=>I.rcompare(H.manifest.version,J.manifest.version))[0];q.has(C.identifier.id.toLowerCase())||await this.n(await this.H(C))}))}catch(j){this.z.error(j)}const E=V.filter(j=>j.metadata&&F[r.$Lp.create(j).toString()]);await Promise.allSettled(E.map(j=>this.removeUninstalledExtension(j)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.s.resolve(this.t.userExtensionsLocation)}catch(V){(0,Z.$pl)(V)!==Z.FileOperationResult.FILE_NOT_FOUND&&this.z.error(V);return}if(F?.children)try{await Promise.allSettled(F.children.map(async V=>{if(!(!V.isDirectory||!V.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",V.resource.toString());try{await this.s.del(V.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",V.resource.toString())}catch(q){(0,Z.$pl)(q)!==Z.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};e.$Yq=K,e.$Yq=K=ve([re(1,Z.$$k),re(2,u.$Lq),re(3,o.$Hq),re(4,x.$Il),re(5,fe.$0l),re(6,oe.$$j)],K);let X=class extends s.$Fq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(F,V,q,E,j,U,C,H,J,se,ae,de){super(),this.l=F,this.manifest=V,this.source=q,this.options=E,this.m=j,this.n=U,this.o=C,this.p=H,this.q=J,this.s=se,this.t=ae,this.u=de,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(F){const q=(await this.n.scanExtensions(M.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(C=>(0,r.$Kp)(C.identifier,this.identifier));q&&(this.j=t.InstallOperation.Update);const E={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===M.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof h.URI?"vsix":"gallery"};let j;if(this.source instanceof h.URI){if(q&&this.l.equals(new r.$Lp(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(i.localize(11384,null,this.manifest.displayName||this.manifest.name))}const C=await this.w(this.l);if(C)try{await this.n.removeExtension(C,"existing")}catch{throw new Error(i.localize(11385,null,this.manifest.displayName||this.manifest.name))}}else{if(E.id=this.source.identifier.uuid,E.publisherId=this.source.publisherId,E.publisherDisplayName=this.source.publisherDisplayName,E.targetPlatform=this.source.properties.targetPlatform,E.updated=!!q,E.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,E.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,E.preRelease=(0,b.$jg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==M.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,E,this.options.profileLocation);j=await this.w(this.l)}if(F.isCancellationRequested)throw(0,s.$Eq)(new R.$4);if(!j){const C=await this.m(this.operation,F);j=C.local,this.k=C.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(C){throw(0,s.$Eq)(C,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(F.isCancellationRequested)throw(0,s.$Eq)(new R.$4);try{await this.t.addExtensionsToProfile([[j,E]],this.options.profileLocation,!j.isValid)}catch(C){throw(0,s.$Eq)(C,t.ExtensionManagementErrorCode.AddToProfile)}const U=await this.n.scanLocalExtension(j.location,M.ExtensionType.User,this.options.profileLocation);if(!U)throw new t.$lp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof h.URI&&this.x(j,F),U}async w(F){return(await this.n.getUninstalledExtensions())[F.toString()]?(this.u.trace("Removing the extension from uninstalled list:",F.id),await this.n.setInstalled(F),this.u.info("Removed the extension from uninstalled list:",F.id),(await this.n.scanAllUserExtensions(!0)).find(E=>r.$Lp.create(E).equals(F))):void 0}async x(F,V){try{let[q]=await this.p.getExtensions([{id:F.identifier.id,version:F.manifest.version}],V);if(q||([q]=await this.p.getExtensions([{id:F.identifier.id}],V)),q){const E={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(F,E,this.options.profileLocation)}}catch{}}};X=ve([re(6,x.$Il),re(7,t.$jp),re(8,Y.$Kl),re(9,u.$Lq),re(10,o.$Hq),re(11,oe.$$j)],X);class te extends s.$Fq{constructor(F,V,q){super(),this.extension=F,this.options=V,this.j=q}async h(F){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(le[139],ue([0,1,6,24,23,18,42,9,17,11]),function(Q,e,S,P,v,k,L,R,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=void 0;let f=class extends L.$Iq{constructor(m,d,p,I,b,h){super(a.URI.file(m.extensionsPath),d,p,I,b,h)}};e.$DR=f,e.$DR=f=ve([re(0,w.$Li),re(1,R.$$k),re(2,P.$Kl),re(3,v.$Il),re(4,k.$0l),re(5,S.$$j)],f)}),define(le[140],ue([0,1,11,17,42,54,9,10,6,33,23,24]),function(Q,e,S,P,v,k,L,R,w,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;let m=class extends k.$Pq{constructor(p,I,b,h,g,O,y,i){super(S.URI.file(g.builtinExtensionsPath),S.URI.file(g.extensionsPath),g.userHome,p.defaultProfile,p,I,b,h,g,O,y,i)}};e.$5gc=m,e.$5gc=m=ve([re(0,c.$Kl),re(1,v.$Hq),re(2,L.$$k),re(3,w.$$j),re(4,P.$Li),re(5,a.$rk),re(6,f.$Il),re(7,R.$Ci)],m)}),define(le[73],ue([0,1,8,4,2,108,3,88,10,24]),function(Q,e,S,P,v,k,L,R,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$iq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gq=e.$fq=e.$eq=void 0,e.$hq=d,e.$jq=I,e.$lq=h,e.$eq="__$__isNewStorageMarker",e.$fq="__$__targetStorageMarker",e.$gq=(0,w.$Di)("storageService");var f;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var c;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(c||(e.StorageScope=c={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function d(g){const O=g.get(e.$fq);if(O)try{return JSON.parse(O)}catch{}return Object.create(null)}class p extends v.$Tc{static{this.a=60*1e3}constructor(O={flushInterval:p.a}){super(),this.m=O,this.b=this.B(new P.$ne),this.c=this.B(new P.$ne),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$ke),this.onWillSaveState=this.f.event,this.h=this.B(new S.$Ph(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(O,y,i){return P.Event.filter(this.b.event,l=>l.scope===O&&(y===void 0||l.key===y),i)}n(){this.j.value=(0,S.$Th)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(O,y){const{key:i,external:l}=y;if(i===e.$fq){switch(O){case c.APPLICATION:this.H=void 0;break;case c.PROFILE:this.F=void 0;break;case c.WORKSPACE:this.C=void 0;break}this.c.fire({scope:O})}else this.b.fire({scope:O,key:i,target:this.J(O)[i],external:l})}w(O){this.f.fire({reason:O})}get(O,y,i){return this.P(y)?.get(O,i)}getBoolean(O,y,i){return this.P(y)?.getBoolean(O,i)}getNumber(O,y,i){return this.P(y)?.getNumber(O,i)}getObject(O,y,i){return this.P(y)?.getObject(O,i)}storeAll(O,y){this.y(()=>{for(const i of O)this.store(i.key,i.value,i.scope,i.target,y)})}store(O,y,i,l,n=!1){if((0,L.$mg)(y)){this.remove(O,i,n);return}this.y(()=>{this.z(O,i,l),this.P(i)?.set(O,y,n)})}remove(O,y,i=!1){this.y(()=>{this.z(O,y,void 0),this.P(y)?.delete(O,i)})}y(O){this.b.pause(),this.c.pause();try{O()}finally{this.b.resume(),this.c.resume()}}keys(O,y){const i=[],l=this.J(O);for(const n of Object.keys(l))l[n]===y&&i.push(n);return i}z(O,y,i,l=!1){const n=this.J(y);typeof i=="number"?n[O]!==i&&(n[O]=i,this.P(y)?.set(e.$fq,JSON.stringify(n),l)):typeof n[O]=="number"&&(delete n[O],this.P(y)?.set(e.$fq,JSON.stringify(n),l))}get D(){return this.C||(this.C=this.L(c.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(c.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(c.APPLICATION)),this.H}J(O){switch(O){case c.APPLICATION:return this.I;case c.PROFILE:return this.G;default:return this.D}}L(O){const y=this.P(O);return y?d(y):Object.create(null)}isNew(O){return this.getBoolean(e.$eq,O)===!0}async flush(O=f.NONE){this.f.fire({reason:O});const y=this.P(c.APPLICATION),i=this.P(c.PROFILE),l=this.P(c.WORKSPACE);switch(O){case f.NONE:await S.Promises.settled([y?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await S.Promises.settled([y?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const O=this.P(c.APPLICATION)?.items??new Map,y=this.P(c.PROFILE)?.items??new Map,i=this.P(c.WORKSPACE)?.items??new Map;return h(O,y,i,this.Q(c.APPLICATION)??"",this.Q(c.PROFILE)??"",this.Q(c.WORKSPACE)??"")}async optimize(O){return await this.flush(),this.P(O)?.optimize()}async switch(O,y){return this.w(f.NONE),(0,a.$Jl)(O)?this.R(O,y):this.S(O,y)}M(O,y){return!(O.id===y.id||I(y)&&I(O))}N(O,y,i){this.y(()=>{const l=new Set;for(const[n,s]of O)l.add(n),y.get(n)!==s&&this.u(i,{key:n,external:!0});for(const[n]of y.items)l.has(n)||this.u(i,{key:n,external:!0})})}}e.$iq=p;function I(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class b extends p{constructor(){super(),this.U=this.B(new R.$cq(new R.$dq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$cq(new R.$dq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$cq(new R.$dq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(O=>this.u(c.WORKSPACE,O))),this.B(this.W.onDidChangeStorage(O=>this.u(c.PROFILE,O))),this.B(this.U.onDidChangeStorage(O=>this.u(c.APPLICATION,O)))}P(O){switch(O){case c.APPLICATION:return this.U;case c.PROFILE:return this.W;default:return this.X}}Q(O){switch(O){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(O){return!1}}e.$kq=b;async function h(g,O,y,i,l,n){const s=N=>{try{return JSON.parse(N)}catch{return N}},t=new Map,r=new Map;g.forEach((N,M)=>{t.set(M,N),r.set(M,s(N))});const o=new Map,u=new Map;O.forEach((N,M)=>{o.set(M,N),u.set(M,s(N))});const $=new Map,D=new Map;y.forEach((N,M)=>{$.set(M,N),D.set(M,s(N))}),console.group(i!==l?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(t.forEach((N,M)=>{T.push({key:M,value:N})}),console.table(T),console.groupEnd(),console.log(r),i!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const N=[];o.forEach((M,G)=>{N.push({key:G,value:M})}),console.table(N),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${n})`);const A=[];$.forEach((N,M)=>{A.push({key:M,value:N})}),console.table(A),console.groupEnd(),console.log(D)}}),define(le[141],ue([0,1,13,28,73]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=k;async function k(L,R,w){let a=w&&w.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(a)return a;try{const c=(await R.readFile(L.serviceMachineIdResource)).value.toString();a=(0,P.$Yg)(c)?c:null}catch{a=null}if(!a){a=(0,P.$Zg)();try{await R.writeFile(L.serviceMachineIdResource,S.$Me.fromString(a))}catch{}}return w?.store("storage.serviceMachineId",a,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),a}}),define(le[142],ue([0,1,141,18,41]),function(Q,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=k;async function k(L,R,w,a,f,c,m){const d={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${R.nameShort})`};if((0,v.$Cp)(R,w)&&(0,v.$Ep)(a)===P.TelemetryLevel.USAGE){const p=await(0,S.$mq)(w,f,c);d["X-Market-User-Id"]=p,d["VSCode-SessionId"]=m.machineId||p}return d}}),define(le[143],ue([0,1,19,21,7,12,36,3,11,30,17,20,26,22,44,9,6,33,46,142,73,18,155]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g,O,y,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0,e.$oq=ne;const n=k.$p?d.TargetPlatform.WEB:(0,c.$fp)(k.$v,L.$dc),s="X-Market-Search-Activity-Id";var t;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function r(...U){return String(U.reduce((C,H)=>C|H,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},$={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},T={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class A{constructor(C=T){this.d=C}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(C,H=this.d.pageSize){return new A({...this.d,pageNumber:C,pageSize:H})}withFilter(C,...H){const J=[...this.d.criteria,...H.length?H.map(se=>({filterType:C,value:se})):[{filterType:C}]];return new A({...this.d,criteria:J})}withSortBy(C){return new A({...this.d,sortBy:C})}withSortOrder(C){return new A({...this.d,sortOrder:C})}withFlags(...C){return new A({...this.d,flags:C.reduce((H,J)=>H|J,0)})}withAssetTypes(...C){return new A({...this.d,assetTypes:C})}withSource(C){return new A({...this.d,source:C})}get raw(){const{criteria:C,pageNumber:H,pageSize:J,sortBy:se,sortOrder:ae,flags:de,assetTypes:me}=this.d;return{filters:[{criteria:C,pageNumber:H,pageSize:J,sortBy:se,sortOrder:ae}],assetTypes:me,flags:de}}get searchText(){const C=this.d.criteria.filter(H=>H.filterType===o.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(C=>String(C.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(U,C){const H=(U||[]).filter(J=>J.statisticName===C)[0];return H?H.value:0}function M(U){const C="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(J=>J.assetType.indexOf(C)===0).reduce((J,se)=>{const ae=ee(U,se.assetType);return ae&&J.push([se.assetType.substring(C.length),ae]),J},[])}function G(U){if(U.properties){const C=U.properties.filter(se=>se.key===u.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=C.filter(se=>H.test(se.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return ee(U,u.Repository)}function Z(U){return{uri:`${U.fallbackAssetUri}/${u.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${u.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ee(U,C){return U.files.filter(J=>J.assetType===C)[0]?{uri:`${U.assetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function oe(U,C){const H=U.properties?U.properties.filter(se=>se.key===C):[],J=H.length>0&&H[0].value;return J?J.split(",").map(se=>(0,m.$Op)(se)):[]}function ce(U){const C=U.properties?U.properties.filter(H=>H.key===$.Engine):[];return C.length>0&&C[0].value||""}function fe(U){const C=U.properties?U.properties.filter(H=>H.key===$.PreRelease):[];return C.length>0&&C[0].value==="true"}function x(U){const C=U.properties?U.properties.filter(J=>J.key===$.EnabledApiProposals):[],H=C.length>0&&C[0].value||"";return H?H.split(","):[]}function Y(U){const C=U.properties?U.properties.filter(J=>J.key===$.LocalizedLanguages):[],H=C.length>0&&C[0].value||"";return H?H.split(","):[]}function B(U){return U.properties?.find(C=>C.key===$.SponsorLink)?.value}function z(U){return U.properties?.find(C=>C.key===$.SupportLink)?.value}function K(U){return U.indexOf("preview")!==-1}function X(U){return U.targetPlatform?(0,c.$ep)(U.targetPlatform):d.TargetPlatform.UNDEFINED}function te(U){const C=(0,S.$Lb)(U.versions.map(X)),H=!!U.tags?.includes(c.$$o),J=C.indexOf(d.TargetPlatform.WEB);return H?J===-1&&C.push(d.TargetPlatform.WEB):J!==-1&&C.splice(J,1),C}function ne(U,C){for(let H=0;H<U.length;H++){const J=U[H];if(J.version===U[H-1]?.version){let se=H;if(X(J)===C)for(;se>0&&U[se-1].version===J.version;)se--;se!==H&&(U.splice(H,1),U.splice(se,0,J))}}return U}function F(U,C,H){U.telemetryData={index:C,querySource:H,queryActivityId:U.queryContext?.[s]}}function V(U,C,H,J){const se=U.versions[0],ae={manifest:ee(C,u.Manifest),readme:ee(C,u.Details),changelog:ee(C,u.Changelog),license:ee(C,u.License),repository:G(C),download:Z(C),icon:ee(C,u.Icon),signature:ee(C,u.Signature),coreTranslations:M(C)};return{type:"gallery",identifier:{id:(0,m.$Pp)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:C.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(se),description:U.shortDescription??"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:H,assets:ae,properties:{dependencies:oe(C,$.Dependency),extensionPack:oe(C,$.ExtensionPack),engine:ce(C),enabledApiProposals:x(C),localizedLanguages:Y(C),targetPlatform:X(C),isPreReleaseVersion:fe(C)},hasPreReleaseVersion:fe(se),hasReleaseVersion:!0,preview:K(U.flags),isSigned:!!ae.signature,queryContext:J,supportLink:z(se)}}let q=class{constructor(C,H,J,se,ae,de,me,ge){this.l=H,this.n=J,this.o=se,this.q=ae,this.u=de,this.w=me,this.x=ge;const we=me.extensionsGallery,he=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=he?we.servicePPEUrl:we?.serviceUrl,this.g=he?void 0:we?.searchUrl,this.h=we?.controlUrl,this.k=me.extensionsEnabledWithApiProposalVersion?.map(pe=>pe.toLowerCase())??[],this.j=(0,O.$nq)(me.version,me,this.o,this.x,this.u,C,this.q)}y(C=""){return`${this.d}${C}`}isEnabled(){return!!this.d}async getExtensions(C,H,J){const se=P.CancellationToken.isCancellationToken(H)?{}:H,ae=P.CancellationToken.isCancellationToken(H)?H:J,de=[],me=[],ge=[],we=[];let he=!0;for(const Se of C){Se.uuid?me.push(Se.uuid):de.push(Se.id);const W=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:W}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),he=he&&!!Se.hasPreRelease&&!W}if(!me.length&&!de.length)return[];let pe=new A().withPage(1,C.length);me.length&&(pe=pe.withFilter(o.ExtensionId,...me)),de.length&&(pe=pe.withFilter(o.ExtensionName,...de)),(se.queryAllVersions||he)&&(pe=pe.withFlags(pe.flags,t.IncludeVersions)),se.source&&(pe=pe.withSource(se.source));const{extensions:be}=await this.B(pe,{targetPlatform:se.targetPlatform??n,includePreRelease:ge,versions:we,compatible:!!se.compatible,productVersion:se.productVersion??{version:this.w.version,date:this.w.date}},ae);return se.source&&be.forEach((Se,W)=>F(Se,W,se.source)),be}async getCompatibleExtension(C,H,J,se={version:this.w.version,date:this.w.date}){if((0,c.$gp)(C.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(C,H,J))return C;const ae=new A().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,C.identifier.uuid),{extensions:de}=await this.B(ae,{targetPlatform:J,compatible:!0,includePreRelease:H,productVersion:se},P.CancellationToken.None);return de[0]||null}async isExtensionCompatible(C,H,J,se={version:this.w.version,date:this.w.date}){if(!(0,c.$hp)(C.properties.targetPlatform,C.allTargetPlatforms,J)||!H&&C.properties.isPreReleaseVersion)return!1;let ae=C.properties.engine;if(!ae){const de=await this.getManifest(C,P.CancellationToken.None);if(!de)throw new Error("Manifest was not found");ae=de.engines.vscode}return!(!(0,p.$4p)(ae,se.version,se.date)||!this.z(C.identifier,C.properties.enabledApiProposals))}z(C,H){return!H||!this.k.includes(C.id.toLowerCase())?!0:(0,p.$5p)(H)}async A(C,H,J,se,ae,de,me={version:this.w.version,date:this.w.date}){if(!(0,c.$hp)(X(H),ae,de)||J!=="any"&&fe(H)!==(J==="prerelease"))return!1;if(se)try{const ge=await this.G(C,H);if(!(0,p.$4p)(ge,me.version,me.date))return!1}catch(ge){return this.n.error(`Error while getting the engine for the version ${H.version}.`,(0,v.$9)(ge)),!1}return!0}async query(C,H){let J=C.text||"";const se=C.pageSize??50;let ae=new A().withPage(1,se);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,be)=>(ae=ae.withFilter(o.Category,be||pe),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,be)=>(ae=ae.withFilter(o.Tag,be||pe),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(o.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),ae=ae.withFilter(o.SearchText,J)),ae=ae.withSortBy(c.SortBy.NoneOrRelevance)):C.ids?ae=ae.withFilter(o.ExtensionId,...C.ids):C.names?ae=ae.withFilter(o.ExtensionName,...C.names):ae=ae.withSortBy(c.SortBy.InstallCount),typeof C.sortBy=="number"&&(ae=ae.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(ae=ae.withSortOrder(C.sortOrder)),C.source&&(ae=ae.withSource(C.source));const de=async(he,pe)=>{const{extensions:be,total:Se}=await this.B(he,{targetPlatform:n,compatible:!1,includePreRelease:!!C.includePreRelease,productVersion:C.productVersion??{version:this.w.version,date:this.w.date}},pe);return be.forEach((W,_)=>F(W,(he.pageNumber-1)*he.pageSize+_,C.source)),{extensions:be,total:Se}},{extensions:me,total:ge}=await de(ae,H),we=async(he,pe)=>{if(pe.isCancellationRequested)throw new v.$4;const{extensions:be}=await de(ae.withPage(he+1),pe);return be};return{firstPage:me,total:ge,pageSize:ae.pageSize,getPage:we}}async B(C,H,J){const se=C.flags;C.flags&t.IncludeLatestVersionOnly&&C.flags&t.IncludeVersions&&(C=C.withFlags(C.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(C.flags&t.IncludeLatestVersionOnly)&&!(C.flags&t.IncludeVersions)&&(C=C.withFlags(C.flags,t.IncludeLatestVersionOnly)),H.versions?.length&&(C=C.withFlags(C.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),C=C.withFlags(C.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ae,total:de,context:me}=await this.D(C,J);if(!(C.flags&t.IncludeLatestVersionOnly)){const pe=[];for(const be of ae){const Se=await this.C(be,H,me);Se&&pe.push(Se)}return{extensions:pe,total:de}}const we=[],he=new Map;for(let pe=0;pe<ae.length;pe++){const be=ae[pe],Se={id:(0,m.$Pp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},W=(0,R.$jg)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(ie=>(0,m.$Kp)(ie,Se))?.includePreRelease;if(H.compatible&&(0,c.$gp)(te(be),H.targetPlatform))continue;const _=await this.C(be,H,me);!_||_.properties.isPreReleaseVersion&&(!W||!_.hasReleaseVersion)||!_.properties.isPreReleaseVersion&&_.properties.targetPlatform!==H.targetPlatform&&_.hasPreReleaseVersion?he.set(be.extensionId,pe):we.push([pe,_])}if(he.size){const pe=new l.$ee,be=new A().withFlags(se&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,he.size).withFilter(o.ExtensionId,...he.keys()),{extensions:Se}=await this.B(be,H,J);this.q.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:he.size});for(const W of Se){const _=he.get(W.identifier.uuid);we.push([_,W])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:de}}async C(C,H,J){const se={id:(0,m.$Pp)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},ae=H.versions?.find(we=>(0,m.$Kp)(we,se))?.version,de=(0,R.$jg)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(we=>(0,m.$Kp)(we,se))?.includePreRelease,me=te(C),ge=ne(C.versions,H.targetPlatform);if(H.compatible&&(0,c.$gp)(me,H.targetPlatform))return null;for(let we=0;we<ge.length;we++){const he=ge[we];if(!(ae&&he.version!==ae)){if(await this.A(se.id,he,de?"any":"release",H.compatible,me,H.targetPlatform,H.productVersion))return H.compatible&&!this.z(se,x(he))?null:V(C,he,me,J);if(ae&&he.version===ae)return null}}return ae||H.compatible?null:V(C,C.versions[0],me)}async D(C,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,r(t.Unpublished));const J=await this.j,se=JSON.stringify(C.raw),ae={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},de=new l.$ee;let me,ge,we=0;try{if(me=await this.l.request({type:"POST",url:this.g&&C.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:se,headers:ae},H),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:we};const he=await(0,g.$_p)(me);if(he){const pe=he.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(W=>W.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(W=>W.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:me.res.headers.activityid?{[s]:me.res.headers.activityid}:{}}}return{galleryExtensions:[],total:we}}catch(he){if((0,v.$3)(he))throw ge=c.ExtensionGalleryErrorCode.Cancelled,he;{const pe=(0,v.$9)(he);throw ge=pe.startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed,new c.$kp(pe,ge)}}finally{this.q.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(se.length),duration:de.elapsed(),success:!!me&&(0,g.$8p)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(C,H,J,se){if(!this.isEnabled())return;const ae=k.$p?this.y(`/itemName/${C}.${H}/version/${J}/statType/${se===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${C}/extensions/${H}/${J}/stats?statType=${se}`),de=k.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:de};try{await this.l.request({type:"POST",url:ae,headers:ge},P.CancellationToken.None)}catch{}}async download(C,H,J){this.n.trace("ExtensionGalleryService#download",C.identifier.id);const se=(0,m.$Sp)(C),ae=new Date().getTime(),de=J===c.InstallOperation.Install?"install":J===c.InstallOperation.Update?"update":"",me=de?{uri:`${C.assets.download.uri}${w.URI.parse(C.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${C.assets.download.fallbackUri}${w.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:C.assets.download,ge=C.queryContext?.[s]?{[s]:C.queryContext[s]}:void 0,we=await this.F(C.identifier.id,me,u.VSIX,ge?{headers:ge}:void 0);try{await this.u.writeFile(H,we.stream)}catch(he){try{await this.u.del(H)}catch(pe){this.n.warn(`Error while deleting the file ${H.toString()}`,(0,v.$9)(pe))}throw new c.$kp((0,v.$9)(he),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...se,duration:new Date().getTime()-ae})}async downloadSignatureArchive(C,H){if(!C.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const J=await this.F(C.identifier.id,C.assets.signature,u.Signature);try{await this.u.writeFile(H,J.stream)}catch(se){try{await this.u.del(H)}catch(ae){this.n.warn(`Error while deleting the file ${H.toString()}`,(0,v.$9)(ae))}throw new c.$kp((0,v.$9)(se),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(C,H){if(C.assets.readme){const J=await this.F(C.identifier.id,C.assets.readme,u.Details,{},H);return await(0,g.$$p)(J)||""}return""}async getManifest(C,H){if(C.assets.manifest){const J=await this.F(C.identifier.id,C.assets.manifest,u.Manifest,{},H),se=await(0,g.$$p)(J);return se?JSON.parse(se):null}return null}async E(C,H,J){const se=ee(H,u.Manifest);if(!se)throw new Error("Manifest was not found");const ae={"Accept-Encoding":"gzip"},de=await this.F(C,se,u.Manifest,{headers:ae});return await(0,g.$_p)(de)}async getCoreTranslation(C,H){const J=C.assets.coreTranslations.filter(se=>se[0]===H.toUpperCase())[0];if(J){const se=await this.F(C.identifier.id,J[1],J[0]),ae=await(0,g.$$p)(se);return ae?JSON.parse(ae):null}return null}async getChangelog(C,H){if(C.assets.changelog){const J=await this.F(C.identifier.id,C.assets.changelog,u.Changelog,{},H);return await(0,g.$$p)(J)||""}return""}async getAllCompatibleVersions(C,H,J){let se=new A().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);C.uuid?se=se.withFilter(o.ExtensionId,C.uuid):se=se.withFilter(o.ExtensionName,C.id);const{galleryExtensions:ae}=await this.D(se,P.CancellationToken.None);if(!ae.length)return[];const de=te(ae[0]);if((0,c.$gp)(de,J))return[];const me=[];await Promise.all(ae[0].versions.map(async he=>{try{await this.A(C.id,he,H?"any":"release",!0,de,J)&&this.z(C,x(he))&&me.push(he)}catch{}}));const ge=[],we=new Set;for(const he of ne(me,J))we.has(he.version)||(we.add(he.version),ge.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:fe(he)}));return ge}async F(C,H,J,se={},ae=P.CancellationToken.None){const de=await this.j,me={type:"GET"},ge={...de,...se.headers||{}};se={...se,...me,headers:ge};const we=H.uri,he=H.fallbackUri,pe={...se,url:we};try{const be=await this.l.request(pe,ae);if(be.res.statusCode===200)return be;const Se=await(0,g.$$p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,v.$3)(be))throw be;const Se=(0,v.$9)(be);this.q.publicLog2("galleryService:cdnFallback",{extension:C,assetType:J,message:Se});const W={...se,url:he};return this.l.request(W,ae)}}async G(C,H){let J=ce(H);if(!J){this.q.publicLog2("galleryService:engineFallback",{extension:C,version:H.version});const se=await this.E(C,H,P.CancellationToken.None);if(!se)throw new Error("Manifest was not found");J=se.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const C=await this.l.request({type:"GET",url:this.h},P.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,g.$_p)(C),J=[],se={},ae=[],de=[];if(H){for(const me of H.malicious)J.push({id:me});if(H.migrateToPreRelease)for(const[me,ge]of Object.entries(H.migrateToPreRelease))(!ge.engine||(0,p.$4p)(ge.engine,this.w.version,this.w.date))&&(se[me.toLowerCase()]={disallowInstall:!0,extension:{id:ge.id,displayName:ge.displayName,autoMigrate:{storage:!!ge.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[me,ge]of Object.entries(H.deprecated))ge&&(se[me.toLowerCase()]=(0,R.$jg)(ge)?{}:ge);if(H.search)for(const me of H.search)ae.push(me);if(Array.isArray(H.extensionsEnabledWithPreRelease))for(const me of H.extensionsEnabledWithPreRelease)de.push(me.toLowerCase())}return{malicious:J,deprecated:se,search:ae,extensionsEnabledWithPreRelease:de}}};q=ve([re(1,g.$6p),re(2,b.$$j),re(3,f.$Ki),re(4,i.$0l),re(5,I.$$k),re(6,h.$rk),re(7,a.$0i)],q);let E=class extends q{constructor(C,H,J,se,ae,de,me,ge){super(C,H,J,se,ae,de,me,ge)}};e.$pq=E,e.$pq=E=ve([re(0,y.$gq),re(1,g.$6p),re(2,b.$$j),re(3,f.$Ki),re(4,i.$0l),re(5,I.$$k),re(6,h.$rk),re(7,a.$0i)],E);let j=class extends q{constructor(C,H,J,se,ae,de,me){super(void 0,C,H,J,se,ae,de,me)}};e.$qq=j,e.$qq=j=ve([re(0,g.$6p),re(1,b.$$j),re(2,f.$Ki),re(3,i.$0l),re(4,I.$$k),re(5,h.$rk),re(6,a.$0i)],j)}),define(le[144],ue([0,1,11,17,9,6,123,23,24,3,69]),function(Q,e,S,P,v,k,L,R,w,a,f){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$CR=e.$BR=e.$AR=void 0;let d=class extends w.$Nl{static{c=this}static{this.a="profileAssociationsMigration"}constructor(h,g,O,y,i){super(O,y,g,i),this.U=h,this.W=O}O(){return this.U.getItem(c.b,[]).map(g=>({...g,location:(0,a.$dg)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):S.URI.revive(g.location)}))}Q(){const h=this.U.getItem(c.c,{});return this.U.getItem(c.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$AR=d,e.$AR=d=c=ve([re(0,L.$vR),re(1,R.$Il),re(2,P.$Li),re(3,v.$$k),re(4,k.$$j)],d);let p=m=class extends d{constructor(h,g,O,y,i){super(h,g,O,y,i),this.$=h}P(h){h.length?this.$.setItem(m.b,h.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem(m.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(m.c,h):this.$.removeItem(m.c)}Q(){const h="workspaceAndProfileInfo",g=this.$.getItem(h,void 0);if(g){this.$.removeItem(h);const y=g.reduce((i,{workspace:l,profile:n})=>(i[S.URI.revive(l).toString()]=S.URI.revive(n).toString(),i),{});this.$.setItem(m.c,{workspaces:y})}const O=super.Q();return this.$.getItem(m.a,!1)||(this.R(O),this.$.setItem(m.a,!0)),O}};e.$BR=p,e.$BR=p=m=ve([re(0,L.$wR),re(1,R.$Il),re(2,P.$Li),re(3,v.$$k),re(4,k.$$j)],p);let I=class extends p{constructor(h,g,O,y){super(new f.$zR(f.SaveStrategy.IMMEDIATE,g,y,O),h,g,O,y)}async init(){return await this.$.init(),super.init()}};e.$CR=I,e.$CR=I=ve([re(0,R.$Il),re(1,P.$Li),re(2,v.$$k),re(3,k.$$j)],I)}),define(le[145],ue([0,1,121,8,13,7,3,30,17,122,6,46,120,156]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,e.$es=b;let p=class extends c.$7p{constructor(g,O,y,i){super(i),this.m=g,this.n=O,this.r=y,this.s(),this.B(g.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,O){const{f:y,g:i}=this;let l;try{l=await(0,a.$Pm)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$9)(t)))}const n={...process.env,...l},s=g.agent?g.agent:await(0,m.$cs)(g.url||"",n,{proxyUrl:y,strictSSL:i});return g.agent=s,g.strictSSL=i,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>b(g,O))}async resolveProxy(g){}async lookupAuthorization(g){}async lookupKerberosAuthorization(g){try{const O=await new Promise((s,t)=>{Q(["kerberos"],s,t)}).then(ye),y=new URL(g),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${y.hostname}`:`HTTP@${y.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${y}`,`spn:${i}`),"Negotiate "+await(await O.initializeClient(i)).step("")}catch(O){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",O);return}}async loadCertificates(){return(await new Promise((O,y)=>{Q(["@vscode/proxy-agent"],O,y)}).then(ye)).loadSystemCertificates({log:this.r})}};e.$ds=p,e.$ds=p=ve([re(0,R.$0i),re(1,w.$Li),re(2,f.$$j),re(3,f.$_j)],p);async function I(h){return((0,S.parse)(h.url).protocol==="https:"?await new Promise((y,i)=>{Q(["https"],y,i)}).then(ye):await new Promise((y,i)=>{Q(["http"],y,i)}).then(ye)).request}async function b(h,g){return P.Promises.withAsyncBody(async(O,y)=>{const i=(0,S.parse)(h.url),l=h.getRawRequest?h.getRawRequest(h):await I(h),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,L.$jg)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(n.auth=h.user+":"+h.password);const s=l(n,t=>{const r=(0,L.$hg)(h.followRedirects)?h.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)b({...h,url:t.headers.location,followRedirects:r-1},g).then(O,y);else{let o=t;!h.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,d.createGunzip)())),O({res:t,stream:(0,v.$2e)(o)})}});s.on("error",y),h.timeout&&s.setTimeout(h.timeout),h.isChromiumNetwork&&s.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&s.write(h.data),s.end(),g.onCancellationRequested(()=>{s.abort(),y(new k.$4)})})}});var ze=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(le[157],ue([0,1,32,35,8,38,7,2,14,15,12,36,11,30,117,61,119,17,95,143,20,71,124,42,54,138,140,9,107,109,51,105,64,68,126,6,113,39,114,129,33,46,145,69,70,18,128,41,130,131,23,133,24,144,132,139,110,112,5,134,158]),function(Q,e,S,P,v,k,L,R,w,a,f,c,m,d,p,I,b,h,g,O,y,i,l,n,s,t,r,o,u,$,D,T,A,N,M,G,Z,ee,oe,ce,fe,x,Y,B,z,K,X,te,ne,F,V,q,E,j,U,C,H,J,se,ae,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=ge,S=ye(S),ce=ze(ce);class me extends R.$Tc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,pe]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(G.$$j),W=be.get(o.$$k),_=be.get(h.$Li),ie=be.get(E.$Kl);Se.info("CLI main",this.b),this.h(Se),await this.j(_,W,ie,he),await Promise.all(pe.map($e=>{(0,v.$uh)($e.flush(),1e3)}))})}async f(){const he=new A.$Bi,pe={_serviceBrand:void 0,...ce.default};he.set(fe.$rk,pe);const be=new g.$7m(this.b,pe);he.set(h.$Li,be),await Promise.all([this.g(be.appSettingsHome.with({scheme:w.Schemas.file}).fsPath),this.g(be.extensionsPath)].map(Ie=>Ie?S.promises.mkdir(Ie,{recursive:!0}):void 0));const Se=new J.$uR((0,G.$mk)(be),be.logsHome);he.set(G.$_j,Se);const W=this.B(Se.createLogger("cli",{name:(0,se.localize)(12855,null)})),_=[];Se.getLogLevel()===G.LogLevel.Trace&&_.push(new G.$gk(Se.getLogLevel()));const ie=this.B(new H.$ER(W,_));he.set(G.$$j,ie);const $e=this.B(new u.$1q(ie));he.set(o.$$k,$e);const Ee=this.B(new $.$rr(ie));$e.registerProvider(w.Schemas.file,Ee);const Ne=new q.$Ss($e);he.set(V.$Il,Ne);const ke=new B.$yR(B.SaveStrategy.DELAYED,be,ie,$e),Te=new j.$AR(ke,Ne,be,$e,ie);he.set(E.$Kl,Te),$e.registerProvider(w.Schemas.vscodeUserData,new ae.$vhc(w.Schemas.file,Ee,w.Schemas.vscodeUserData,Te,Ne,ie));const Oe=f.$j&&pe.win32RegValueName?this.B(new oe.$thc(ie,pe.win32RegValueName)):be.policyFile?this.B(new Z.$uhc(be.policyFile,$e,ie)):new ee.$to;he.set(ee.$ro,Oe);const Le=this.B(new p.$Vo(Te.defaultProfile.settingsResource,$e,Oe,ie));he.set(d.$0i,Le),await Promise.all([ke.init(),Le.initialize()]);let Me;try{Me=await(0,U.$8gc)(ke,ie)}catch(Ie){Ie.code!=="ENOENT"&&ie.error(Ie)}const Ae=await(0,U.$9gc)(ke,ie),Ce=await(0,U.$0gc)(ke,ie);Te.init(),he.set(V.$Il,new q.$Ss($e));const Fe=new Y.$ds(Le,be,ie,Se);he.set(x.$6p,Fe),he.set(I.$Zo,new D.$Ai(b.$TR,void 0,!0)),he.set(n.$Hq,new D.$Ai(C.$DR,void 0,!0)),he.set(s.$Lq,new D.$Ai(r.$5gc,void 0,!0)),he.set(i.$rq,new D.$Ai(i.$tq,void 0,!0)),he.set(t.$Wq,new D.$Ai(t.$Xq,void 0,!0)),he.set(y.$jp,new D.$Ai(O.$qq,void 0,!0)),he.set(N.$0r,new D.$Ai(M.$_r,void 0,!1));const Ue=[],Pe=(0,te.$Hp)(pe,Le);if((0,te.$Cp)(pe,be)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ue.push(new ne.$sR(Fe,Pe,"monacoworkbench",null,pe.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,z.$tp)((0,P.release)(),(0,P.hostname)(),process.arch,pe.commit,pe.version,Me,Ae,Ce,Pe),piiPaths:(0,te.$Ip)(be)};he.set(K.$0l,new D.$Ai(X.$fs,[Ie],!1))}else he.set(K.$0l,te.$xp);return[new T.$ur(he),Ue]}g(he){if(f.$j){const pe=(0,de.getUNCHost)(he);pe&&(0,de.addUNCHostToAllowlist)(pe)}return he}h(he){(0,L.setUnexpectedErrorHandler)(pe=>{const be=(0,k.$oj)(pe,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",pe=>{(0,L.$X)(pe)||(0,L.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,L.$Y)(pe))}async j(he,pe,be,Se){let W;if(he.args.profile&&(W=be.profiles.find(ie=>ie.name===he.args.profile),!W))throw new Error(`Profile '${he.args.profile}' not found.`);const _=(W??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(l.$uq,new G.$gk(G.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,_);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ie={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:_};return Se.createInstance(l.$uq,new G.$gk(G.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ie,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(l.$uq,new G.$gk(G.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,_);if(this.b["update-extensions"])return Se.createInstance(l.$uq,new G.$gk(G.LogLevel.Info,!1)).updateExtensions(_);if(this.b["locate-extension"])return Se.createInstance(l.$uq,new G.$gk(G.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$Khc)(he.appRoot,he.extensionsPath))}}m(he){return he.map(pe=>/\.vsix$/i.test(pe)?m.URI.file((0,a.$hc)(pe)?pe:(0,a.$ic)((0,c.cwd)(),pe)):pe)}}async function ge(we){const he=new me(we);try{await he.run()}finally{he.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/65a6a2f783dbc87fb3b1408c6a9b3e8d455a60a2/core/vs/code/node/cliProcessMain.js.map
